// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('ajax.core');
goog.require('cljs.core');
goog.require('goog.Uri');
goog.require('cognitect.transit');
goog.require('goog.net.XhrIo');
goog.require('goog.net.XhrManager');
goog.require('goog.Uri.QueryData');
goog.require('goog.net.EventType');
goog.require('goog.events');
goog.require('goog.structs');
goog.require('goog.json.Serializer');
goog.require('clojure.string');
goog.require('cljs.reader');
goog.require('goog.net.ErrorCode');

/**
 * An abstraction for a javascript class that implements
 * Ajax calls.
 * @interface
 */
ajax.core.AjaxImpl = function(){};

/**
 * Makes an actual ajax request.  All parameters except opts
 *   are in JS format.  Should return an AjaxRequest.
 */
ajax.core._js_ajax_request = (function ajax$core$_js_ajax_request(this$,uri,method,body,headers,handler,opts){
if((!((this$ == null))) && (!((this$.ajax$core$AjaxImpl$_js_ajax_request$arity$7 == null)))){
return this$.ajax$core$AjaxImpl$_js_ajax_request$arity$7(this$,uri,method,body,headers,handler,opts);
} else {
var x__5167__auto__ = (((this$ == null))?null:this$);
var m__5168__auto__ = (ajax.core._js_ajax_request[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$7 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$7(this$,uri,method,body,headers,handler,opts) : m__5168__auto__.call(null,this$,uri,method,body,headers,handler,opts));
} else {
var m__5168__auto____$1 = (ajax.core._js_ajax_request["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$7 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$7(this$,uri,method,body,headers,handler,opts) : m__5168__auto____$1.call(null,this$,uri,method,body,headers,handler,opts));
} else {
throw cljs.core.missing_protocol("AjaxImpl.-js-ajax-request",this$);
}
}
}
});


/**
 * An abstraction for a running ajax request.
 * @interface
 */
ajax.core.AjaxRequest = function(){};

/**
 * Aborts a running ajax request, if possible.
 */
ajax.core._abort = (function ajax$core$_abort(this$,error_code){
if((!((this$ == null))) && (!((this$.ajax$core$AjaxRequest$_abort$arity$2 == null)))){
return this$.ajax$core$AjaxRequest$_abort$arity$2(this$,error_code);
} else {
var x__5167__auto__ = (((this$ == null))?null:this$);
var m__5168__auto__ = (ajax.core._abort[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$2(this$,error_code) : m__5168__auto__.call(null,this$,error_code));
} else {
var m__5168__auto____$1 = (ajax.core._abort["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2(this$,error_code) : m__5168__auto____$1.call(null,this$,error_code));
} else {
throw cljs.core.missing_protocol("AjaxRequest.-abort",this$);
}
}
}
});


/**
 * A marker interface for types that can be directly sent to XhrIo
 * @interface
 */
ajax.core.DirectlySubmittable = function(){};

if(typeof FormData !== 'undefined'){
FormData.prototype.ajax$core$DirectlySubmittable$ = true;
} else {
}
ajax.core.submittable_QMARK_ = (function ajax$core$submittable_QMARK_(params){
var or__4512__auto__ = ((!((params == null)))?(((false) || (params.ajax$core$DirectlySubmittable$))?true:(((!params.cljs$lang$protocol_mask$partition$))?cljs.core.native_satisfies_QMARK_(ajax.core.DirectlySubmittable,params):false)):cljs.core.native_satisfies_QMARK_(ajax.core.DirectlySubmittable,params));
if(or__4512__auto__){
return or__4512__auto__;
} else {
return typeof params === 'string';
}
});
(ajax.core.AjaxImpl["null"] = true);

(ajax.core._js_ajax_request["null"] = (function (this$,uri,method,body,headers,handler,p__21018){
var map__21019 = p__21018;
var map__21019__$1 = ((((!((map__21019 == null)))?((((map__21019.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21019.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21019):map__21019);
var timeout = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21019__$1,cljs.core.cst$kw$timeout);
var with_credentials = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__21019__$1,cljs.core.cst$kw$with_DASH_credentials,false);
var G__21021 = (new goog.net.XhrIo());
goog.events.listen(G__21021,goog.net.EventType.COMPLETE,handler);

G__21021.setTimeoutInterval((function (){var or__4512__auto__ = timeout;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return (0);
}
})());

G__21021.setWithCredentials(with_credentials);

G__21021.send(uri,method,body,headers);

return G__21021;
}));
goog.net.XhrIo.prototype.ajax$core$AjaxRequest$ = true;

goog.net.XhrIo.prototype.ajax$core$AjaxRequest$_abort$arity$2 = (function (this$,error_code){
var this$__$1 = this;
return this$__$1.abort(error_code);
});
goog.net.XhrManager.prototype.ajax$core$AjaxImpl$ = true;

goog.net.XhrManager.prototype.ajax$core$AjaxImpl$_js_ajax_request$arity$7 = (function (this$,uri,method,body,headers,handler,p__21022){
var map__21023 = p__21022;
var map__21023__$1 = ((((!((map__21023 == null)))?((((map__21023.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21023.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21023):map__21023);
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21023__$1,cljs.core.cst$kw$id);
var timeout = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21023__$1,cljs.core.cst$kw$timeout);
var priority = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21023__$1,cljs.core.cst$kw$priority);
var max_retries = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21023__$1,cljs.core.cst$kw$max_DASH_retries);
var this$__$1 = this;
return this$__$1.send(id,uri,method,body,headers,priority,handler,max_retries);
});
ajax.core.abort = (function ajax$core$abort(this$){
return ajax.core._abort(this$,goog.net.ErrorCode.ABORT);
});
ajax.core.success_QMARK_ = (function ajax$core$success_QMARK_(status){
return cljs.core.some(cljs.core.PersistentHashSet.fromArray([status], true),new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(200),(201),(202),(204),(205),(206)], null));
});
ajax.core.read_edn = (function ajax$core$read_edn(xhrio){
return cljs.reader.read_string(xhrio.getResponseText());
});
ajax.core.edn_response_format = (function ajax$core$edn_response_format(var_args){
var args21025 = [];
var len__5570__auto___21028 = arguments.length;
var i__5571__auto___21029 = (0);
while(true){
if((i__5571__auto___21029 < len__5570__auto___21028)){
args21025.push((arguments[i__5571__auto___21029]));

var G__21030 = (i__5571__auto___21029 + (1));
i__5571__auto___21029 = G__21030;
continue;
} else {
}
break;
}

var G__21027 = args21025.length;
switch (G__21027) {
case 0:
return ajax.core.edn_response_format.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return ajax.core.edn_response_format.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21025.length)].join('')));

}
});

ajax.core.edn_response_format.cljs$core$IFn$_invoke$arity$0 = (function (){
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$read,ajax.core.read_edn,cljs.core.cst$kw$description,"EDN",cljs.core.cst$kw$content_DASH_type,"application/edn"], null);
});

ajax.core.edn_response_format.cljs$core$IFn$_invoke$arity$1 = (function (opts){
return ajax.core.edn_response_format.cljs$core$IFn$_invoke$arity$0();
});

ajax.core.edn_response_format.cljs$lang$maxFixedArity = 1;
ajax.core.edn_request_format = (function ajax$core$edn_request_format(){
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$write,cljs.core.pr_str,cljs.core.cst$kw$content_DASH_type,"application/edn"], null);
});
ajax.core.transit_content_type = "application/transit+json; charset=utf-8";
ajax.core.transit_write = (function ajax$core$transit_write(var_args){
var args21032 = [];
var len__5570__auto___21035 = arguments.length;
var i__5571__auto___21036 = (0);
while(true){
if((i__5571__auto___21036 < len__5570__auto___21035)){
args21032.push((arguments[i__5571__auto___21036]));

var G__21037 = (i__5571__auto___21036 + (1));
i__5571__auto___21036 = G__21037;
continue;
} else {
}
break;
}

var G__21034 = args21032.length;
switch (G__21034) {
case 2:
return ajax.core.transit_write.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.transit_write.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21032.length)].join('')));

}
});

ajax.core.transit_write.cljs$core$IFn$_invoke$arity$2 = (function (writer,params){
return cognitect.transit.write(writer,params);
});

ajax.core.transit_write.cljs$core$IFn$_invoke$arity$1 = (function (writer){
return (function (params){
return cognitect.transit.write(writer,params);
});
});

ajax.core.transit_write.cljs$lang$maxFixedArity = 2;
ajax.core.transit_request_format = (function ajax$core$transit_request_format(var_args){
var args21039 = [];
var len__5570__auto___21045 = arguments.length;
var i__5571__auto___21046 = (0);
while(true){
if((i__5571__auto___21046 < len__5570__auto___21045)){
args21039.push((arguments[i__5571__auto___21046]));

var G__21047 = (i__5571__auto___21046 + (1));
i__5571__auto___21046 = G__21047;
continue;
} else {
}
break;
}

var G__21041 = args21039.length;
switch (G__21041) {
case 0:
return ajax.core.transit_request_format.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return ajax.core.transit_request_format.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21039.length)].join('')));

}
});

ajax.core.transit_request_format.cljs$core$IFn$_invoke$arity$0 = (function (){
return ajax.core.transit_request_format.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
});

ajax.core.transit_request_format.cljs$core$IFn$_invoke$arity$1 = (function (p__21042){
var map__21043 = p__21042;
var map__21043__$1 = ((((!((map__21043 == null)))?((((map__21043.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21043.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21043):map__21043);
var opts = map__21043__$1;
var type = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21043__$1,cljs.core.cst$kw$type);
var writer = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21043__$1,cljs.core.cst$kw$writer);
var writer__$1 = (function (){var or__4512__auto__ = writer;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return cognitect.transit.writer.cljs$core$IFn$_invoke$arity$2((function (){var or__4512__auto____$1 = type;
if(cljs.core.truth_(or__4512__auto____$1)){
return or__4512__auto____$1;
} else {
return cljs.core.cst$kw$json;
}
})(),opts);
}
})();
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$write,ajax.core.transit_write.cljs$core$IFn$_invoke$arity$1(writer__$1),cljs.core.cst$kw$content_DASH_type,ajax.core.transit_content_type], null);
});

ajax.core.transit_request_format.cljs$lang$maxFixedArity = 1;
ajax.core.transit_read = (function ajax$core$transit_read(var_args){
var args21049 = [];
var len__5570__auto___21052 = arguments.length;
var i__5571__auto___21053 = (0);
while(true){
if((i__5571__auto___21053 < len__5570__auto___21052)){
args21049.push((arguments[i__5571__auto___21053]));

var G__21054 = (i__5571__auto___21053 + (1));
i__5571__auto___21053 = G__21054;
continue;
} else {
}
break;
}

var G__21051 = args21049.length;
switch (G__21051) {
case 3:
return ajax.core.transit_read.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 2:
return ajax.core.transit_read.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.transit_read.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21049.length)].join('')));

}
});

ajax.core.transit_read.cljs$core$IFn$_invoke$arity$3 = (function (reader,raw,xhrio){
var text = xhrio.getResponseText();
var data = cognitect.transit.read(reader,text);
if(cljs.core.truth_(raw)){
return data;
} else {
return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(data);
}
});

ajax.core.transit_read.cljs$core$IFn$_invoke$arity$2 = (function (reader,raw){
return (function (xhrio){
var text = xhrio.getResponseText();
var data = cognitect.transit.read(reader,text);
if(cljs.core.truth_(raw)){
return data;
} else {
return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(data);
}
});
});

ajax.core.transit_read.cljs$core$IFn$_invoke$arity$1 = (function (reader){
return (function (raw,xhrio){
var text = xhrio.getResponseText();
var data = cognitect.transit.read(reader,text);
if(cljs.core.truth_(raw)){
return data;
} else {
return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$1(data);
}
});
});

ajax.core.transit_read.cljs$lang$maxFixedArity = 3;
ajax.core.transit_response_format = (function ajax$core$transit_response_format(var_args){
var args21056 = [];
var len__5570__auto___21062 = arguments.length;
var i__5571__auto___21063 = (0);
while(true){
if((i__5571__auto___21063 < len__5570__auto___21062)){
args21056.push((arguments[i__5571__auto___21063]));

var G__21064 = (i__5571__auto___21063 + (1));
i__5571__auto___21063 = G__21064;
continue;
} else {
}
break;
}

var G__21058 = args21056.length;
switch (G__21058) {
case 0:
return ajax.core.transit_response_format.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return ajax.core.transit_response_format.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21056.length)].join('')));

}
});

ajax.core.transit_response_format.cljs$core$IFn$_invoke$arity$0 = (function (){
return ajax.core.transit_response_format.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
});

ajax.core.transit_response_format.cljs$core$IFn$_invoke$arity$1 = (function (p__21059){
var map__21060 = p__21059;
var map__21060__$1 = ((((!((map__21060 == null)))?((((map__21060.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21060.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21060):map__21060);
var opts = map__21060__$1;
var type = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21060__$1,cljs.core.cst$kw$type);
var reader = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21060__$1,cljs.core.cst$kw$reader);
var raw = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21060__$1,cljs.core.cst$kw$raw);
var reader__$1 = (function (){var or__4512__auto__ = reader;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return cognitect.transit.reader.cljs$core$IFn$_invoke$arity$2((function (){var or__4512__auto____$1 = type;
if(cljs.core.truth_(or__4512__auto____$1)){
return or__4512__auto____$1;
} else {
return cljs.core.cst$kw$json;
}
})(),opts);
}
})();
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$read,ajax.core.transit_read.cljs$core$IFn$_invoke$arity$2(reader__$1,raw),cljs.core.cst$kw$description,"Transit",cljs.core.cst$kw$content_DASH_type,"application/transit+json"], null);
});

ajax.core.transit_response_format.cljs$lang$maxFixedArity = 1;
ajax.core.params_to_str = (function ajax$core$params_to_str(params){
if(cljs.core.truth_(params)){
return (function (){var G__21067 = (new goog.structs.Map(cljs.core.clj__GT_js(params)));
return goog.Uri.QueryData.createFromMap(G__21067);
})().toString();
} else {
return null;
}
});
ajax.core.read_text = (function ajax$core$read_text(xhrio){
return xhrio.getResponseText();
});
ajax.core.url_request_format = (function ajax$core$url_request_format(){
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$write,ajax.core.params_to_str,cljs.core.cst$kw$content_DASH_type,"application/x-www-form-urlencoded"], null);
});
ajax.core.raw_response_format = (function ajax$core$raw_response_format(var_args){
var args21068 = [];
var len__5570__auto___21071 = arguments.length;
var i__5571__auto___21072 = (0);
while(true){
if((i__5571__auto___21072 < len__5570__auto___21071)){
args21068.push((arguments[i__5571__auto___21072]));

var G__21073 = (i__5571__auto___21072 + (1));
i__5571__auto___21072 = G__21073;
continue;
} else {
}
break;
}

var G__21070 = args21068.length;
switch (G__21070) {
case 0:
return ajax.core.raw_response_format.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return ajax.core.raw_response_format.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21068.length)].join('')));

}
});

ajax.core.raw_response_format.cljs$core$IFn$_invoke$arity$0 = (function (){
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$read,ajax.core.read_text,cljs.core.cst$kw$description,"raw text",cljs.core.cst$kw$content_DASH_type,"*/*"], null);
});

ajax.core.raw_response_format.cljs$core$IFn$_invoke$arity$1 = (function (opts){
return ajax.core.raw_response_format.cljs$core$IFn$_invoke$arity$0();
});

ajax.core.raw_response_format.cljs$lang$maxFixedArity = 1;
ajax.core.write_json = (function ajax$core$write_json(data){
return (new goog.json.Serializer()).serialize(cljs.core.clj__GT_js(data));
});
ajax.core.json_request_format = (function ajax$core$json_request_format(){
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$write,ajax.core.write_json,cljs.core.cst$kw$content_DASH_type,"application/json"], null);
});
ajax.core.json_read = (function ajax$core$json_read(var_args){
var args21075 = [];
var len__5570__auto___21078 = arguments.length;
var i__5571__auto___21079 = (0);
while(true){
if((i__5571__auto___21079 < len__5570__auto___21078)){
args21075.push((arguments[i__5571__auto___21079]));

var G__21080 = (i__5571__auto___21079 + (1));
i__5571__auto___21079 = G__21080;
continue;
} else {
}
break;
}

var G__21077 = args21075.length;
switch (G__21077) {
case 4:
return ajax.core.json_read.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 3:
return ajax.core.json_read.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 2:
return ajax.core.json_read.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.json_read.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21075.length)].join('')));

}
});

ajax.core.json_read.cljs$core$IFn$_invoke$arity$4 = (function (prefix,raw,keywords_QMARK_,xhrio){
var json = xhrio.getResponseJson(prefix);
if(cljs.core.truth_(raw)){
return json;
} else {
return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(json,cljs.core.array_seq([cljs.core.cst$kw$keywordize_DASH_keys,keywords_QMARK_], 0));
}
});

ajax.core.json_read.cljs$core$IFn$_invoke$arity$3 = (function (prefix,raw,keywords_QMARK_){
return (function (xhrio){
var json = xhrio.getResponseJson(prefix);
if(cljs.core.truth_(raw)){
return json;
} else {
return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(json,cljs.core.array_seq([cljs.core.cst$kw$keywordize_DASH_keys,keywords_QMARK_], 0));
}
});
});

ajax.core.json_read.cljs$core$IFn$_invoke$arity$2 = (function (prefix,raw){
return (function (keywords_QMARK_,xhrio){
var json = xhrio.getResponseJson(prefix);
if(cljs.core.truth_(raw)){
return json;
} else {
return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(json,cljs.core.array_seq([cljs.core.cst$kw$keywordize_DASH_keys,keywords_QMARK_], 0));
}
});
});

ajax.core.json_read.cljs$core$IFn$_invoke$arity$1 = (function (prefix){
return (function (raw,keywords_QMARK_,xhrio){
var json = xhrio.getResponseJson(prefix);
if(cljs.core.truth_(raw)){
return json;
} else {
return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(json,cljs.core.array_seq([cljs.core.cst$kw$keywordize_DASH_keys,keywords_QMARK_], 0));
}
});
});

ajax.core.json_read.cljs$lang$maxFixedArity = 4;
/**
 * Returns a JSON response format.  Options include
 * :keywords? Returns the keys as keywords
 * :prefix A prefix that needs to be stripped off.  This is to
 * combat JSON hijacking.  If you're using JSON with GET request,
 * you should think about using this.
 * http://stackoverflow.com/questions/2669690/why-does-google-prepend-while1-to-their-json-responses
 * http://haacked.com/archive/2009/06/24/json-hijacking.aspx
 */
ajax.core.json_response_format = (function ajax$core$json_response_format(var_args){
var args21082 = [];
var len__5570__auto___21088 = arguments.length;
var i__5571__auto___21089 = (0);
while(true){
if((i__5571__auto___21089 < len__5570__auto___21088)){
args21082.push((arguments[i__5571__auto___21089]));

var G__21090 = (i__5571__auto___21089 + (1));
i__5571__auto___21089 = G__21090;
continue;
} else {
}
break;
}

var G__21084 = args21082.length;
switch (G__21084) {
case 0:
return ajax.core.json_response_format.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return ajax.core.json_response_format.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21082.length)].join('')));

}
});

ajax.core.json_response_format.cljs$core$IFn$_invoke$arity$0 = (function (){
return ajax.core.json_response_format.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
});

ajax.core.json_response_format.cljs$core$IFn$_invoke$arity$1 = (function (p__21085){
var map__21086 = p__21085;
var map__21086__$1 = ((((!((map__21086 == null)))?((((map__21086.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21086.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21086):map__21086);
var prefix = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21086__$1,cljs.core.cst$kw$prefix);
var keywords_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21086__$1,cljs.core.cst$kw$keywords_QMARK_);
var raw = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21086__$1,cljs.core.cst$kw$raw);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$read,ajax.core.json_read.cljs$core$IFn$_invoke$arity$3(prefix,raw,keywords_QMARK_),cljs.core.cst$kw$description,[cljs.core.str("JSON"),cljs.core.str((cljs.core.truth_(prefix)?[cljs.core.str(" prefix '"),cljs.core.str(prefix),cljs.core.str("'")].join(''):null)),cljs.core.str((cljs.core.truth_(keywords_QMARK_)?" keywordize":null))].join(''),cljs.core.cst$kw$content_DASH_type,"application/json"], null);
});

ajax.core.json_response_format.cljs$lang$maxFixedArity = 1;
ajax.core.default_formats = new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [ajax.core.json_response_format,ajax.core.edn_response_format,ajax.core.transit_response_format,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["text/plain",ajax.core.raw_response_format], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["text/html",ajax.core.raw_response_format], null),ajax.core.raw_response_format], null);
ajax.core.get_format = (function ajax$core$get_format(var_args){
var args21092 = [];
var len__5570__auto___21095 = arguments.length;
var i__5571__auto___21096 = (0);
while(true){
if((i__5571__auto___21096 < len__5570__auto___21095)){
args21092.push((arguments[i__5571__auto___21096]));

var G__21097 = (i__5571__auto___21096 + (1));
i__5571__auto___21096 = G__21097;
continue;
} else {
}
break;
}

var G__21094 = args21092.length;
switch (G__21094) {
case 2:
return ajax.core.get_format.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.get_format.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21092.length)].join('')));

}
});

ajax.core.get_format.cljs$core$IFn$_invoke$arity$2 = (function (opts,format_entry){
if(cljs.core.vector_QMARK_(format_entry)){
return ajax.core.get_format.cljs$core$IFn$_invoke$arity$2(opts,cljs.core.second(format_entry));
} else {
if(cljs.core.map_QMARK_(format_entry)){
return format_entry;
} else {
return (format_entry.cljs$core$IFn$_invoke$arity$1 ? format_entry.cljs$core$IFn$_invoke$arity$1(opts) : format_entry.call(null,opts));

}
}
});

ajax.core.get_format.cljs$core$IFn$_invoke$arity$1 = (function (opts){
return (function (format_entry){
if(cljs.core.vector_QMARK_(format_entry)){
return ajax.core.get_format.cljs$core$IFn$_invoke$arity$2(opts,cljs.core.second(format_entry));
} else {
if(cljs.core.map_QMARK_(format_entry)){
return format_entry;
} else {
return (format_entry.cljs$core$IFn$_invoke$arity$1 ? format_entry.cljs$core$IFn$_invoke$arity$1(opts) : format_entry.call(null,opts));

}
}
});
});

ajax.core.get_format.cljs$lang$maxFixedArity = 2;
ajax.core.accept_entry = (function ajax$core$accept_entry(var_args){
var args21099 = [];
var len__5570__auto___21102 = arguments.length;
var i__5571__auto___21103 = (0);
while(true){
if((i__5571__auto___21103 < len__5570__auto___21102)){
args21099.push((arguments[i__5571__auto___21103]));

var G__21104 = (i__5571__auto___21103 + (1));
i__5571__auto___21103 = G__21104;
continue;
} else {
}
break;
}

var G__21101 = args21099.length;
switch (G__21101) {
case 2:
return ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21099.length)].join('')));

}
});

ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$2 = (function (opts,format_entry){
var or__4512__auto__ = ((cljs.core.vector_QMARK_(format_entry))?cljs.core.first(format_entry):cljs.core.cst$kw$content_DASH_type.cljs$core$IFn$_invoke$arity$1(ajax.core.get_format.cljs$core$IFn$_invoke$arity$2(opts,format_entry)));
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return "*/*";
}
});

ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$1 = (function (opts){
return (function (format_entry){
var or__4512__auto__ = ((cljs.core.vector_QMARK_(format_entry))?cljs.core.first(format_entry):cljs.core.cst$kw$content_DASH_type.cljs$core$IFn$_invoke$arity$1(ajax.core.get_format.cljs$core$IFn$_invoke$arity$2(opts,format_entry)));
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return "*/*";
}
});
});

ajax.core.accept_entry.cljs$lang$maxFixedArity = 2;
ajax.core.detect_content_type = (function ajax$core$detect_content_type(var_args){
var args21106 = [];
var len__5570__auto___21109 = arguments.length;
var i__5571__auto___21110 = (0);
while(true){
if((i__5571__auto___21110 < len__5570__auto___21109)){
args21106.push((arguments[i__5571__auto___21110]));

var G__21111 = (i__5571__auto___21110 + (1));
i__5571__auto___21110 = G__21111;
continue;
} else {
}
break;
}

var G__21108 = args21106.length;
switch (G__21108) {
case 3:
return ajax.core.detect_content_type.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 2:
return ajax.core.detect_content_type.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.detect_content_type.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21106.length)].join('')));

}
});

ajax.core.detect_content_type.cljs$core$IFn$_invoke$arity$3 = (function (content_type,opts,format_entry){
var accept = ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$2(opts,format_entry);
return (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(accept,"*/*")) || ((content_type.indexOf(accept) >= (0)));
});

ajax.core.detect_content_type.cljs$core$IFn$_invoke$arity$2 = (function (content_type,opts){
return (function (format_entry){
var accept = ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$2(opts,format_entry);
return (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(accept,"*/*")) || ((content_type.indexOf(accept) >= (0)));
});
});

ajax.core.detect_content_type.cljs$core$IFn$_invoke$arity$1 = (function (content_type){
return (function (opts,format_entry){
var accept = ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$2(opts,format_entry);
return (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(accept,"*/*")) || ((content_type.indexOf(accept) >= (0)));
});
});

ajax.core.detect_content_type.cljs$lang$maxFixedArity = 3;
ajax.core.get_default_format = (function ajax$core$get_default_format(xhrio,p__21113){
var map__21116 = p__21113;
var map__21116__$1 = ((((!((map__21116 == null)))?((((map__21116.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21116.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21116):map__21116);
var opts = map__21116__$1;
var response_format = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21116__$1,cljs.core.cst$kw$response_DASH_format);
var f = ajax.core.detect_content_type.cljs$core$IFn$_invoke$arity$2((function (){var or__4512__auto__ = xhrio.getResponseHeader("Content-Type");
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return "";
}
})(),opts);
return ajax.core.get_format.cljs$core$IFn$_invoke$arity$2(opts,cljs.core.first(cljs.core.filter.cljs$core$IFn$_invoke$arity$2(f,response_format)));
});
ajax.core.detect_response_format_read = (function ajax$core$detect_response_format_read(var_args){
var args21118 = [];
var len__5570__auto___21121 = arguments.length;
var i__5571__auto___21122 = (0);
while(true){
if((i__5571__auto___21122 < len__5570__auto___21121)){
args21118.push((arguments[i__5571__auto___21122]));

var G__21123 = (i__5571__auto___21122 + (1));
i__5571__auto___21122 = G__21123;
continue;
} else {
}
break;
}

var G__21120 = args21118.length;
switch (G__21120) {
case 2:
return ajax.core.detect_response_format_read.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.detect_response_format_read.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21118.length)].join('')));

}
});

ajax.core.detect_response_format_read.cljs$core$IFn$_invoke$arity$2 = (function (opts,xhrio){
return cljs.core.cst$kw$read.cljs$core$IFn$_invoke$arity$1(ajax.core.get_default_format(xhrio,opts)).call(null,xhrio);
});

ajax.core.detect_response_format_read.cljs$core$IFn$_invoke$arity$1 = (function (opts){
return (function (xhrio){
return cljs.core.cst$kw$read.cljs$core$IFn$_invoke$arity$1(ajax.core.get_default_format(xhrio,opts)).call(null,xhrio);
});
});

ajax.core.detect_response_format_read.cljs$lang$maxFixedArity = 2;
ajax.core.accept_header = (function ajax$core$accept_header(p__21125){
var map__21128 = p__21125;
var map__21128__$1 = ((((!((map__21128 == null)))?((((map__21128.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21128.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21128):map__21128);
var opts = map__21128__$1;
var response_format = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21128__$1,cljs.core.cst$kw$response_DASH_format);
if(cljs.core.vector_QMARK_(response_format)){
return clojure.string.join.cljs$core$IFn$_invoke$arity$2(", ",cljs.core.map.cljs$core$IFn$_invoke$arity$2(ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$1(opts),response_format));
} else {
return ajax.core.accept_entry.cljs$core$IFn$_invoke$arity$2(opts,response_format);
}
});
ajax.core.detect_response_format = (function ajax$core$detect_response_format(var_args){
var args21130 = [];
var len__5570__auto___21133 = arguments.length;
var i__5571__auto___21134 = (0);
while(true){
if((i__5571__auto___21134 < len__5570__auto___21133)){
args21130.push((arguments[i__5571__auto___21134]));

var G__21135 = (i__5571__auto___21134 + (1));
i__5571__auto___21134 = G__21135;
continue;
} else {
}
break;
}

var G__21132 = args21130.length;
switch (G__21132) {
case 0:
return ajax.core.detect_response_format.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return ajax.core.detect_response_format.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21130.length)].join('')));

}
});

ajax.core.detect_response_format.cljs$core$IFn$_invoke$arity$0 = (function (){
return ajax.core.detect_response_format.cljs$core$IFn$_invoke$arity$1(new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$response_DASH_format,ajax.core.default_formats], null));
});

ajax.core.detect_response_format.cljs$core$IFn$_invoke$arity$1 = (function (opts){
var accept = ajax.core.accept_header(opts);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$read,ajax.core.detect_response_format_read.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$format,[cljs.core.str("(from "),cljs.core.str(accept),cljs.core.str(")")].join(''),cljs.core.cst$kw$content_DASH_type,accept], null);
});

ajax.core.detect_response_format.cljs$lang$maxFixedArity = 1;
ajax.core.get_response_format = (function ajax$core$get_response_format(p__21137){
var map__21140 = p__21137;
var map__21140__$1 = ((((!((map__21140 == null)))?((((map__21140.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21140.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21140):map__21140);
var opts = map__21140__$1;
var response_format = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21140__$1,cljs.core.cst$kw$response_DASH_format);
if(cljs.core.vector_QMARK_(response_format)){
return ajax.core.detect_response_format.cljs$core$IFn$_invoke$arity$1(opts);
} else {
if(cljs.core.map_QMARK_(response_format)){
return response_format;
} else {
if(cljs.core.ifn_QMARK_(response_format)){
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$read,response_format,cljs.core.cst$kw$description,"custom",cljs.core.cst$kw$content_DASH_type,"*/*"], null);
} else {
throw (new Error([cljs.core.str("unrecognized response format: "),cljs.core.str(response_format)].join('')));

}
}
}
});
ajax.core.exception_response = (function ajax$core$exception_response(e,status,p__21142,xhrio){
var map__21145 = p__21142;
var map__21145__$1 = ((((!((map__21145 == null)))?((((map__21145.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21145.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21145):map__21145);
var description = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21145__$1,cljs.core.cst$kw$description);
var response = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$status,status,cljs.core.cst$kw$failure,cljs.core.cst$kw$error,cljs.core.cst$kw$response,null], null);
var status_text = [cljs.core.str(e.message),cljs.core.str("  Format should have been "),cljs.core.str(description)].join('');
var parse_error = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(response,cljs.core.cst$kw$status_DASH_text,status_text,cljs.core.array_seq([cljs.core.cst$kw$failure,cljs.core.cst$kw$parse,cljs.core.cst$kw$original_DASH_text,xhrio.getResponseText()], 0));
if(cljs.core.truth_(ajax.core.success_QMARK_(status))){
return parse_error;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(response,cljs.core.cst$kw$status_DASH_text,xhrio.getStatusText(),cljs.core.array_seq([cljs.core.cst$kw$parse_DASH_error,parse_error], 0));
}
});
ajax.core.fail = (function ajax$core$fail(var_args){
var args__5577__auto__ = [];
var len__5570__auto___21151 = arguments.length;
var i__5571__auto___21152 = (0);
while(true){
if((i__5571__auto___21152 < len__5570__auto___21151)){
args__5577__auto__.push((arguments[i__5571__auto___21152]));

var G__21153 = (i__5571__auto___21152 + (1));
i__5571__auto___21152 = G__21153;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((3) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((3)),(0))):null);
return ajax.core.fail.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5578__auto__);
});

ajax.core.fail.cljs$core$IFn$_invoke$arity$variadic = (function (status,status_text,failure,params){
var response = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$status,status,cljs.core.cst$kw$status_DASH_text,status_text,cljs.core.cst$kw$failure,failure], null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [false,cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core.conj,response,cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.vec,cljs.core.partition.cljs$core$IFn$_invoke$arity$2((2),params)))], null);
});

ajax.core.fail.cljs$lang$maxFixedArity = (3);

ajax.core.fail.cljs$lang$applyTo = (function (seq21147){
var G__21148 = cljs.core.first(seq21147);
var seq21147__$1 = cljs.core.next(seq21147);
var G__21149 = cljs.core.first(seq21147__$1);
var seq21147__$2 = cljs.core.next(seq21147__$1);
var G__21150 = cljs.core.first(seq21147__$2);
var seq21147__$3 = cljs.core.next(seq21147__$2);
return ajax.core.fail.cljs$core$IFn$_invoke$arity$variadic(G__21148,G__21149,G__21150,seq21147__$3);
});
ajax.core.interpret_response = (function ajax$core$interpret_response(p__21154,response){
var map__21163 = p__21154;
var map__21163__$1 = ((((!((map__21163 == null)))?((((map__21163.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21163.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21163):map__21163);
var format = map__21163__$1;
var read = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21163__$1,cljs.core.cst$kw$read);
try{var xhrio = response.target;
var status = xhrio.getStatus();
var fail = cljs.core.partial.cljs$core$IFn$_invoke$arity$2(ajax.core.fail,status);
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((-1),status)){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(xhrio.getLastErrorCode(),goog.net.ErrorCode.ABORT)){
return (fail.cljs$core$IFn$_invoke$arity$2 ? fail.cljs$core$IFn$_invoke$arity$2("Request aborted by client.",cljs.core.cst$kw$aborted) : fail.call(null,"Request aborted by client.",cljs.core.cst$kw$aborted));
} else {
return (fail.cljs$core$IFn$_invoke$arity$2 ? fail.cljs$core$IFn$_invoke$arity$2("Request timed out.",cljs.core.cst$kw$timeout) : fail.call(null,"Request timed out.",cljs.core.cst$kw$timeout));
}
} else {
try{var response__$1 = (read.cljs$core$IFn$_invoke$arity$1 ? read.cljs$core$IFn$_invoke$arity$1(xhrio) : read.call(null,xhrio));
if(cljs.core.truth_(ajax.core.success_QMARK_(status))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [true,response__$1], null);
} else {
var G__21167 = xhrio.getStatusText();
var G__21168 = cljs.core.cst$kw$error;
var G__21169 = cljs.core.cst$kw$response;
var G__21170 = response__$1;
return (fail.cljs$core$IFn$_invoke$arity$4 ? fail.cljs$core$IFn$_invoke$arity$4(G__21167,G__21168,G__21169,G__21170) : fail.call(null,G__21167,G__21168,G__21169,G__21170));
}
}catch (e21166){if((e21166 instanceof Object)){
var e = e21166;
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [false,ajax.core.exception_response(e,status,format,xhrio)], null);
} else {
throw e21166;

}
}}
}catch (e21165){if((e21165 instanceof Object)){
var e = e21165;
return ajax.core.fail.cljs$core$IFn$_invoke$arity$variadic((0),e.message,cljs.core.cst$kw$exception,cljs.core.array_seq([cljs.core.cst$kw$exception,e], 0));
} else {
throw e21165;

}
}});
ajax.core.no_format = (function ajax$core$no_format(xhrio){
throw (new Error("No response format was supplied."));
});
ajax.core.uri_with_params = (function ajax$core$uri_with_params(uri,params){
if(cljs.core.truth_(params)){
return [cljs.core.str(uri),cljs.core.str("?"),cljs.core.str(ajax.core.params_to_str(params))].join('');
} else {
return uri;
}
});
ajax.core.get_request_format = (function ajax$core$get_request_format(format){
if(cljs.core.map_QMARK_(format)){
return format;
} else {
if(cljs.core.ifn_QMARK_(format)){
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$write,format,cljs.core.cst$kw$content_DASH_type,"text/plain"], null);
} else {
return null;

}
}
});
ajax.core.normalize_method = (function ajax$core$normalize_method(method){
if((method instanceof cljs.core.Keyword)){
return clojure.string.upper_case(cljs.core.name(method));
} else {
return method;
}
});
ajax.core.process_inputs = (function ajax$core$process_inputs(p__21171,p__21172){
var map__21179 = p__21171;
var map__21179__$1 = ((((!((map__21179 == null)))?((((map__21179.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21179.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21179):map__21179);
var uri = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21179__$1,cljs.core.cst$kw$uri);
var method = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21179__$1,cljs.core.cst$kw$method);
var format = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21179__$1,cljs.core.cst$kw$format);
var params = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21179__$1,cljs.core.cst$kw$params);
var headers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21179__$1,cljs.core.cst$kw$headers);
var map__21180 = p__21172;
var map__21180__$1 = ((((!((map__21180 == null)))?((((map__21180.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21180.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21180):map__21180);
var content_type = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21180__$1,cljs.core.cst$kw$content_DASH_type);
var headers__$1 = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([new cljs.core.PersistentArrayMap(null, 1, ["Accept",content_type], null),(function (){var or__4512__auto__ = headers;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return cljs.core.PersistentArrayMap.EMPTY;
}
})()], 0));
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(ajax.core.normalize_method(method),"GET")){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [ajax.core.uri_with_params(uri,params),null,headers__$1], null);
} else {
var map__21183 = ajax.core.get_request_format(format);
var map__21183__$1 = ((((!((map__21183 == null)))?((((map__21183.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21183.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21183):map__21183);
var write = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21183__$1,cljs.core.cst$kw$write);
var content_type__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21183__$1,cljs.core.cst$kw$content_DASH_type);
var body = ((!((write == null)))?(write.cljs$core$IFn$_invoke$arity$1 ? write.cljs$core$IFn$_invoke$arity$1(params) : write.call(null,params)):(cljs.core.truth_(ajax.core.submittable_QMARK_(params))?params:(function(){throw (new Error([cljs.core.str("unrecognized request format: "),cljs.core.str(format)].join('')))})()
));
var content_type__$2 = (cljs.core.truth_(content_type__$1)?new cljs.core.PersistentArrayMap(null, 1, ["Content-Type",content_type__$1], null):null);
var headers__$2 = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([headers__$1,content_type__$2], 0));
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [uri,body,headers__$2], null);
}
});
ajax.core.js_handler = (function ajax$core$js_handler(var_args){
var args21185 = [];
var len__5570__auto___21188 = arguments.length;
var i__5571__auto___21189 = (0);
while(true){
if((i__5571__auto___21189 < len__5570__auto___21188)){
args21185.push((arguments[i__5571__auto___21189]));

var G__21190 = (i__5571__auto___21189 + (1));
i__5571__auto___21189 = G__21190;
continue;
} else {
}
break;
}

var G__21187 = args21185.length;
switch (G__21187) {
case 3:
return ajax.core.js_handler.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 2:
return ajax.core.js_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.js_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21185.length)].join('')));

}
});

ajax.core.js_handler.cljs$core$IFn$_invoke$arity$3 = (function (response_format,handler,xhrio){
var response = ajax.core.interpret_response(response_format,xhrio);
return (handler.cljs$core$IFn$_invoke$arity$1 ? handler.cljs$core$IFn$_invoke$arity$1(response) : handler.call(null,response));
});

ajax.core.js_handler.cljs$core$IFn$_invoke$arity$2 = (function (response_format,handler){
return (function (xhrio){
var response = ajax.core.interpret_response(response_format,xhrio);
return (handler.cljs$core$IFn$_invoke$arity$1 ? handler.cljs$core$IFn$_invoke$arity$1(response) : handler.call(null,response));
});
});

ajax.core.js_handler.cljs$core$IFn$_invoke$arity$1 = (function (response_format){
return (function (handler,xhrio){
var response = ajax.core.interpret_response(response_format,xhrio);
return (handler.cljs$core$IFn$_invoke$arity$1 ? handler.cljs$core$IFn$_invoke$arity$1(response) : handler.call(null,response));
});
});

ajax.core.js_handler.cljs$lang$maxFixedArity = 3;
ajax.core.base_handler = (function ajax$core$base_handler(response_format,p__21192){
var map__21195 = p__21192;
var map__21195__$1 = ((((!((map__21195 == null)))?((((map__21195.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21195.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21195):map__21195);
var handler = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21195__$1,cljs.core.cst$kw$handler);
if(cljs.core.truth_(handler)){
return ajax.core.js_handler.cljs$core$IFn$_invoke$arity$2(response_format,handler);
} else {
throw (new Error("No ajax handler provided."));
}
});
ajax.core.ajax_request = (function ajax$core$ajax_request(p__21197){
var map__21201 = p__21197;
var map__21201__$1 = ((((!((map__21201 == null)))?((((map__21201.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21201.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21201):map__21201);
var opts = map__21201__$1;
var method = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21201__$1,cljs.core.cst$kw$method);
var manager = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21201__$1,cljs.core.cst$kw$manager);
var response_format = ajax.core.get_response_format(opts);
var method__$1 = ajax.core.normalize_method(method);
var vec__21203 = ajax.core.process_inputs(opts,response_format);
var uri = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21203,(0),null);
var body = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21203,(1),null);
var headers = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21203,(2),null);
var handler = ajax.core.base_handler(response_format,opts);
return ajax.core._js_ajax_request(manager,uri,method__$1,body,cljs.core.clj__GT_js(headers),handler,opts);
});
ajax.core.keyword_request_format = (function ajax$core$keyword_request_format(format,format_params){
if(cljs.core.map_QMARK_(format)){
return format;
} else {
if(cljs.core.fn_QMARK_(format)){
return new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$write,format], null);
} else {
if((format == null)){
return ajax.core.transit_request_format.cljs$core$IFn$_invoke$arity$1(format_params);
} else {
var G__21205 = (((format instanceof cljs.core.Keyword))?format.fqn:null);
switch (G__21205) {
case "transit":
return ajax.core.transit_request_format.cljs$core$IFn$_invoke$arity$1(format_params);

break;
case "json":
return ajax.core.json_request_format();

break;
case "edn":
return ajax.core.edn_request_format();

break;
case "raw":
return ajax.core.url_request_format();

break;
case "url":
return ajax.core.url_request_format();

break;
default:
return null;

}

}
}
}
});
ajax.core.keyword_response_format_2 = (function ajax$core$keyword_response_format_2(format,format_params){
if(cljs.core.vector_QMARK_(format)){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.first(format),ajax$core$keyword_response_format_2(cljs.core.second(format),format_params)], null);
} else {
if(cljs.core.map_QMARK_(format)){
return format;
} else {
if(cljs.core.fn_QMARK_(format)){
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$read,format,cljs.core.cst$kw$description,"custom"], null);
} else {
if((format == null)){
return ajax.core.detect_response_format.cljs$core$IFn$_invoke$arity$0();
} else {
var G__21210 = (((format instanceof cljs.core.Keyword))?format.fqn:null);
switch (G__21210) {
case "transit":
return ajax.core.transit_response_format.cljs$core$IFn$_invoke$arity$1(format_params);

break;
case "json":
return ajax.core.json_response_format.cljs$core$IFn$_invoke$arity$1(format_params);

break;
case "edn":
return ajax.core.edn_response_format.cljs$core$IFn$_invoke$arity$0();

break;
case "raw":
return ajax.core.raw_response_format.cljs$core$IFn$_invoke$arity$0();

break;
case "detect":
return ajax.core.detect_response_format.cljs$core$IFn$_invoke$arity$0();

break;
default:
return null;

}

}
}
}
}
});
ajax.core.keyword_response_format = (function ajax$core$keyword_response_format(format,format_params){
if(cljs.core.vector_QMARK_(format)){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.vector,cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__21212_SHARP_){
return ajax.core.keyword_response_format_2(p1__21212_SHARP_,format_params);
}),format));
} else {
return ajax.core.keyword_response_format_2(format,format_params);
}
});
ajax.core.transform_handler = (function ajax$core$transform_handler(var_args){
var args21213 = [];
var len__5570__auto___21226 = arguments.length;
var i__5571__auto___21227 = (0);
while(true){
if((i__5571__auto___21227 < len__5570__auto___21226)){
args21213.push((arguments[i__5571__auto___21227]));

var G__21228 = (i__5571__auto___21227 + (1));
i__5571__auto___21227 = G__21228;
continue;
} else {
}
break;
}

var G__21215 = args21213.length;
switch (G__21215) {
case 2:
return ajax.core.transform_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return ajax.core.transform_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args21213.length)].join('')));

}
});

ajax.core.transform_handler.cljs$core$IFn$_invoke$arity$2 = (function (p__21216,p__21217){
var map__21218 = p__21216;
var map__21218__$1 = ((((!((map__21218 == null)))?((((map__21218.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21218.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21218):map__21218);
var handler = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21218__$1,cljs.core.cst$kw$handler);
var error_handler = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21218__$1,cljs.core.cst$kw$error_DASH_handler);
var finally$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21218__$1,cljs.core.cst$kw$finally);
var vec__21219 = p__21217;
var ok = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21219,(0),null);
var result = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21219,(1),null);
var temp__4423__auto___21230 = (cljs.core.truth_(ok)?handler:error_handler);
if(cljs.core.truth_(temp__4423__auto___21230)){
var h_21231 = temp__4423__auto___21230;
(h_21231.cljs$core$IFn$_invoke$arity$1 ? h_21231.cljs$core$IFn$_invoke$arity$1(result) : h_21231.call(null,result));
} else {
}

if(cljs.core.fn_QMARK_(finally$)){
return (finally$.cljs$core$IFn$_invoke$arity$0 ? finally$.cljs$core$IFn$_invoke$arity$0() : finally$.call(null));
} else {
return null;
}
});

ajax.core.transform_handler.cljs$core$IFn$_invoke$arity$1 = (function (p__21221){
var map__21222 = p__21221;
var map__21222__$1 = ((((!((map__21222 == null)))?((((map__21222.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21222.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21222):map__21222);
var handler = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21222__$1,cljs.core.cst$kw$handler);
var error_handler = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21222__$1,cljs.core.cst$kw$error_DASH_handler);
var finally$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21222__$1,cljs.core.cst$kw$finally);
return ((function (map__21222,map__21222__$1,handler,error_handler,finally$){
return (function (p__21224){
var vec__21225 = p__21224;
var ok = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21225,(0),null);
var result = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__21225,(1),null);
var temp__4423__auto___21232 = (cljs.core.truth_(ok)?handler:error_handler);
if(cljs.core.truth_(temp__4423__auto___21232)){
var h_21233 = temp__4423__auto___21232;
(h_21233.cljs$core$IFn$_invoke$arity$1 ? h_21233.cljs$core$IFn$_invoke$arity$1(result) : h_21233.call(null,result));
} else {
}

if(cljs.core.fn_QMARK_(finally$)){
return (finally$.cljs$core$IFn$_invoke$arity$0 ? finally$.cljs$core$IFn$_invoke$arity$0() : finally$.call(null));
} else {
return null;
}
});
;})(map__21222,map__21222__$1,handler,error_handler,finally$))
});

ajax.core.transform_handler.cljs$lang$maxFixedArity = 2;
ajax.core.transform_opts = (function ajax$core$transform_opts(p__21234){
var map__21237 = p__21234;
var map__21237__$1 = ((((!((map__21237 == null)))?((((map__21237.cljs$lang$protocol_mask$partition0$ & (64))) || (map__21237.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__21237):map__21237);
var opts = map__21237__$1;
var method = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21237__$1,cljs.core.cst$kw$method);
var format = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21237__$1,cljs.core.cst$kw$format);
var response_format = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21237__$1,cljs.core.cst$kw$response_DASH_format);
var params = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21237__$1,cljs.core.cst$kw$params);

var needs_format = cljs.core.not((function (){var or__4512__auto__ = ajax.core.submittable_QMARK_(params);
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(method,"GET");
}
})());
var rf = (cljs.core.truth_((function (){var or__4512__auto__ = format;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return needs_format;
}
})())?ajax.core.keyword_request_format(format,opts):null);
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.cst$kw$handler,ajax.core.transform_handler.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.array_seq([cljs.core.cst$kw$format,rf,cljs.core.cst$kw$response_DASH_format,ajax.core.keyword_response_format(response_format,opts)], 0));
});
ajax.core.easy_ajax_request = (function ajax$core$easy_ajax_request(uri,method,opts){
return ajax.core.ajax_request(ajax.core.transform_opts(cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.cst$kw$uri,uri,cljs.core.array_seq([cljs.core.cst$kw$method,method], 0))));
});
/**
 * accepts the URI and an optional map of options, options include:
 *      :handler - the handler function for successful operation
 *                 should accept a single parameter which is the
 *                 deserialized response
 *      :error-handler - the handler function for errors, should accept a
 *                       map with keys :status and :status-text
 *      :format - the format for the request
 *      :response-format - the format for the response
 *      :params - a map of parameters that will be sent with the request
 */
ajax.core.GET = (function ajax$core$GET(var_args){
var args__5577__auto__ = [];
var len__5570__auto___21241 = arguments.length;
var i__5571__auto___21242 = (0);
while(true){
if((i__5571__auto___21242 < len__5570__auto___21241)){
args__5577__auto__.push((arguments[i__5571__auto___21242]));

var G__21243 = (i__5571__auto___21242 + (1));
i__5571__auto___21242 = G__21243;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return ajax.core.GET.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

ajax.core.GET.cljs$core$IFn$_invoke$arity$variadic = (function (uri,opts){
var f__7307__auto__ = cljs.core.first(opts);
return ajax.core.easy_ajax_request(uri,"GET",(((f__7307__auto__ instanceof cljs.core.Keyword))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts):f__7307__auto__));
});

ajax.core.GET.cljs$lang$maxFixedArity = (1);

ajax.core.GET.cljs$lang$applyTo = (function (seq21239){
var G__21240 = cljs.core.first(seq21239);
var seq21239__$1 = cljs.core.next(seq21239);
return ajax.core.GET.cljs$core$IFn$_invoke$arity$variadic(G__21240,seq21239__$1);
});
/**
 * accepts the URI and an optional map of options, options include:
 *      :handler - the handler function for successful operation
 *                 should accept a single parameter which is the
 *                 deserialized response
 *      :error-handler - the handler function for errors, should accept a
 *                       map with keys :status and :status-text
 *      :format - the format for the request
 *      :response-format - the format for the response
 *      :params - a map of parameters that will be sent with the request
 */
ajax.core.HEAD = (function ajax$core$HEAD(var_args){
var args__5577__auto__ = [];
var len__5570__auto___21246 = arguments.length;
var i__5571__auto___21247 = (0);
while(true){
if((i__5571__auto___21247 < len__5570__auto___21246)){
args__5577__auto__.push((arguments[i__5571__auto___21247]));

var G__21248 = (i__5571__auto___21247 + (1));
i__5571__auto___21247 = G__21248;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return ajax.core.HEAD.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

ajax.core.HEAD.cljs$core$IFn$_invoke$arity$variadic = (function (uri,opts){
var f__7307__auto__ = cljs.core.first(opts);
return ajax.core.easy_ajax_request(uri,"HEAD",(((f__7307__auto__ instanceof cljs.core.Keyword))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts):f__7307__auto__));
});

ajax.core.HEAD.cljs$lang$maxFixedArity = (1);

ajax.core.HEAD.cljs$lang$applyTo = (function (seq21244){
var G__21245 = cljs.core.first(seq21244);
var seq21244__$1 = cljs.core.next(seq21244);
return ajax.core.HEAD.cljs$core$IFn$_invoke$arity$variadic(G__21245,seq21244__$1);
});
/**
 * accepts the URI and an optional map of options, options include:
 *      :handler - the handler function for successful operation
 *                 should accept a single parameter which is the
 *                 deserialized response
 *      :error-handler - the handler function for errors, should accept a
 *                       map with keys :status and :status-text
 *      :format - the format for the request
 *      :response-format - the format for the response
 *      :params - a map of parameters that will be sent with the request
 */
ajax.core.POST = (function ajax$core$POST(var_args){
var args__5577__auto__ = [];
var len__5570__auto___21251 = arguments.length;
var i__5571__auto___21252 = (0);
while(true){
if((i__5571__auto___21252 < len__5570__auto___21251)){
args__5577__auto__.push((arguments[i__5571__auto___21252]));

var G__21253 = (i__5571__auto___21252 + (1));
i__5571__auto___21252 = G__21253;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return ajax.core.POST.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

ajax.core.POST.cljs$core$IFn$_invoke$arity$variadic = (function (uri,opts){
var f__7307__auto__ = cljs.core.first(opts);
return ajax.core.easy_ajax_request(uri,"POST",(((f__7307__auto__ instanceof cljs.core.Keyword))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts):f__7307__auto__));
});

ajax.core.POST.cljs$lang$maxFixedArity = (1);

ajax.core.POST.cljs$lang$applyTo = (function (seq21249){
var G__21250 = cljs.core.first(seq21249);
var seq21249__$1 = cljs.core.next(seq21249);
return ajax.core.POST.cljs$core$IFn$_invoke$arity$variadic(G__21250,seq21249__$1);
});
/**
 * accepts the URI and an optional map of options, options include:
 *      :handler - the handler function for successful operation
 *                 should accept a single parameter which is the
 *                 deserialized response
 *      :error-handler - the handler function for errors, should accept a
 *                       map with keys :status and :status-text
 *      :format - the format for the request
 *      :response-format - the format for the response
 *      :params - a map of parameters that will be sent with the request
 */
ajax.core.PUT = (function ajax$core$PUT(var_args){
var args__5577__auto__ = [];
var len__5570__auto___21256 = arguments.length;
var i__5571__auto___21257 = (0);
while(true){
if((i__5571__auto___21257 < len__5570__auto___21256)){
args__5577__auto__.push((arguments[i__5571__auto___21257]));

var G__21258 = (i__5571__auto___21257 + (1));
i__5571__auto___21257 = G__21258;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return ajax.core.PUT.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

ajax.core.PUT.cljs$core$IFn$_invoke$arity$variadic = (function (uri,opts){
var f__7307__auto__ = cljs.core.first(opts);
return ajax.core.easy_ajax_request(uri,"PUT",(((f__7307__auto__ instanceof cljs.core.Keyword))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts):f__7307__auto__));
});

ajax.core.PUT.cljs$lang$maxFixedArity = (1);

ajax.core.PUT.cljs$lang$applyTo = (function (seq21254){
var G__21255 = cljs.core.first(seq21254);
var seq21254__$1 = cljs.core.next(seq21254);
return ajax.core.PUT.cljs$core$IFn$_invoke$arity$variadic(G__21255,seq21254__$1);
});
/**
 * accepts the URI and an optional map of options, options include:
 *      :handler - the handler function for successful operation
 *                 should accept a single parameter which is the
 *                 deserialized response
 *      :error-handler - the handler function for errors, should accept a
 *                       map with keys :status and :status-text
 *      :format - the format for the request
 *      :response-format - the format for the response
 *      :params - a map of parameters that will be sent with the request
 */
ajax.core.DELETE = (function ajax$core$DELETE(var_args){
var args__5577__auto__ = [];
var len__5570__auto___21261 = arguments.length;
var i__5571__auto___21262 = (0);
while(true){
if((i__5571__auto___21262 < len__5570__auto___21261)){
args__5577__auto__.push((arguments[i__5571__auto___21262]));

var G__21263 = (i__5571__auto___21262 + (1));
i__5571__auto___21262 = G__21263;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return ajax.core.DELETE.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

ajax.core.DELETE.cljs$core$IFn$_invoke$arity$variadic = (function (uri,opts){
var f__7307__auto__ = cljs.core.first(opts);
return ajax.core.easy_ajax_request(uri,"DELETE",(((f__7307__auto__ instanceof cljs.core.Keyword))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts):f__7307__auto__));
});

ajax.core.DELETE.cljs$lang$maxFixedArity = (1);

ajax.core.DELETE.cljs$lang$applyTo = (function (seq21259){
var G__21260 = cljs.core.first(seq21259);
var seq21259__$1 = cljs.core.next(seq21259);
return ajax.core.DELETE.cljs$core$IFn$_invoke$arity$variadic(G__21260,seq21259__$1);
});
/**
 * accepts the URI and an optional map of options, options include:
 *      :handler - the handler function for successful operation
 *                 should accept a single parameter which is the
 *                 deserialized response
 *      :error-handler - the handler function for errors, should accept a
 *                       map with keys :status and :status-text
 *      :format - the format for the request
 *      :response-format - the format for the response
 *      :params - a map of parameters that will be sent with the request
 */
ajax.core.OPTIONS = (function ajax$core$OPTIONS(var_args){
var args__5577__auto__ = [];
var len__5570__auto___21266 = arguments.length;
var i__5571__auto___21267 = (0);
while(true){
if((i__5571__auto___21267 < len__5570__auto___21266)){
args__5577__auto__.push((arguments[i__5571__auto___21267]));

var G__21268 = (i__5571__auto___21267 + (1));
i__5571__auto___21267 = G__21268;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return ajax.core.OPTIONS.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

ajax.core.OPTIONS.cljs$core$IFn$_invoke$arity$variadic = (function (uri,opts){
var f__7307__auto__ = cljs.core.first(opts);
return ajax.core.easy_ajax_request(uri,"OPTIONS",(((f__7307__auto__ instanceof cljs.core.Keyword))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts):f__7307__auto__));
});

ajax.core.OPTIONS.cljs$lang$maxFixedArity = (1);

ajax.core.OPTIONS.cljs$lang$applyTo = (function (seq21264){
var G__21265 = cljs.core.first(seq21264);
var seq21264__$1 = cljs.core.next(seq21264);
return ajax.core.OPTIONS.cljs$core$IFn$_invoke$arity$variadic(G__21265,seq21264__$1);
});
/**
 * accepts the URI and an optional map of options, options include:
 *      :handler - the handler function for successful operation
 *                 should accept a single parameter which is the
 *                 deserialized response
 *      :error-handler - the handler function for errors, should accept a
 *                       map with keys :status and :status-text
 *      :format - the format for the request
 *      :response-format - the format for the response
 *      :params - a map of parameters that will be sent with the request
 */
ajax.core.TRACE = (function ajax$core$TRACE(var_args){
var args__5577__auto__ = [];
var len__5570__auto___21271 = arguments.length;
var i__5571__auto___21272 = (0);
while(true){
if((i__5571__auto___21272 < len__5570__auto___21271)){
args__5577__auto__.push((arguments[i__5571__auto___21272]));

var G__21273 = (i__5571__auto___21272 + (1));
i__5571__auto___21272 = G__21273;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return ajax.core.TRACE.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

ajax.core.TRACE.cljs$core$IFn$_invoke$arity$variadic = (function (uri,opts){
var f__7307__auto__ = cljs.core.first(opts);
return ajax.core.easy_ajax_request(uri,"TRACE",(((f__7307__auto__ instanceof cljs.core.Keyword))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts):f__7307__auto__));
});

ajax.core.TRACE.cljs$lang$maxFixedArity = (1);

ajax.core.TRACE.cljs$lang$applyTo = (function (seq21269){
var G__21270 = cljs.core.first(seq21269);
var seq21269__$1 = cljs.core.next(seq21269);
return ajax.core.TRACE.cljs$core$IFn$_invoke$arity$variadic(G__21270,seq21269__$1);
});
