// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('om_bootstrap.input');
goog.require('cljs.core');
goog.require('om_bootstrap.types');
goog.require('schema.core');
goog.require('om_bootstrap.util');
goog.require('om_tools.dom');
goog.require('clojure.string');
goog.require('om.core');
om_bootstrap.input.Addons = cljs.core.PersistentArrayMap.fromArray([schema.core.optional_key(cljs.core.cst$kw$addon_DASH_before),schema.core.either.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([schema.core.Str,om_bootstrap.types.Component], 0)),schema.core.optional_key(cljs.core.cst$kw$addon_DASH_after),schema.core.either.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([schema.core.Str,om_bootstrap.types.Component], 0))], true, false);
/**
 * Helps render feedback icons.
 */
om_bootstrap.input.FeedbackIcons = cljs.core.PersistentArrayMap.fromArray([schema.core.optional_key(cljs.core.cst$kw$bs_DASH_style),schema.core.enum$.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["success","warning","error"], 0)),schema.core.optional_key(cljs.core.cst$kw$feedback_QMARK_),schema.core.Bool], true, false);
/**
 * Input fields that match these bad dawgs:
 * https://github.com/react-bootstrap/react-bootstrap/blob/master/src/Input.jsx
 */
om_bootstrap.input.Input = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([om_bootstrap.input.Addons,om_bootstrap.input.FeedbackIcons,cljs.core.PersistentArrayMap.fromArray([schema.core.optional_key(cljs.core.cst$kw$type),schema.core.Str,schema.core.optional_key(cljs.core.cst$kw$label),schema.core.Str,schema.core.optional_key(cljs.core.cst$kw$skip_DASH_form_DASH_group_QMARK_),schema.core.named(schema.core.Bool,"DON'T render a wrapping form group?"),schema.core.optional_key(cljs.core.cst$kw$help),schema.core.Str,schema.core.optional_key(cljs.core.cst$kw$group_DASH_classname),schema.core.Str,schema.core.optional_key(cljs.core.cst$kw$wrapper_DASH_classname),schema.core.Str,schema.core.optional_key(cljs.core.cst$kw$label_DASH_classname),schema.core.Str], true, false)], 0));
om_bootstrap.input.Radio = om_bootstrap.types.bootstrap(cljs.core.PersistentArrayMap.fromArray([cljs.core.cst$kw$label,schema.core.Str,schema.core.optional_key(cljs.core.cst$kw$checked_QMARK_),schema.core.Bool,schema.core.optional_key(cljs.core.cst$kw$inline_QMARK_),schema.core.Bool], true, false));
var ufv___28483 = schema.utils.use_fn_validation;
var output_schema28474_28484 = schema.core.Str;
var input_schema28475_28485 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(cljs.core.PersistentArrayMap.fromArray([schema.core.either.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([schema.core.Str,schema.core.Keyword], 0)),schema.core.Bool], true, false),cljs.core.with_meta(cljs.core.cst$sym$klasses,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.PersistentArrayMap.fromArray([cljs.core.list(cljs.core.cst$sym$s_SLASH_either,cljs.core.cst$sym$s_SLASH_Str,cljs.core.cst$sym$s_SLASH_Keyword),cljs.core.cst$sym$s_SLASH_Bool], true, false)], null)))], null);
var input_checker28476_28486 = schema.core.checker(input_schema28475_28485);
var output_checker28477_28487 = schema.core.checker(output_schema28474_28484);
/**
 * Inputs: [klasses :- {(s/either s/Str s/Keyword) s/Bool}]
 *   Returns: s/Str
 * 
 *   Mimics the class-set behavior from React. Pass in a map of
 *   potential class to Boolean; you'll get back a class string that
 *   represents the final class to apply.
 * 
 *   TODO: Use class-set from om-tools.
 */
om_bootstrap.input.class_set = ((function (ufv___28483,output_schema28474_28484,input_schema28475_28485,input_checker28476_28486,output_checker28477_28487){
return (function om_bootstrap$input$class_set(G__28478){
var validate__8403__auto__ = ufv___28483.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28488 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28478], null);
var temp__4425__auto___28489 = (input_checker28476_28486.cljs$core$IFn$_invoke$arity$1 ? input_checker28476_28486.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28488) : input_checker28476_28486.call(null,args__8404__auto___28488));
if(cljs.core.truth_(temp__4425__auto___28489)){
var error__8405__auto___28490 = temp__4425__auto___28489;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$class_DASH_set,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Str,cljs.core.cst$kw$doc,"Mimics the class-set behavior from React. Pass in a map of\n  potential class to Boolean; you'll get back a class string that\n  represents the final class to apply.\n\n  TODO: Use class-set from om-tools."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28490], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28475_28485,cljs.core.cst$kw$value,args__8404__auto___28488,cljs.core.cst$kw$error,error__8405__auto___28490], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var klasses = G__28478;
while(true){
return clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",cljs.core.mapcat.cljs$core$IFn$_invoke$arity$variadic(((function (validate__8403__auto__,ufv___28483,output_schema28474_28484,input_schema28475_28485,input_checker28476_28486,output_checker28477_28487){
return (function (p__28481){
var vec__28482 = p__28481;
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28482,(0),null);
var keep_QMARK_ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28482,(1),null);
if(cljs.core.truth_(keep_QMARK_)){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.name(k)], null);
} else {
return null;
}
});})(validate__8403__auto__,ufv___28483,output_schema28474_28484,input_schema28475_28485,input_checker28476_28486,output_checker28477_28487))
,cljs.core.array_seq([klasses], 0)));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28491 = (output_checker28477_28487.cljs$core$IFn$_invoke$arity$1 ? output_checker28477_28487.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28477_28487.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28491)){
var error__8405__auto___28492 = temp__4425__auto___28491;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$class_DASH_set,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Str,cljs.core.cst$kw$doc,"Mimics the class-set behavior from React. Pass in a map of\n  potential class to Boolean; you'll get back a class string that\n  represents the final class to apply.\n\n  TODO: Use class-set from om-tools."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28492], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28474_28484,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28492], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28483,output_schema28474_28484,input_schema28475_28485,input_checker28476_28486,output_checker28477_28487))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.class_set),schema.core.make_fn_schema(output_schema28474_28484,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28475_28485], null)));
var ufv___28500 = schema.utils.use_fn_validation;
var output_schema28493_28501 = om_bootstrap.types.Component;
var input_schema28494_28502 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Str,cljs.core.with_meta(cljs.core.cst$sym$glyph_DASH_name,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Str], null)))], null);
var input_checker28495_28503 = schema.core.checker(input_schema28494_28502);
var output_checker28496_28504 = schema.core.checker(output_schema28493_28501);
/**
 * Inputs: [glyph-name :- s/Str]
 *   Returns: t/Component
 * 
 *   To be used with :addon-before or :addon-after.
 */
om_bootstrap.input.glyph = ((function (ufv___28500,output_schema28493_28501,input_schema28494_28502,input_checker28495_28503,output_checker28496_28504){
return (function om_bootstrap$input$glyph(G__28497){
var validate__8403__auto__ = ufv___28500.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28505 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28497], null);
var temp__4425__auto___28506 = (input_checker28495_28503.cljs$core$IFn$_invoke$arity$1 ? input_checker28495_28503.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28505) : input_checker28495_28503.call(null,args__8404__auto___28505));
if(cljs.core.truth_(temp__4425__auto___28506)){
var error__8405__auto___28507 = temp__4425__auto___28506;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$glyph,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"To be used with :addon-before or :addon-after."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28507], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28494_28502,cljs.core.cst$kw$value,args__8404__auto___28505,cljs.core.cst$kw$error,error__8405__auto___28507], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var glyph_name = G__28497;
while(true){
var G__28499 = {"className": om_tools.dom.format_opts([cljs.core.str("glyphicon glyphicon-"),cljs.core.str(glyph_name)].join(''))};
return React.DOM.span(G__28499);
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28508 = (output_checker28496_28504.cljs$core$IFn$_invoke$arity$1 ? output_checker28496_28504.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28496_28504.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28508)){
var error__8405__auto___28509 = temp__4425__auto___28508;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$glyph,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"To be used with :addon-before or :addon-after."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28509], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28493_28501,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28509], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28500,output_schema28493_28501,input_schema28494_28502,input_checker28495_28503,output_checker28496_28504))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.glyph),schema.core.make_fn_schema(output_schema28493_28501,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28494_28502], null)));
var ufv___28529 = schema.utils.use_fn_validation;
var output_schema28510_28530 = om_bootstrap.types.Component;
var input_schema28511_28531 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.FeedbackIcons,cljs.core.cst$sym$arg0)], null);
var input_checker28512_28532 = schema.core.checker(input_schema28511_28531);
var output_checker28513_28533 = schema.core.checker(output_schema28510_28530);
/**
 * Inputs: [{:keys [feedback? bs-style]} :- FeedbackIcons]
 *   Returns: t/Component
 */
om_bootstrap.input.render_icon = ((function (ufv___28529,output_schema28510_28530,input_schema28511_28531,input_checker28512_28532,output_checker28513_28533){
return (function om_bootstrap$input$render_icon(G__28514){
var validate__8403__auto__ = ufv___28529.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28534 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28514], null);
var temp__4425__auto___28535 = (input_checker28512_28532.cljs$core$IFn$_invoke$arity$1 ? input_checker28512_28532.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28534) : input_checker28512_28532.call(null,args__8404__auto___28534));
if(cljs.core.truth_(temp__4425__auto___28535)){
var error__8405__auto___28536 = temp__4425__auto___28535;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_icon,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28536], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28511_28531,cljs.core.cst$kw$value,args__8404__auto___28534,cljs.core.cst$kw$error,error__8405__auto___28536], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__28523 = G__28514;
var map__28524 = G__28523;
var map__28524__$1 = ((((!((map__28524 == null)))?((((map__28524.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28524.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28524):map__28524);
var feedback_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28524__$1,cljs.core.cst$kw$feedback_QMARK_);
var bs_style = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28524__$1,cljs.core.cst$kw$bs_DASH_style);
var G__28523__$1 = G__28523;
while(true){
var map__28526 = G__28523__$1;
var map__28526__$1 = ((((!((map__28526 == null)))?((((map__28526.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28526.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28526):map__28526);
var feedback_QMARK___$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28526__$1,cljs.core.cst$kw$feedback_QMARK_);
var bs_style__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28526__$1,cljs.core.cst$kw$bs_DASH_style);
if(cljs.core.truth_(feedback_QMARK___$1)){
var klasses = new cljs.core.PersistentArrayMap(null, 5, [cljs.core.cst$kw$glyphicon,true,cljs.core.cst$kw$form_DASH_control_DASH_feedback,true,cljs.core.cst$kw$glyphicon_DASH_ok,cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("success",bs_style__$1),cljs.core.cst$kw$glyphicon_DASH_warning_DASH_sign,cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("warning",bs_style__$1),cljs.core.cst$kw$glyphicon_DASH_remove,cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("error",bs_style__$1)], null);
var G__28528 = {"className": om_tools.dom.format_opts(om_bootstrap.input.class_set(klasses))};
return React.DOM.span(G__28528);
} else {
return null;
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28537 = (output_checker28513_28533.cljs$core$IFn$_invoke$arity$1 ? output_checker28513_28533.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28513_28533.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28537)){
var error__8405__auto___28538 = temp__4425__auto___28537;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_icon,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28538], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28510_28530,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28538], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28529,output_schema28510_28530,input_schema28511_28531,input_checker28512_28532,output_checker28513_28533))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.render_icon),schema.core.make_fn_schema(output_schema28510_28530,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28511_28531], null)));
var ufv___28544 = schema.utils.use_fn_validation;
var output_schema28539_28545 = schema.core.Any;
var input_schema28540_28546 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.maybe(schema.core.Str),cljs.core.with_meta(cljs.core.cst$sym$help,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.list(cljs.core.cst$sym$s_SLASH_maybe,cljs.core.cst$sym$s_SLASH_Str)], null)))], null);
var input_checker28541_28547 = schema.core.checker(input_schema28540_28546);
var output_checker28542_28548 = schema.core.checker(output_schema28539_28545);
/**
 * Inputs: [help :- (s/maybe s/Str)]
 */
om_bootstrap.input.render_help = ((function (ufv___28544,output_schema28539_28545,input_schema28540_28546,input_checker28541_28547,output_checker28542_28548){
return (function om_bootstrap$input$render_help(G__28543){
var validate__8403__auto__ = ufv___28544.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28549 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28543], null);
var temp__4425__auto___28550 = (input_checker28541_28547.cljs$core$IFn$_invoke$arity$1 ? input_checker28541_28547.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28549) : input_checker28541_28547.call(null,args__8404__auto___28549));
if(cljs.core.truth_(temp__4425__auto___28550)){
var error__8405__auto___28551 = temp__4425__auto___28550;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_help,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28551], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28540_28546,cljs.core.cst$kw$value,args__8404__auto___28549,cljs.core.cst$kw$error,error__8405__auto___28551], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var help = G__28543;
while(true){
if(cljs.core.truth_(help)){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.span,{"className": "help-block"},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[help],null))));
} else {
return null;
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28552 = (output_checker28542_28548.cljs$core$IFn$_invoke$arity$1 ? output_checker28542_28548.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28542_28548.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28552)){
var error__8405__auto___28553 = temp__4425__auto___28552;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_help,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28553], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28539_28545,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28553], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28544,output_schema28539_28545,input_schema28540_28546,input_checker28541_28547,output_checker28542_28548))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.render_help),schema.core.make_fn_schema(output_schema28539_28545,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28540_28546], null)));
var ufv___28572 = schema.utils.use_fn_validation;
var output_schema28554_28573 = schema.core.Any;
var input_schema28555_28574 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Addons,cljs.core.cst$sym$arg0),schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$items,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Any], null)))], null);
var input_checker28556_28575 = schema.core.checker(input_schema28555_28574);
var output_checker28557_28576 = schema.core.checker(output_schema28554_28573);
/**
 * Inputs: [{:keys [addon-before addon-after]} :- Addons items :- s/Any]
 * 
 *   Items is a vector of render instances.
 */
om_bootstrap.input.render_input_group = ((function (ufv___28572,output_schema28554_28573,input_schema28555_28574,input_checker28556_28575,output_checker28557_28576){
return (function om_bootstrap$input$render_input_group(G__28558,G__28559){
var validate__8403__auto__ = ufv___28572.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28577 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28558,G__28559], null);
var temp__4425__auto___28578 = (input_checker28556_28575.cljs$core$IFn$_invoke$arity$1 ? input_checker28556_28575.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28577) : input_checker28556_28575.call(null,args__8404__auto___28577));
if(cljs.core.truth_(temp__4425__auto___28578)){
var error__8405__auto___28579 = temp__4425__auto___28578;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_input_DASH_group,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"Items is a vector of render instances."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28579], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28555_28574,cljs.core.cst$kw$value,args__8404__auto___28577,cljs.core.cst$kw$error,error__8405__auto___28579], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__28567 = G__28558;
var map__28568 = G__28567;
var map__28568__$1 = ((((!((map__28568 == null)))?((((map__28568.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28568.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28568):map__28568);
var addon_before = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28568__$1,cljs.core.cst$kw$addon_DASH_before);
var addon_after = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28568__$1,cljs.core.cst$kw$addon_DASH_after);
var items = G__28559;
var G__28567__$1 = G__28567;
var items__$1 = items;
while(true){
var map__28570 = G__28567__$1;
var map__28570__$1 = ((((!((map__28570 == null)))?((((map__28570.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28570.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28570):map__28570);
var addon_before__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28570__$1,cljs.core.cst$kw$addon_DASH_before);
var addon_after__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28570__$1,cljs.core.cst$kw$addon_DASH_after);
var items__$2 = items__$1;
if(cljs.core.truth_((function (){var or__4512__auto__ = addon_before__$1;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return addon_after__$1;
}
})())){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.div,{"className": "input-group"},cljs.core.flatten((new cljs.core.PersistentVector(null,3,(5),cljs.core.PersistentVector.EMPTY_NODE,[(cljs.core.truth_(addon_before__$1)?cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.span,{"className": "input-group-addon"},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[addon_before__$1],null)))):null),items__$2,(cljs.core.truth_(addon_after__$1)?cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.span,{"className": "input-group-addon"},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[addon_after__$1],null)))):null)],null))));
} else {
return items__$2;
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28580 = (output_checker28557_28576.cljs$core$IFn$_invoke$arity$1 ? output_checker28557_28576.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28557_28576.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28580)){
var error__8405__auto___28581 = temp__4425__auto___28580;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_input_DASH_group,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"Items is a vector of render instances."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28581], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28554_28573,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28581], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28572,output_schema28554_28573,input_schema28555_28574,input_checker28556_28575,output_checker28557_28576))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.render_input_group),schema.core.make_fn_schema(output_schema28554_28573,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28555_28574], null)));
var ufv___28599 = schema.utils.use_fn_validation;
var output_schema28582_28600 = schema.core.Bool;
var input_schema28583_28601 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Input,cljs.core.cst$sym$arg0)], null);
var input_checker28584_28602 = schema.core.checker(input_schema28583_28601);
var output_checker28585_28603 = schema.core.checker(output_schema28582_28600);
/**
 * Inputs: [{type :type} :- Input]
 *   Returns: s/Bool
 * 
 *   Returns true if the supplied input is of type checkbox or radio,
 *   false otherwise.
 */
om_bootstrap.input.checkbox_or_radio_QMARK_ = ((function (ufv___28599,output_schema28582_28600,input_schema28583_28601,input_checker28584_28602,output_checker28585_28603){
return (function om_bootstrap$input$checkbox_or_radio_QMARK_(G__28586){
var validate__8403__auto__ = ufv___28599.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28604 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28586], null);
var temp__4425__auto___28605 = (input_checker28584_28602.cljs$core$IFn$_invoke$arity$1 ? input_checker28584_28602.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28604) : input_checker28584_28602.call(null,args__8404__auto___28604));
if(cljs.core.truth_(temp__4425__auto___28605)){
var error__8405__auto___28606 = temp__4425__auto___28605;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$checkbox_DASH_or_DASH_radio_QMARK_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool,cljs.core.cst$kw$doc,"Returns true if the supplied input is of type checkbox or radio,\n  false otherwise."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28606], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28583_28601,cljs.core.cst$kw$value,args__8404__auto___28604,cljs.core.cst$kw$error,error__8405__auto___28606], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__28594 = G__28586;
var map__28595 = G__28594;
var map__28595__$1 = ((((!((map__28595 == null)))?((((map__28595.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28595.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28595):map__28595);
var type = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28595__$1,cljs.core.cst$kw$type);
var G__28594__$1 = G__28594;
while(true){
var map__28597 = G__28594__$1;
var map__28597__$1 = ((((!((map__28597 == null)))?((((map__28597.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28597.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28597):map__28597);
var type__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28597__$1,cljs.core.cst$kw$type);
return (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(type__$1,"checkbox")) || (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(type__$1,"radio"));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28607 = (output_checker28585_28603.cljs$core$IFn$_invoke$arity$1 ? output_checker28585_28603.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28585_28603.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28607)){
var error__8405__auto___28608 = temp__4425__auto___28607;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$checkbox_DASH_or_DASH_radio_QMARK_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Bool,cljs.core.cst$kw$doc,"Returns true if the supplied input is of type checkbox or radio,\n  false otherwise."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28608], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28582_28600,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28608], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28599,output_schema28582_28600,input_schema28583_28601,input_checker28584_28602,output_checker28585_28603))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.checkbox_or_radio_QMARK_),schema.core.make_fn_schema(output_schema28582_28600,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28583_28601], null)));
var ufv___28627 = schema.utils.use_fn_validation;
var output_schema28609_28628 = om_bootstrap.types.Component;
var input_schema28610_28629 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Input,cljs.core.cst$sym$arg0),schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$children,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker28611_28630 = schema.core.checker(input_schema28610_28629);
var output_checker28612_28631 = schema.core.checker(output_schema28609_28628);
/**
 * Inputs: [{type :type} :- Input children]
 *   Returns: t/Component
 * 
 *   Wraps this business in a div.
 */
om_bootstrap.input.checkbox_or_radio_wrapper = ((function (ufv___28627,output_schema28609_28628,input_schema28610_28629,input_checker28611_28630,output_checker28612_28631){
return (function om_bootstrap$input$checkbox_or_radio_wrapper(G__28613,G__28614){
var validate__8403__auto__ = ufv___28627.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28632 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28613,G__28614], null);
var temp__4425__auto___28633 = (input_checker28611_28630.cljs$core$IFn$_invoke$arity$1 ? input_checker28611_28630.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28632) : input_checker28611_28630.call(null,args__8404__auto___28632));
if(cljs.core.truth_(temp__4425__auto___28633)){
var error__8405__auto___28634 = temp__4425__auto___28633;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$checkbox_DASH_or_DASH_radio_DASH_wrapper,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Wraps this business in a div."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28634], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28610_28629,cljs.core.cst$kw$value,args__8404__auto___28632,cljs.core.cst$kw$error,error__8405__auto___28634], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__28622 = G__28613;
var map__28623 = G__28622;
var map__28623__$1 = ((((!((map__28623 == null)))?((((map__28623.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28623.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28623):map__28623);
var type = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28623__$1,cljs.core.cst$kw$type);
var children = G__28614;
var G__28622__$1 = G__28622;
var children__$1 = children;
while(true){
var map__28625 = G__28622__$1;
var map__28625__$1 = ((((!((map__28625 == null)))?((((map__28625.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28625.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28625):map__28625);
var type__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28625__$1,cljs.core.cst$kw$type);
var children__$2 = children__$1;
var klasses = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$checkbox,cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("checkbox",type__$1),cljs.core.cst$kw$radio,cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("radio",type__$1)], null);
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.div,{"className": om_tools.dom.format_opts(om_bootstrap.input.class_set(klasses))},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[children__$2],null))));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28635 = (output_checker28612_28631.cljs$core$IFn$_invoke$arity$1 ? output_checker28612_28631.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28612_28631.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28635)){
var error__8405__auto___28636 = temp__4425__auto___28635;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$checkbox_DASH_or_DASH_radio_DASH_wrapper,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Wraps this business in a div."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28636], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28609_28628,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28636], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28627,output_schema28609_28628,input_schema28610_28629,input_checker28611_28630,output_checker28612_28631))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.checkbox_or_radio_wrapper),schema.core.make_fn_schema(output_schema28609_28628,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28610_28629], null)));
var ufv___28656 = schema.utils.use_fn_validation;
var output_schema28637_28657 = schema.core.Any;
var input_schema28638_28658 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Input,cljs.core.with_meta(cljs.core.cst$sym$input,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$Input], null)))], null);
var input_schema28642_28659 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Input,cljs.core.cst$sym$arg0),schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$child,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker28639_28660 = schema.core.checker(input_schema28638_28658);
var output_checker28640_28661 = schema.core.checker(output_schema28637_28657);
var input_checker28643_28662 = schema.core.checker(input_schema28642_28659);
var output_checker28644_28663 = schema.core.checker(output_schema28637_28657);
/**
 * Inputs: ([input :- Input] [{lc :label-classname, label :label, :as input} :- Input child])
 * 
 *   This doesn't handle any control group stuff.
 */
om_bootstrap.input.render_label = ((function (ufv___28656,output_schema28637_28657,input_schema28638_28658,input_schema28642_28659,input_checker28639_28660,output_checker28640_28661,input_checker28643_28662,output_checker28644_28663){
return (function om_bootstrap$input$render_label(var_args){
var args28647 = [];
var len__5570__auto___28664 = arguments.length;
var i__5571__auto___28665 = (0);
while(true){
if((i__5571__auto___28665 < len__5570__auto___28664)){
args28647.push((arguments[i__5571__auto___28665]));

var G__28666 = (i__5571__auto___28665 + (1));
i__5571__auto___28665 = G__28666;
continue;
} else {
}
break;
}

var G__28649 = args28647.length;
switch (G__28649) {
case 1:
return om_bootstrap.input.render_label.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return om_bootstrap.input.render_label.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args28647.length)].join('')));

}
});})(ufv___28656,output_schema28637_28657,input_schema28638_28658,input_schema28642_28659,input_checker28639_28660,output_checker28640_28661,input_checker28643_28662,output_checker28644_28663))
;

om_bootstrap.input.render_label.cljs$core$IFn$_invoke$arity$1 = ((function (ufv___28656,output_schema28637_28657,input_schema28638_28658,input_schema28642_28659,input_checker28639_28660,output_checker28640_28661,input_checker28643_28662,output_checker28644_28663){
return (function (G__28641){
var validate__8403__auto__ = ufv___28656.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28668 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28641], null);
var temp__4425__auto___28669 = (input_checker28639_28660.cljs$core$IFn$_invoke$arity$1 ? input_checker28639_28660.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28668) : input_checker28639_28660.call(null,args__8404__auto___28668));
if(cljs.core.truth_(temp__4425__auto___28669)){
var error__8405__auto___28670 = temp__4425__auto___28669;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_label,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"This doesn't handle any control group stuff."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28670], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28638_28658,cljs.core.cst$kw$value,args__8404__auto___28668,cljs.core.cst$kw$error,error__8405__auto___28670], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var input = G__28641;
while(true){
return om_bootstrap.input.render_label.cljs$core$IFn$_invoke$arity$2(input,null);
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28671 = (output_checker28640_28661.cljs$core$IFn$_invoke$arity$1 ? output_checker28640_28661.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28640_28661.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28671)){
var error__8405__auto___28672 = temp__4425__auto___28671;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_label,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"This doesn't handle any control group stuff."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28672], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28637_28657,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28672], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28656,output_schema28637_28657,input_schema28638_28658,input_schema28642_28659,input_checker28639_28660,output_checker28640_28661,input_checker28643_28662,output_checker28644_28663))
;

om_bootstrap.input.render_label.cljs$core$IFn$_invoke$arity$2 = ((function (ufv___28656,output_schema28637_28657,input_schema28638_28658,input_schema28642_28659,input_checker28639_28660,output_checker28640_28661,input_checker28643_28662,output_checker28644_28663){
return (function (G__28645,G__28646){
var validate__8403__auto__ = ufv___28656.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28673 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28645,G__28646], null);
var temp__4425__auto___28674 = (input_checker28643_28662.cljs$core$IFn$_invoke$arity$1 ? input_checker28643_28662.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28673) : input_checker28643_28662.call(null,args__8404__auto___28673));
if(cljs.core.truth_(temp__4425__auto___28674)){
var error__8405__auto___28675 = temp__4425__auto___28674;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_label,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"This doesn't handle any control group stuff."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28675], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28642_28659,cljs.core.cst$kw$value,args__8404__auto___28673,cljs.core.cst$kw$error,error__8405__auto___28675], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__28651 = G__28645;
var map__28652 = G__28651;
var map__28652__$1 = ((((!((map__28652 == null)))?((((map__28652.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28652.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28652):map__28652);
var input = map__28652__$1;
var lc = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28652__$1,cljs.core.cst$kw$label_DASH_classname);
var label = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28652__$1,cljs.core.cst$kw$label);
var child = G__28646;
var G__28651__$1 = G__28651;
var child__$1 = child;
while(true){
var map__28654 = G__28651__$1;
var map__28654__$1 = ((((!((map__28654 == null)))?((((map__28654.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28654.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28654):map__28654);
var input__$1 = map__28654__$1;
var lc__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28654__$1,cljs.core.cst$kw$label_DASH_classname);
var label__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28654__$1,cljs.core.cst$kw$label);
var child__$2 = child__$1;
var classes = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$control_DASH_label,cljs.core.not(om_bootstrap.input.checkbox_or_radio_QMARK_(input__$1))], null),(cljs.core.truth_(lc__$1)?cljs.core.PersistentArrayMap.fromArray([lc__$1,cljs.core.boolean$(lc__$1)], true, false):null)], 0));
if(cljs.core.truth_(label__$1)){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.label,{"className": om_tools.dom.format_opts(om_bootstrap.input.class_set(classes))},cljs.core.flatten((new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[child__$2,label__$1],null))));
} else {
return child__$2;
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28676 = (output_checker28644_28663.cljs$core$IFn$_invoke$arity$1 ? output_checker28644_28663.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28644_28663.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28676)){
var error__8405__auto___28677 = temp__4425__auto___28676;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_label,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"This doesn't handle any control group stuff."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28677], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28637_28657,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28677], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28656,output_schema28637_28657,input_schema28638_28658,input_schema28642_28659,input_checker28639_28660,output_checker28640_28661,input_checker28643_28662,output_checker28644_28663))
;

om_bootstrap.input.render_label.cljs$lang$maxFixedArity = 2;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.render_label),schema.core.make_fn_schema(output_schema28637_28657,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28638_28658,input_schema28642_28659], null)));
var ufv___28696 = schema.utils.use_fn_validation;
var output_schema28678_28697 = schema.core.Any;
var input_schema28679_28698 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Input,cljs.core.cst$sym$arg0),schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$child,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker28680_28699 = schema.core.checker(input_schema28679_28698);
var output_checker28681_28700 = schema.core.checker(output_schema28678_28697);
/**
 * Inputs: [{wc :wrapper-classname} :- Input child]
 */
om_bootstrap.input.render_wrapper = ((function (ufv___28696,output_schema28678_28697,input_schema28679_28698,input_checker28680_28699,output_checker28681_28700){
return (function om_bootstrap$input$render_wrapper(G__28682,G__28683){
var validate__8403__auto__ = ufv___28696.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28701 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28682,G__28683], null);
var temp__4425__auto___28702 = (input_checker28680_28699.cljs$core$IFn$_invoke$arity$1 ? input_checker28680_28699.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28701) : input_checker28680_28699.call(null,args__8404__auto___28701));
if(cljs.core.truth_(temp__4425__auto___28702)){
var error__8405__auto___28703 = temp__4425__auto___28702;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_wrapper,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28703], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28679_28698,cljs.core.cst$kw$value,args__8404__auto___28701,cljs.core.cst$kw$error,error__8405__auto___28703], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__28691 = G__28682;
var map__28692 = G__28691;
var map__28692__$1 = ((((!((map__28692 == null)))?((((map__28692.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28692.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28692):map__28692);
var wc = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28692__$1,cljs.core.cst$kw$wrapper_DASH_classname);
var child = G__28683;
var G__28691__$1 = G__28691;
var child__$1 = child;
while(true){
var map__28694 = G__28691__$1;
var map__28694__$1 = ((((!((map__28694 == null)))?((((map__28694.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28694.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28694):map__28694);
var wc__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28694__$1,cljs.core.cst$kw$wrapper_DASH_classname);
var child__$2 = child__$1;
if(cljs.core.truth_(wc__$1)){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.div,{"className": om_tools.dom.format_opts(wc__$1)},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[child__$2],null))));
} else {
return child__$2;
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28704 = (output_checker28681_28700.cljs$core$IFn$_invoke$arity$1 ? output_checker28681_28700.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28681_28700.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28704)){
var error__8405__auto___28705 = temp__4425__auto___28704;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_wrapper,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28705], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28678_28697,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28705], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28696,output_schema28678_28697,input_schema28679_28698,input_checker28680_28699,output_checker28681_28700))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.render_wrapper),schema.core.make_fn_schema(output_schema28678_28697,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28679_28698], null)));
var ufv___28724 = schema.utils.use_fn_validation;
var output_schema28706_28725 = om_bootstrap.types.Component;
var input_schema28707_28726 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Input,cljs.core.cst$sym$arg0),schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$children,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker28708_28727 = schema.core.checker(input_schema28707_28726);
var output_checker28709_28728 = schema.core.checker(output_schema28706_28725);
/**
 * Inputs: [{bs-style :bs-style, cn :group-classname, :as input} :- Input children]
 *   Returns: t/Component
 * 
 *   Wraps the entire form group.
 */
om_bootstrap.input.render_form_group = ((function (ufv___28724,output_schema28706_28725,input_schema28707_28726,input_checker28708_28727,output_checker28709_28728){
return (function om_bootstrap$input$render_form_group(G__28710,G__28711){
var validate__8403__auto__ = ufv___28724.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28729 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28710,G__28711], null);
var temp__4425__auto___28730 = (input_checker28708_28727.cljs$core$IFn$_invoke$arity$1 ? input_checker28708_28727.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28729) : input_checker28708_28727.call(null,args__8404__auto___28729));
if(cljs.core.truth_(temp__4425__auto___28730)){
var error__8405__auto___28731 = temp__4425__auto___28730;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_form_DASH_group,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Wraps the entire form group."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28731], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28707_28726,cljs.core.cst$kw$value,args__8404__auto___28729,cljs.core.cst$kw$error,error__8405__auto___28731], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__28719 = G__28710;
var map__28720 = G__28719;
var map__28720__$1 = ((((!((map__28720 == null)))?((((map__28720.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28720.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28720):map__28720);
var input = map__28720__$1;
var bs_style = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28720__$1,cljs.core.cst$kw$bs_DASH_style);
var cn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28720__$1,cljs.core.cst$kw$group_DASH_classname);
var children = G__28711;
var G__28719__$1 = G__28719;
var children__$1 = children;
while(true){
var map__28722 = G__28719__$1;
var map__28722__$1 = ((((!((map__28722 == null)))?((((map__28722.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28722.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28722):map__28722);
var input__$1 = map__28722__$1;
var bs_style__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28722__$1,cljs.core.cst$kw$bs_DASH_style);
var cn__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28722__$1,cljs.core.cst$kw$group_DASH_classname);
var children__$2 = children__$1;
var classes = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([new cljs.core.PersistentArrayMap(null, 5, [cljs.core.cst$kw$form_DASH_group,cljs.core.not(cljs.core.cst$kw$skip_DASH_form_DASH_group_QMARK_.cljs$core$IFn$_invoke$arity$1(input__$1)),cljs.core.cst$kw$has_DASH_feedback,cljs.core.boolean$(cljs.core.cst$kw$feedback_QMARK_.cljs$core$IFn$_invoke$arity$1(input__$1)),cljs.core.cst$kw$has_DASH_success,cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("success",bs_style__$1),cljs.core.cst$kw$has_DASH_warning,cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("warning",bs_style__$1),cljs.core.cst$kw$has_DASH_error,cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("error",bs_style__$1)], null),(cljs.core.truth_(cn__$1)?cljs.core.PersistentArrayMap.fromArray([cn__$1,cljs.core.boolean$(cn__$1)], true, false):null)], 0));
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.div,{"className": om_tools.dom.format_opts(om_bootstrap.input.class_set(classes))},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[children__$2],null))));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28732 = (output_checker28709_28728.cljs$core$IFn$_invoke$arity$1 ? output_checker28709_28728.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28709_28728.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28732)){
var error__8405__auto___28733 = temp__4425__auto___28732;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_form_DASH_group,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Wraps the entire form group."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28733], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28706_28725,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28733], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28724,output_schema28706_28725,input_schema28707_28726,input_checker28708_28727,output_checker28709_28728))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.render_form_group),schema.core.make_fn_schema(output_schema28706_28725,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28707_28726], null)));
var ufv___28743 = schema.utils.use_fn_validation;
var output_schema28734_28744 = om_bootstrap.types.Component;
var input_schema28735_28745 = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Input,cljs.core.with_meta(cljs.core.cst$sym$input,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$Input], null))),schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$attrs,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null))),schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$children,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker28736_28746 = schema.core.checker(input_schema28735_28745);
var output_checker28737_28747 = schema.core.checker(output_schema28734_28744);
/**
 * Inputs: [input :- Input attrs children]
 *   Returns: t/Component
 */
om_bootstrap.input.render_input = ((function (ufv___28743,output_schema28734_28744,input_schema28735_28745,input_checker28736_28746,output_checker28737_28747){
return (function om_bootstrap$input$render_input(G__28738,G__28739,G__28740){
var validate__8403__auto__ = ufv___28743.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28748 = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28738,G__28739,G__28740], null);
var temp__4425__auto___28749 = (input_checker28736_28746.cljs$core$IFn$_invoke$arity$1 ? input_checker28736_28746.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28748) : input_checker28736_28746.call(null,args__8404__auto___28748));
if(cljs.core.truth_(temp__4425__auto___28749)){
var error__8405__auto___28750 = temp__4425__auto___28749;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_input,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28750], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28735_28745,cljs.core.cst$kw$value,args__8404__auto___28748,cljs.core.cst$kw$error,error__8405__auto___28750], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var input = G__28738;
var attrs = G__28739;
var children = G__28740;
while(true){
var props = ((function (validate__8403__auto__,ufv___28743,output_schema28734_28744,input_schema28735_28745,input_checker28736_28746,output_checker28737_28747){
return (function (klass){
return om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([attrs,new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$class,klass,cljs.core.cst$kw$ref,"input",cljs.core.cst$kw$key,"input"], null)], 0));
});})(validate__8403__auto__,ufv___28743,output_schema28734_28744,input_schema28735_28745,input_checker28736_28746,output_checker28737_28747))
;
if(cljs.core.not(cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(input))){
return children;
} else {
var G__28742 = cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(input);
switch (G__28742) {
case "select":
return om_tools.dom.element(React.DOM.select,props("form-control"),(new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[children],null)));

break;
case "textarea":
return om_tools.dom.element(om.dom.textarea,props("form-control"),cljs.core.PersistentVector.EMPTY);

break;
case "static":
return om_tools.dom.element(React.DOM.p,props("form-control-static"),(new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$value.cljs$core$IFn$_invoke$arity$1(attrs)],null)));

break;
default:
return om_tools.dom.element(om.dom.input,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(props((cljs.core.truth_(om_bootstrap.input.checkbox_or_radio_QMARK_(input))?"":"form-control")),cljs.core.cst$kw$type,cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(input)),(new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[children],null)));

}
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28752 = (output_checker28737_28747.cljs$core$IFn$_invoke$arity$1 ? output_checker28737_28747.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28737_28747.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28752)){
var error__8405__auto___28753 = temp__4425__auto___28752;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$render_DASH_input,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28753], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28734_28744,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28753], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28743,output_schema28734_28744,input_schema28735_28745,input_checker28736_28746,output_checker28737_28747))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.render_input),schema.core.make_fn_schema(output_schema28734_28744,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28735_28745], null)));
var ufv___28763 = schema.utils.use_fn_validation;
var output_schema28754_28764 = om_bootstrap.types.Component;
var input_schema28755_28765 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Input,cljs.core.with_meta(cljs.core.cst$sym$opts,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$Input], null))),schema.core.Any], null);
var input_checker28756_28766 = schema.core.checker(input_schema28755_28765);
var output_checker28757_28767 = schema.core.checker(output_schema28754_28764);
/**
 * Inputs: [opts :- Input & children]
 *   Returns: t/Component
 * 
 *   Returns an input component. This currently does NOT handle any of
 *   the default values or validation messages that we'll need to make
 *   this work, though.
 */
om_bootstrap.input.input = ((function (ufv___28763,output_schema28754_28764,input_schema28755_28765,input_checker28756_28766,output_checker28757_28767){
return (function om_bootstrap$input$input(var_args){
var args__5577__auto__ = [];
var len__5570__auto___28768 = arguments.length;
var i__5571__auto___28769 = (0);
while(true){
if((i__5571__auto___28769 < len__5570__auto___28768)){
args__5577__auto__.push((arguments[i__5571__auto___28769]));

var G__28770 = (i__5571__auto___28769 + (1));
i__5571__auto___28769 = G__28770;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return om_bootstrap.input.input.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});})(ufv___28763,output_schema28754_28764,input_schema28755_28765,input_checker28756_28766,output_checker28757_28767))
;

om_bootstrap.input.input.cljs$core$IFn$_invoke$arity$variadic = ((function (ufv___28763,output_schema28754_28764,input_schema28755_28765,input_checker28756_28766,output_checker28757_28767){
return (function (G__28758,rest28759){
var validate__8403__auto__ = ufv___28763.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28771 = cljs.core.list_STAR_.cljs$core$IFn$_invoke$arity$2(G__28758,rest28759);
var temp__4425__auto___28772 = (input_checker28756_28766.cljs$core$IFn$_invoke$arity$1 ? input_checker28756_28766.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28771) : input_checker28756_28766.call(null,args__8404__auto___28771));
if(cljs.core.truth_(temp__4425__auto___28772)){
var error__8405__auto___28773 = temp__4425__auto___28772;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$input,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Returns an input component. This currently does NOT handle any of\n  the default values or validation messages that we'll need to make\n  this work, though."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28773], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28755_28765,cljs.core.cst$kw$value,args__8404__auto___28771,cljs.core.cst$kw$error,error__8405__auto___28773], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var opts = G__28758;
var children = rest28759;
while(true){
var vec__28762 = om_bootstrap.types.separate.cljs$core$IFn$_invoke$arity$2(om_bootstrap.input.Input,opts);
var input = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28762,(0),null);
var attrs = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28762,(1),null);
if(cljs.core.truth_(om_bootstrap.input.checkbox_or_radio_QMARK_(input))){
return om_bootstrap.input.render_form_group(input,om_bootstrap.input.render_wrapper(input,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [om_bootstrap.input.checkbox_or_radio_wrapper(input,om_bootstrap.input.render_label.cljs$core$IFn$_invoke$arity$2(input,om_bootstrap.input.render_input(input,attrs,children))),om_bootstrap.input.render_help(cljs.core.cst$kw$help.cljs$core$IFn$_invoke$arity$1(input))], null)));
} else {
return om_bootstrap.input.render_form_group(input,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [om_bootstrap.input.render_label.cljs$core$IFn$_invoke$arity$1(input),om_bootstrap.input.render_wrapper(input,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [om_bootstrap.input.render_input_group(cljs.core.select_keys(input,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$addon_DASH_before,cljs.core.cst$kw$addon_DASH_after], null)),om_bootstrap.input.render_input(input,attrs,children)),om_bootstrap.input.render_icon(cljs.core.select_keys(input,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$feedback_QMARK_,cljs.core.cst$kw$bs_DASH_style], null))),om_bootstrap.input.render_help(cljs.core.cst$kw$help.cljs$core$IFn$_invoke$arity$1(input))], null))], null));
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28774 = (output_checker28757_28767.cljs$core$IFn$_invoke$arity$1 ? output_checker28757_28767.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28757_28767.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28774)){
var error__8405__auto___28775 = temp__4425__auto___28774;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$input,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Returns an input component. This currently does NOT handle any of\n  the default values or validation messages that we'll need to make\n  this work, though."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28775], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28754_28764,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28775], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28763,output_schema28754_28764,input_schema28755_28765,input_checker28756_28766,output_checker28757_28767))
;

om_bootstrap.input.input.cljs$lang$maxFixedArity = (1);

om_bootstrap.input.input.cljs$lang$applyTo = ((function (ufv___28763,output_schema28754_28764,input_schema28755_28765,input_checker28756_28766,output_checker28757_28767){
return (function (seq28760){
var G__28761 = cljs.core.first(seq28760);
var seq28760__$1 = cljs.core.next(seq28760);
return om_bootstrap.input.input.cljs$core$IFn$_invoke$arity$variadic(G__28761,seq28760__$1);
});})(ufv___28763,output_schema28754_28764,input_schema28755_28765,input_checker28756_28766,output_checker28757_28767))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.input),schema.core.make_fn_schema(output_schema28754_28764,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28755_28765], null)));
var ufv___28787 = schema.utils.use_fn_validation;
var output_schema28776_28788 = om_bootstrap.types.Component;
var input_schema28777_28789 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.input.Radio,cljs.core.with_meta(cljs.core.cst$sym$opts,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$Radio], null)))], null);
var input_checker28778_28790 = schema.core.checker(input_schema28777_28789);
var output_checker28779_28791 = schema.core.checker(output_schema28776_28788);
/**
 * Inputs: [opts :- Radio]
 *   Returns: t/Component
 * 
 *   Generates a radio button entry, to place into a radio button
 * grouping.
 */
om_bootstrap.input.radio_option = ((function (ufv___28787,output_schema28776_28788,input_schema28777_28789,input_checker28778_28790,output_checker28779_28791){
return (function om_bootstrap$input$radio_option(G__28780){
var validate__8403__auto__ = ufv___28787.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28792 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28780], null);
var temp__4425__auto___28793 = (input_checker28778_28790.cljs$core$IFn$_invoke$arity$1 ? input_checker28778_28790.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28792) : input_checker28778_28790.call(null,args__8404__auto___28792));
if(cljs.core.truth_(temp__4425__auto___28793)){
var error__8405__auto___28794 = temp__4425__auto___28793;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$radio_DASH_option,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Generates a radio button entry, to place into a radio button\n   grouping."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28794], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28777_28789,cljs.core.cst$kw$value,args__8404__auto___28792,cljs.core.cst$kw$error,error__8405__auto___28794], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var opts = G__28780;
while(true){
var vec__28784 = om_bootstrap.types.separate.cljs$core$IFn$_invoke$arity$3(om_bootstrap.input.Radio,opts,new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$ref,"input",cljs.core.cst$kw$key,"input",cljs.core.cst$kw$type,"radio"], null));
var bs = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28784,(0),null);
var props = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28784,(1),null);
var map__28785 = bs;
var map__28785__$1 = ((((!((map__28785 == null)))?((((map__28785.cljs$lang$protocol_mask$partition0$ & (64))) || (map__28785.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__28785):map__28785);
var label = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28785__$1,cljs.core.cst$kw$label);
var checked_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28785__$1,cljs.core.cst$kw$checked_QMARK_);
var inline_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__28785__$1,cljs.core.cst$kw$inline_QMARK_);
var core = om_tools.dom.element(om.dom.input,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(props,cljs.core.cst$kw$checked,checked_QMARK_),cljs.core.PersistentVector.EMPTY);
if(cljs.core.truth_(inline_QMARK_)){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.label,{"className": "radio-inline"},cljs.core.flatten((new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[core,label],null))));
} else {
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.div,{"className": "radio"},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.label,{},cljs.core.flatten((new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[core,label],null))))],null))));
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28795 = (output_checker28779_28791.cljs$core$IFn$_invoke$arity$1 ? output_checker28779_28791.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28779_28791.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28795)){
var error__8405__auto___28796 = temp__4425__auto___28795;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$radio_DASH_option,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$t_SLASH_Component,cljs.core.cst$kw$doc,"Generates a radio button entry, to place into a radio button\n   grouping."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28796], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28776_28788,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28796], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28787,output_schema28776_28788,input_schema28777_28789,input_checker28778_28790,output_checker28779_28791))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.radio_option),schema.core.make_fn_schema(output_schema28776_28788,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28777_28789], null)));
var ufv___28823 = schema.utils.use_fn_validation;
var output_schema28797_28824 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [om_bootstrap.types.Component], null);
var input_schema28798_28825 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Str,cljs.core.with_meta(cljs.core.cst$sym$header,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Str], null))),schema.core.one(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.pair(schema.core.Str,"option value",schema.core.Str,"option label")], null),cljs.core.with_meta(cljs.core.cst$sym$opts,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.list(cljs.core.cst$sym$s_SLASH_pair,cljs.core.cst$sym$s_SLASH_Str,"option value",cljs.core.cst$sym$s_SLASH_Str,"option label")], null)], null)))], null);
var input_checker28799_28826 = schema.core.checker(input_schema28798_28825);
var output_checker28800_28827 = schema.core.checker(output_schema28797_28824);
/**
 * Inputs: [header :- s/Str opts :- [(s/pair s/Str "option value" s/Str "option label")]]
 *   Returns: [t/Component]
 * 
 *   Returns a sequence of options for use as the children of a select
 *   input.
 */
om_bootstrap.input.options = ((function (ufv___28823,output_schema28797_28824,input_schema28798_28825,input_checker28799_28826,output_checker28800_28827){
return (function om_bootstrap$input$options(G__28801,G__28802){
var validate__8403__auto__ = ufv___28823.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___28828 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__28801,G__28802], null);
var temp__4425__auto___28829 = (input_checker28799_28826.cljs$core$IFn$_invoke$arity$1 ? input_checker28799_28826.cljs$core$IFn$_invoke$arity$1(args__8404__auto___28828) : input_checker28799_28826.call(null,args__8404__auto___28828));
if(cljs.core.truth_(temp__4425__auto___28829)){
var error__8405__auto___28830 = temp__4425__auto___28829;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$options,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$t_SLASH_Component], null),cljs.core.cst$kw$doc,"Returns a sequence of options for use as the children of a select\n  input."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28830], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema28798_28825,cljs.core.cst$kw$value,args__8404__auto___28828,cljs.core.cst$kw$error,error__8405__auto___28830], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var header = G__28801;
var opts = G__28802;
while(true){
return cljs.core.cons(cljs.core.apply.cljs$core$IFn$_invoke$arity$3(om.dom.option,{"value": ""},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[header],null)))),(function (){var iter__5284__auto__ = ((function (validate__8403__auto__,ufv___28823,output_schema28797_28824,input_schema28798_28825,input_checker28799_28826,output_checker28800_28827){
return (function om_bootstrap$input$options_$_iter__28813(s__28814){
return (new cljs.core.LazySeq(null,((function (validate__8403__auto__,ufv___28823,output_schema28797_28824,input_schema28798_28825,input_checker28799_28826,output_checker28800_28827){
return (function (){
var s__28814__$1 = s__28814;
while(true){
var temp__4425__auto__ = cljs.core.seq(s__28814__$1);
if(temp__4425__auto__){
var s__28814__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_(s__28814__$2)){
var c__5282__auto__ = cljs.core.chunk_first(s__28814__$2);
var size__5283__auto__ = cljs.core.count(c__5282__auto__);
var b__28816 = cljs.core.chunk_buffer(size__5283__auto__);
if((function (){var i__28815 = (0);
while(true){
if((i__28815 < size__5283__auto__)){
var vec__28821 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__5282__auto__,i__28815);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28821,(0),null);
var label = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28821,(1),null);
cljs.core.chunk_append(b__28816,cljs.core.apply.cljs$core$IFn$_invoke$arity$3(om.dom.option,{"value": om_tools.dom.format_opts(v)},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[label],null)))));

var G__28831 = (i__28815 + (1));
i__28815 = G__28831;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__28816),om_bootstrap$input$options_$_iter__28813(cljs.core.chunk_rest(s__28814__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__28816),null);
}
} else {
var vec__28822 = cljs.core.first(s__28814__$2);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28822,(0),null);
var label = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__28822,(1),null);
return cljs.core.cons(cljs.core.apply.cljs$core$IFn$_invoke$arity$3(om.dom.option,{"value": om_tools.dom.format_opts(v)},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[label],null)))),om_bootstrap$input$options_$_iter__28813(cljs.core.rest(s__28814__$2)));
}
} else {
return null;
}
break;
}
});})(validate__8403__auto__,ufv___28823,output_schema28797_28824,input_schema28798_28825,input_checker28799_28826,output_checker28800_28827))
,null,null));
});})(validate__8403__auto__,ufv___28823,output_schema28797_28824,input_schema28798_28825,input_checker28799_28826,output_checker28800_28827))
;
return iter__5284__auto__(opts);
})());
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___28832 = (output_checker28800_28827.cljs$core$IFn$_invoke$arity$1 ? output_checker28800_28827.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker28800_28827.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___28832)){
var error__8405__auto___28833 = temp__4425__auto___28832;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$options,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$t_SLASH_Component], null),cljs.core.cst$kw$doc,"Returns a sequence of options for use as the children of a select\n  input."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___28833], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema28797_28824,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___28833], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___28823,output_schema28797_28824,input_schema28798_28825,input_checker28799_28826,output_checker28800_28827))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.input.options),schema.core.make_fn_schema(output_schema28797_28824,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema28798_28825], null)));
