// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('om_bootstrap.mixins');
goog.require('cljs.core');
goog.require('cljs.core.async');
goog.require('om.core');
goog.require('om_tools.mixin');
goog.require('schema.core');
var ufv___23638 = schema.utils.use_fn_validation;
var output_schema23631_23639 = schema.core.make_fn_schema(schema.core.Any,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.PersistentVector.EMPTY], null));
var input_schema23632_23640 = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$target,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Any], null))),schema.core.one(schema.core.Str,cljs.core.with_meta(cljs.core.cst$sym$event_DASH_type,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$s_SLASH_Str], null))),schema.core.one(schema.core.make_fn_schema(schema.core.Any,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.cst$sym$arg0)], null)], null)),cljs.core.with_meta(cljs.core.cst$sym$callback,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.list(cljs.core.cst$sym$sm_SLASH__EQ__GT_,cljs.core.cst$sym$s_SLASH_Any,cljs.core.cst$sym$s_SLASH_Any)], null)))], null);
var input_checker23633_23641 = schema.core.checker(input_schema23632_23640);
var output_checker23634_23642 = schema.core.checker(output_schema23631_23639);
/**
 * Inputs: [target :- s/Any event-type :- s/Str callback :- (sm/=> s/Any s/Any)]
 *   Returns: (sm/=> s/Any)
 * 
 *   Registers the callback on the supplied target for events of type
 * `event-type`. Returns a function of no arguments that, when called,
 * unregisters the callback.
 */
om_bootstrap.mixins.event_listener = ((function (ufv___23638,output_schema23631_23639,input_schema23632_23640,input_checker23633_23641,output_checker23634_23642){
return (function om_bootstrap$mixins$event_listener(G__23635,G__23636,G__23637){
var validate__8403__auto__ = ufv___23638.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___23643 = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__23635,G__23636,G__23637], null);
var temp__4425__auto___23644 = (input_checker23633_23641.cljs$core$IFn$_invoke$arity$1 ? input_checker23633_23641.cljs$core$IFn$_invoke$arity$1(args__8404__auto___23643) : input_checker23633_23641.call(null,args__8404__auto___23643));
if(cljs.core.truth_(temp__4425__auto___23644)){
var error__8405__auto___23645 = temp__4425__auto___23644;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$event_DASH_listener,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.list(cljs.core.cst$sym$sm_SLASH__EQ__GT_,cljs.core.cst$sym$s_SLASH_Any),cljs.core.cst$kw$doc,"Registers the callback on the supplied target for events of type\n   `event-type`. Returns a function of no arguments that, when called,\n   unregisters the callback."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23645], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema23632_23640,cljs.core.cst$kw$value,args__8404__auto___23643,cljs.core.cst$kw$error,error__8405__auto___23645], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var target = G__23635;
var event_type = G__23636;
var callback = G__23637;
while(true){
if(cljs.core.truth_(target.addEventListener)){
target.addEventListener(event_type,callback,false);

return ((function (validate__8403__auto__,ufv___23638,output_schema23631_23639,input_schema23632_23640,input_checker23633_23641,output_checker23634_23642){
return (function (){
return target.removeEventListener(event_type,callback,false);
});
;})(validate__8403__auto__,ufv___23638,output_schema23631_23639,input_schema23632_23640,input_checker23633_23641,output_checker23634_23642))
} else {
if(cljs.core.truth_(target.attachEvent)){
var event_type__$1 = [cljs.core.str("on"),cljs.core.str(event_type)].join('');
target.attachEvent(event_type__$1,callback);

return ((function (event_type__$1,validate__8403__auto__,ufv___23638,output_schema23631_23639,input_schema23632_23640,input_checker23633_23641,output_checker23634_23642){
return (function (){
return target.detachEvent(event_type__$1,callback);
});
;})(event_type__$1,validate__8403__auto__,ufv___23638,output_schema23631_23639,input_schema23632_23640,input_checker23633_23641,output_checker23634_23642))
} else {
return ((function (validate__8403__auto__,ufv___23638,output_schema23631_23639,input_schema23632_23640,input_checker23633_23641,output_checker23634_23642){
return (function (){
return null;
});
;})(validate__8403__auto__,ufv___23638,output_schema23631_23639,input_schema23632_23640,input_checker23633_23641,output_checker23634_23642))

}
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___23646 = (output_checker23634_23642.cljs$core$IFn$_invoke$arity$1 ? output_checker23634_23642.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker23634_23642.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___23646)){
var error__8405__auto___23647 = temp__4425__auto___23646;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$event_DASH_listener,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.list(cljs.core.cst$sym$sm_SLASH__EQ__GT_,cljs.core.cst$sym$s_SLASH_Any),cljs.core.cst$kw$doc,"Registers the callback on the supplied target for events of type\n   `event-type`. Returns a function of no arguments that, when called,\n   unregisters the callback."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___23647], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema23631_23639,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___23647], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___23638,output_schema23631_23639,input_schema23632_23640,input_checker23633_23641,output_checker23634_23642))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.mixins.event_listener),schema.core.make_fn_schema(output_schema23631_23639,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema23632_23640], null)));
/**
 * Handles a sequence of listeners for the component, and removes them
 * from the document when the component is unmounted.
 */
om_bootstrap.mixins.set_listener_mixin = {"componentWillMount": (function (){
var this23649 = this;
return ((function (this23649){
return (function (owner){
return owner.listeners = [];
});})(this23649))
.call(null,this23649);
}), "componentWillUnmount": (function (){
var this23650 = this;
return ((function (this23650){
return (function (owner){
return owner.listeners.map(((function (this23650){
return (function (p1__23648_SHARP_){
return (p1__23648_SHARP_.cljs$core$IFn$_invoke$arity$0 ? p1__23648_SHARP_.cljs$core$IFn$_invoke$arity$0() : p1__23648_SHARP_.call(null));
});})(this23650))
);
});})(this23650))
.call(null,this23650);
}), "set_listener": (function (target23652,event_type23653,callback23654){
var this23651 = this;
return ((function (this23651){
return (function (owner,target,event_type,callback){
var remove_fn = om_bootstrap.mixins.event_listener(target,event_type,callback);
return owner.listeners.push(remove_fn);
});})(this23651))
.call(null,this23651,target23652,event_type23653,callback23654);
})};
/**
 * Handles a sequence of timeouts for the component, and removes them
 * from the document when the component is unmounted.
 */
om_bootstrap.mixins.set_timeout_mixin = {"componentWillMount": (function (){
var this23656 = this;
return ((function (this23656){
return (function (owner){
return owner.timeouts = [];
});})(this23656))
.call(null,this23656);
}), "componentWillUnmount": (function (){
var this23657 = this;
return ((function (this23657){
return (function (owner){
return owner.timeouts.map(((function (this23657){
return (function (p1__23655_SHARP_){
return clearTimeout(p1__23655_SHARP_);
});})(this23657))
);
});})(this23657))
.call(null,this23657);
}), "set_timeout": (function (f23659,timeout23660){
var this23658 = this;
return ((function (this23658){
return (function (owner,f,timeout){
var timeout__$1 = setTimeout(f,timeout);
return owner.timeouts.push(timeout__$1);
});})(this23658))
.call(null,this23658,f23659,timeout23660);
})};
/**
 * Accepts two DOM elements; returns true if the supplied node is
 *   nested inside the supplied root, false otherwise.
 */
om_bootstrap.mixins.in_root_QMARK_ = (function om_bootstrap$mixins$in_root_QMARK_(node,root){
var node__$1 = node;
while(true){
if((node__$1 == null)){
return false;
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(root,node__$1)){
return true;
} else {
var G__23661 = node__$1.parentNode;
node__$1 = G__23661;
continue;

}
}
break;
}
});
om_bootstrap.mixins.ESCAPE_KEY = (27);
/**
 * For dropdowns, binds a handler for that sets the dropdown-mixin's
 *   `:open?` state to false if the user clicks outside the owning
 *   component OR hits the escape key.
 */
om_bootstrap.mixins.bind_root_close_handlers_BANG_ = (function om_bootstrap$mixins$bind_root_close_handlers_BANG_(owner){
var set_state = (owner["setDropdownState"]);
return owner.dropdownListeners = [om_bootstrap.mixins.event_listener(document,"click",((function (set_state){
return (function (e){
if(cljs.core.truth_(om_bootstrap.mixins.in_root_QMARK_(e.target,om.core.get_node.cljs$core$IFn$_invoke$arity$1(owner)))){
return null;
} else {
return (set_state.cljs$core$IFn$_invoke$arity$1 ? set_state.cljs$core$IFn$_invoke$arity$1(false) : set_state.call(null,false));
}
});})(set_state))
),om_bootstrap.mixins.event_listener(document,"keyup",((function (set_state){
return (function (e){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(om_bootstrap.mixins.ESCAPE_KEY,e.keyCode)){
return (set_state.cljs$core$IFn$_invoke$arity$1 ? set_state.cljs$core$IFn$_invoke$arity$1(false) : set_state.call(null,false));
} else {
return null;
}
});})(set_state))
)];
});
/**
 * If they're present on the owning object, removes the listeners
 *   registered by the dropdown mixin.
 */
om_bootstrap.mixins.unbind_root_close_handlers_BANG_ = (function om_bootstrap$mixins$unbind_root_close_handlers_BANG_(owner){
var temp__4425__auto__ = owner.dropdownListeners;
if(cljs.core.truth_(temp__4425__auto__)){
var listeners = temp__4425__auto__;
cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (listeners,temp__4425__auto__){
return (function (p1__23662_SHARP_){
return (p1__23662_SHARP_.cljs$core$IFn$_invoke$arity$0 ? p1__23662_SHARP_.cljs$core$IFn$_invoke$arity$0() : p1__23662_SHARP_.call(null));
});})(listeners,temp__4425__auto__))
,listeners);

return owner.dropdownListeners = null;
} else {
return null;
}
});
/**
 * Mixin that manages a single piece of state - :open?. If a user
 *   clicks outside the component's owning dom element OR hits the escape
 *   key, the state will jump back to false.
 * 
 *   Down the road this may need to register a callback when the state
 *   changes.
 */
om_bootstrap.mixins.dropdown_mixin = {"getInitialState": (function (){
var this23663 = this;
return ((function (this23663){
return (function (_){
return new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$open_QMARK_,false], null);
});})(this23663))
.call(null,this23663);
}), "componentWillUnmount": (function (){
var this23664 = this;
return ((function (this23664){
return (function (owner){
return om_bootstrap.mixins.unbind_root_close_handlers_BANG_(owner);
});})(this23664))
.call(null,this23664);
}), "isDropdownOpen": (function (){
var this23665 = this;
return ((function (this23665){
return (function (owner){
return om.core.get_state.cljs$core$IFn$_invoke$arity$2(owner,cljs.core.cst$kw$open_QMARK_);
});})(this23665))
.call(null,this23665);
}), "setDropdownState": (function (open_QMARK_23667){
var this23666 = this;
return ((function (this23666){
return (function (owner,open_QMARK_){
if(cljs.core.truth_(open_QMARK_)){
om_bootstrap.mixins.bind_root_close_handlers_BANG_(owner);
} else {
om_bootstrap.mixins.unbind_root_close_handlers_BANG_(owner);
}

return om.core.set_state_BANG_.cljs$core$IFn$_invoke$arity$3(owner,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$open_QMARK_], null),open_QMARK_);
});})(this23666))
.call(null,this23666,open_QMARK_23667);
})};
/**
 * Mixin that enables collapsible Panels. Similar to the Dropdown
 * Mixin it only manages a single piece of state - :collapsed?. The Panel
 * is opened and closen by clicking on the header.
 */
om_bootstrap.mixins.collapsible_mixin = {"getInitialState": (function (){
var this23668 = this;
return ((function (this23668){
return (function (_){
return new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$collapsed_QMARK_,false], null);
});})(this23668))
.call(null,this23668);
}), "isPanelCollapsed": (function (){
var this23669 = this;
return ((function (this23669){
return (function (owner){
return om.core.get_state.cljs$core$IFn$_invoke$arity$2(owner,cljs.core.cst$kw$collapsed_QMARK_);
});})(this23669))
.call(null,this23669);
}), "toggleCollapsed": (function (){
var this23670 = this;
return ((function (this23670){
return (function (owner){
return om.core.update_state_BANG_.cljs$core$IFn$_invoke$arity$3(owner,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$collapsed_QMARK_], null),cljs.core.not);
});})(this23670))
.call(null,this23670);
})};
