// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('om_bootstrap.table');
goog.require('cljs.core');
goog.require('om_bootstrap.types');
goog.require('schema.core');
goog.require('om_bootstrap.util');
goog.require('om_tools.dom');
goog.require('om.core');
om_bootstrap.table.Table = cljs.core.PersistentArrayMap.fromArray([schema.core.optional_key(cljs.core.cst$kw$striped_QMARK_),schema.core.Bool,schema.core.optional_key(cljs.core.cst$kw$bordered_QMARK_),schema.core.Bool,schema.core.optional_key(cljs.core.cst$kw$condensed_QMARK_),schema.core.Bool,schema.core.optional_key(cljs.core.cst$kw$hover_QMARK_),schema.core.Bool,schema.core.optional_key(cljs.core.cst$kw$responsive_QMARK_),schema.core.Bool], true, false);
var ufv___27134 = schema.utils.use_fn_validation;
var output_schema27125_27135 = schema.core.Any;
var input_schema27126_27136 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(om_bootstrap.table.Table,cljs.core.with_meta(cljs.core.cst$sym$opts,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$Table], null))),schema.core.Any], null);
var input_checker27127_27137 = schema.core.checker(input_schema27126_27136);
var output_checker27128_27138 = schema.core.checker(output_schema27125_27135);
/**
 * Inputs: [opts :- Table & children]
 * 
 *   Generates a Bootstrap table wrapper.
 */
om_bootstrap.table.table = ((function (ufv___27134,output_schema27125_27135,input_schema27126_27136,input_checker27127_27137,output_checker27128_27138){
return (function om_bootstrap$table$table(var_args){
var args__5577__auto__ = [];
var len__5570__auto___27139 = arguments.length;
var i__5571__auto___27140 = (0);
while(true){
if((i__5571__auto___27140 < len__5570__auto___27139)){
args__5577__auto__.push((arguments[i__5571__auto___27140]));

var G__27141 = (i__5571__auto___27140 + (1));
i__5571__auto___27140 = G__27141;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return om_bootstrap.table.table.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});})(ufv___27134,output_schema27125_27135,input_schema27126_27136,input_checker27127_27137,output_checker27128_27138))
;

om_bootstrap.table.table.cljs$core$IFn$_invoke$arity$variadic = ((function (ufv___27134,output_schema27125_27135,input_schema27126_27136,input_checker27127_27137,output_checker27128_27138){
return (function (G__27129,rest27130){
var validate__8403__auto__ = ufv___27134.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___27142 = cljs.core.list_STAR_.cljs$core$IFn$_invoke$arity$2(G__27129,rest27130);
var temp__4425__auto___27143 = (input_checker27127_27137.cljs$core$IFn$_invoke$arity$1 ? input_checker27127_27137.cljs$core$IFn$_invoke$arity$1(args__8404__auto___27142) : input_checker27127_27137.call(null,args__8404__auto___27142));
if(cljs.core.truth_(temp__4425__auto___27143)){
var error__8405__auto___27144 = temp__4425__auto___27143;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$table,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"Generates a Bootstrap table wrapper."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___27144], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema27126_27136,cljs.core.cst$kw$value,args__8404__auto___27142,cljs.core.cst$kw$error,error__8405__auto___27144], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var opts = G__27129;
var children = rest27130;
while(true){
var vec__27133 = om_bootstrap.types.separate.cljs$core$IFn$_invoke$arity$2(om_bootstrap.table.Table,opts);
var bs = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__27133,(0),null);
var props = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__27133,(1),null);
var klasses = new cljs.core.PersistentArrayMap(null, 5, [cljs.core.cst$kw$table,true,cljs.core.cst$kw$table_DASH_striped,cljs.core.cst$kw$striped_QMARK_.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$table_DASH_bordered,cljs.core.cst$kw$bordered_QMARK_.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$table_DASH_condensed,cljs.core.cst$kw$condensed_QMARK_.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$table_DASH_hover,cljs.core.cst$kw$hover_QMARK_.cljs$core$IFn$_invoke$arity$1(opts)], null);
var props__$1 = om_bootstrap.util.merge_props.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([props,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$class,om_tools.dom.class_set(klasses)], null)], 0));
var table = om_tools.dom.element(React.DOM.table,props__$1,(new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[children],null)));
if(cljs.core.truth_(cljs.core.cst$kw$responsive_QMARK_.cljs$core$IFn$_invoke$arity$1(opts))){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(React.DOM.div,{"className": "table-responsive"},cljs.core.flatten((new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[table],null))));
} else {
return table;
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___27145 = (output_checker27128_27138.cljs$core$IFn$_invoke$arity$1 ? output_checker27128_27138.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker27128_27138.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___27145)){
var error__8405__auto___27146 = temp__4425__auto___27145;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$table,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"Generates a Bootstrap table wrapper."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___27146], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema27125_27135,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___27146], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___27134,output_schema27125_27135,input_schema27126_27136,input_checker27127_27137,output_checker27128_27138))
;

om_bootstrap.table.table.cljs$lang$maxFixedArity = (1);

om_bootstrap.table.table.cljs$lang$applyTo = ((function (ufv___27134,output_schema27125_27135,input_schema27126_27136,input_checker27127_27137,output_checker27128_27138){
return (function (seq27131){
var G__27132 = cljs.core.first(seq27131);
var seq27131__$1 = cljs.core.next(seq27131);
return om_bootstrap.table.table.cljs$core$IFn$_invoke$arity$variadic(G__27132,seq27131__$1);
});})(ufv___27134,output_schema27125_27135,input_schema27126_27136,input_checker27127_27137,output_checker27128_27138))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(om_bootstrap.table.table),schema.core.make_fn_schema(output_schema27125_27135,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema27126_27136], null)));
