// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('plumbing.core');
goog.require('cljs.core');
goog.require('schema.utils');
goog.require('plumbing.fnk.schema');
/**
 * A sentinel value representing missing portions of the input data.
 */
plumbing.core._PLUS_none_PLUS_ = cljs.core.cst$kw$plumbing$core_SLASH_missing;
/**
 * Updates the value in map m at k with the function f.
 * 
 *  Like update-in, but for updating a single top-level key.
 *  Any additional args will be passed to f after the value.
 * 
 *  WARNING As of Clojure 1.7 this function exists in clojure.core and
 *  will not be exported by this namespace.
 */
plumbing.core.update = (function plumbing$core$update(var_args){
var args26477 = [];
var len__5570__auto___26492 = arguments.length;
var i__5571__auto___26493 = (0);
while(true){
if((i__5571__auto___26493 < len__5570__auto___26492)){
args26477.push((arguments[i__5571__auto___26493]));

var G__26494 = (i__5571__auto___26493 + (1));
i__5571__auto___26493 = G__26494;
continue;
} else {
}
break;
}

var G__26485 = args26477.length;
switch (G__26485) {
case 3:
return plumbing.core.update.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return plumbing.core.update.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return plumbing.core.update.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
var argseq__5589__auto__ = (new cljs.core.IndexedSeq(args26477.slice((5)),(0)));
return plumbing.core.update.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),argseq__5589__auto__);

}
});

plumbing.core.update.cljs$core$IFn$_invoke$arity$3 = (function (m,k,f){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,k,(function (){var G__26486 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(m,k);
return (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(G__26486) : f.call(null,G__26486));
})());
});

plumbing.core.update.cljs$core$IFn$_invoke$arity$4 = (function (m,k,f,x1){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,k,(function (){var G__26487 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(m,k);
var G__26488 = x1;
return (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(G__26487,G__26488) : f.call(null,G__26487,G__26488));
})());
});

plumbing.core.update.cljs$core$IFn$_invoke$arity$5 = (function (m,k,f,x1,x2){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,k,(function (){var G__26489 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(m,k);
var G__26490 = x1;
var G__26491 = x2;
return (f.cljs$core$IFn$_invoke$arity$3 ? f.cljs$core$IFn$_invoke$arity$3(G__26489,G__26490,G__26491) : f.call(null,G__26489,G__26490,G__26491));
})());
});

plumbing.core.update.cljs$core$IFn$_invoke$arity$variadic = (function (m,k,f,x1,x2,xs){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,k,cljs.core.apply.cljs$core$IFn$_invoke$arity$5(f,cljs.core.get.cljs$core$IFn$_invoke$arity$2(m,k),x1,x2,xs));
});

plumbing.core.update.cljs$lang$applyTo = (function (seq26478){
var G__26479 = cljs.core.first(seq26478);
var seq26478__$1 = cljs.core.next(seq26478);
var G__26480 = cljs.core.first(seq26478__$1);
var seq26478__$2 = cljs.core.next(seq26478__$1);
var G__26481 = cljs.core.first(seq26478__$2);
var seq26478__$3 = cljs.core.next(seq26478__$2);
var G__26482 = cljs.core.first(seq26478__$3);
var seq26478__$4 = cljs.core.next(seq26478__$3);
var G__26483 = cljs.core.first(seq26478__$4);
var seq26478__$5 = cljs.core.next(seq26478__$4);
return plumbing.core.update.cljs$core$IFn$_invoke$arity$variadic(G__26479,G__26480,G__26481,G__26482,G__26483,seq26478__$5);
});

plumbing.core.update.cljs$lang$maxFixedArity = (5);
/**
 * Build map k -> (f v) for [k v] in map, preserving the initial type
 */
plumbing.core.map_vals = (function plumbing$core$map_vals(f,m){
if(cljs.core.sorted_QMARK_(m)){
return cljs.core.reduce_kv((function (out_m,k,v){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(out_m,k,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(v) : f.call(null,v)));
}),cljs.core.sorted_map(),m);
} else {
if(cljs.core.map_QMARK_(m)){
return cljs.core.persistent_BANG_(cljs.core.reduce_kv((function (out_m,k,v){
return cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(out_m,k,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(v) : f.call(null,v)));
}),cljs.core.transient$(cljs.core.PersistentArrayMap.EMPTY),m));
} else {
var m_atom__14277__auto__ = (function (){var G__26509 = cljs.core.transient$(cljs.core.PersistentArrayMap.EMPTY);
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__26509) : cljs.core.atom.call(null,G__26509));
})();
var seq__26510_26520 = cljs.core.seq(m);
var chunk__26511_26521 = null;
var count__26512_26522 = (0);
var i__26513_26523 = (0);
while(true){
if((i__26513_26523 < count__26512_26522)){
var vec__26514_26524 = chunk__26511_26521.cljs$core$IIndexed$_nth$arity$2(null,i__26513_26523);
var k_26525 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26514_26524,(0),null);
var v_26526 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26514_26524,(1),null);
var m26508_26527 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26515_26528 = m_atom__14277__auto__;
var G__26516_26529 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26508_26527,k_26525,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(v_26526) : f.call(null,v_26526)));
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26515_26528,G__26516_26529) : cljs.core.reset_BANG_.call(null,G__26515_26528,G__26516_26529));

var G__26530 = seq__26510_26520;
var G__26531 = chunk__26511_26521;
var G__26532 = count__26512_26522;
var G__26533 = (i__26513_26523 + (1));
seq__26510_26520 = G__26530;
chunk__26511_26521 = G__26531;
count__26512_26522 = G__26532;
i__26513_26523 = G__26533;
continue;
} else {
var temp__4425__auto___26534 = cljs.core.seq(seq__26510_26520);
if(temp__4425__auto___26534){
var seq__26510_26535__$1 = temp__4425__auto___26534;
if(cljs.core.chunked_seq_QMARK_(seq__26510_26535__$1)){
var c__5315__auto___26536 = cljs.core.chunk_first(seq__26510_26535__$1);
var G__26537 = cljs.core.chunk_rest(seq__26510_26535__$1);
var G__26538 = c__5315__auto___26536;
var G__26539 = cljs.core.count(c__5315__auto___26536);
var G__26540 = (0);
seq__26510_26520 = G__26537;
chunk__26511_26521 = G__26538;
count__26512_26522 = G__26539;
i__26513_26523 = G__26540;
continue;
} else {
var vec__26517_26541 = cljs.core.first(seq__26510_26535__$1);
var k_26542 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26517_26541,(0),null);
var v_26543 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26517_26541,(1),null);
var m26508_26544 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26518_26545 = m_atom__14277__auto__;
var G__26519_26546 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26508_26544,k_26542,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(v_26543) : f.call(null,v_26543)));
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26518_26545,G__26519_26546) : cljs.core.reset_BANG_.call(null,G__26518_26545,G__26519_26546));

var G__26547 = cljs.core.next(seq__26510_26535__$1);
var G__26548 = null;
var G__26549 = (0);
var G__26550 = (0);
seq__26510_26520 = G__26547;
chunk__26511_26521 = G__26548;
count__26512_26522 = G__26549;
i__26513_26523 = G__26550;
continue;
}
} else {
}
}
break;
}

return cljs.core.persistent_BANG_((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__)));

}
}
});
/**
 * Build map (f k) -> v for [k v] in map m
 */
plumbing.core.map_keys = (function plumbing$core$map_keys(f,m){
if(cljs.core.map_QMARK_(m)){
return cljs.core.persistent_BANG_(cljs.core.reduce_kv((function (out_m,k,v){
return cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(out_m,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(k) : f.call(null,k)),v);
}),cljs.core.transient$(cljs.core.PersistentArrayMap.EMPTY),m));
} else {
var m_atom__14277__auto__ = (function (){var G__26564 = cljs.core.transient$(cljs.core.PersistentArrayMap.EMPTY);
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__26564) : cljs.core.atom.call(null,G__26564));
})();
var seq__26565_26575 = cljs.core.seq(m);
var chunk__26566_26576 = null;
var count__26567_26577 = (0);
var i__26568_26578 = (0);
while(true){
if((i__26568_26578 < count__26567_26577)){
var vec__26569_26579 = chunk__26566_26576.cljs$core$IIndexed$_nth$arity$2(null,i__26568_26578);
var k_26580 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26569_26579,(0),null);
var v_26581 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26569_26579,(1),null);
var m26563_26582 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26570_26583 = m_atom__14277__auto__;
var G__26571_26584 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26563_26582,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(k_26580) : f.call(null,k_26580)),v_26581);
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26570_26583,G__26571_26584) : cljs.core.reset_BANG_.call(null,G__26570_26583,G__26571_26584));

var G__26585 = seq__26565_26575;
var G__26586 = chunk__26566_26576;
var G__26587 = count__26567_26577;
var G__26588 = (i__26568_26578 + (1));
seq__26565_26575 = G__26585;
chunk__26566_26576 = G__26586;
count__26567_26577 = G__26587;
i__26568_26578 = G__26588;
continue;
} else {
var temp__4425__auto___26589 = cljs.core.seq(seq__26565_26575);
if(temp__4425__auto___26589){
var seq__26565_26590__$1 = temp__4425__auto___26589;
if(cljs.core.chunked_seq_QMARK_(seq__26565_26590__$1)){
var c__5315__auto___26591 = cljs.core.chunk_first(seq__26565_26590__$1);
var G__26592 = cljs.core.chunk_rest(seq__26565_26590__$1);
var G__26593 = c__5315__auto___26591;
var G__26594 = cljs.core.count(c__5315__auto___26591);
var G__26595 = (0);
seq__26565_26575 = G__26592;
chunk__26566_26576 = G__26593;
count__26567_26577 = G__26594;
i__26568_26578 = G__26595;
continue;
} else {
var vec__26572_26596 = cljs.core.first(seq__26565_26590__$1);
var k_26597 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26572_26596,(0),null);
var v_26598 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26572_26596,(1),null);
var m26563_26599 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26573_26600 = m_atom__14277__auto__;
var G__26574_26601 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26563_26599,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(k_26597) : f.call(null,k_26597)),v_26598);
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26573_26600,G__26574_26601) : cljs.core.reset_BANG_.call(null,G__26573_26600,G__26574_26601));

var G__26602 = cljs.core.next(seq__26565_26590__$1);
var G__26603 = null;
var G__26604 = (0);
var G__26605 = (0);
seq__26565_26575 = G__26602;
chunk__26566_26576 = G__26603;
count__26567_26577 = G__26604;
i__26568_26578 = G__26605;
continue;
}
} else {
}
}
break;
}

return cljs.core.persistent_BANG_((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__)));
}
});
/**
 * Build map k -> (f k) for keys in ks
 */
plumbing.core.map_from_keys = (function plumbing$core$map_from_keys(f,ks){
var m_atom__14277__auto__ = (function (){var G__26617 = cljs.core.transient$(cljs.core.PersistentArrayMap.EMPTY);
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__26617) : cljs.core.atom.call(null,G__26617));
})();
var seq__26618_26626 = cljs.core.seq(ks);
var chunk__26619_26627 = null;
var count__26620_26628 = (0);
var i__26621_26629 = (0);
while(true){
if((i__26621_26629 < count__26620_26628)){
var k_26630 = chunk__26619_26627.cljs$core$IIndexed$_nth$arity$2(null,i__26621_26629);
var m26616_26631 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26622_26632 = m_atom__14277__auto__;
var G__26623_26633 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26616_26631,k_26630,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(k_26630) : f.call(null,k_26630)));
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26622_26632,G__26623_26633) : cljs.core.reset_BANG_.call(null,G__26622_26632,G__26623_26633));

var G__26634 = seq__26618_26626;
var G__26635 = chunk__26619_26627;
var G__26636 = count__26620_26628;
var G__26637 = (i__26621_26629 + (1));
seq__26618_26626 = G__26634;
chunk__26619_26627 = G__26635;
count__26620_26628 = G__26636;
i__26621_26629 = G__26637;
continue;
} else {
var temp__4425__auto___26638 = cljs.core.seq(seq__26618_26626);
if(temp__4425__auto___26638){
var seq__26618_26639__$1 = temp__4425__auto___26638;
if(cljs.core.chunked_seq_QMARK_(seq__26618_26639__$1)){
var c__5315__auto___26640 = cljs.core.chunk_first(seq__26618_26639__$1);
var G__26641 = cljs.core.chunk_rest(seq__26618_26639__$1);
var G__26642 = c__5315__auto___26640;
var G__26643 = cljs.core.count(c__5315__auto___26640);
var G__26644 = (0);
seq__26618_26626 = G__26641;
chunk__26619_26627 = G__26642;
count__26620_26628 = G__26643;
i__26621_26629 = G__26644;
continue;
} else {
var k_26645 = cljs.core.first(seq__26618_26639__$1);
var m26616_26646 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26624_26647 = m_atom__14277__auto__;
var G__26625_26648 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26616_26646,k_26645,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(k_26645) : f.call(null,k_26645)));
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26624_26647,G__26625_26648) : cljs.core.reset_BANG_.call(null,G__26624_26647,G__26625_26648));

var G__26649 = cljs.core.next(seq__26618_26639__$1);
var G__26650 = null;
var G__26651 = (0);
var G__26652 = (0);
seq__26618_26626 = G__26649;
chunk__26619_26627 = G__26650;
count__26620_26628 = G__26651;
i__26621_26629 = G__26652;
continue;
}
} else {
}
}
break;
}

return cljs.core.persistent_BANG_((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__)));
});
/**
 * Build map (f v) -> v for vals in vs
 */
plumbing.core.map_from_vals = (function plumbing$core$map_from_vals(f,vs){
var m_atom__14277__auto__ = (function (){var G__26664 = cljs.core.transient$(cljs.core.PersistentArrayMap.EMPTY);
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__26664) : cljs.core.atom.call(null,G__26664));
})();
var seq__26665_26673 = cljs.core.seq(vs);
var chunk__26666_26674 = null;
var count__26667_26675 = (0);
var i__26668_26676 = (0);
while(true){
if((i__26668_26676 < count__26667_26675)){
var v_26677 = chunk__26666_26674.cljs$core$IIndexed$_nth$arity$2(null,i__26668_26676);
var m26663_26678 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26669_26679 = m_atom__14277__auto__;
var G__26670_26680 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26663_26678,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(v_26677) : f.call(null,v_26677)),v_26677);
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26669_26679,G__26670_26680) : cljs.core.reset_BANG_.call(null,G__26669_26679,G__26670_26680));

var G__26681 = seq__26665_26673;
var G__26682 = chunk__26666_26674;
var G__26683 = count__26667_26675;
var G__26684 = (i__26668_26676 + (1));
seq__26665_26673 = G__26681;
chunk__26666_26674 = G__26682;
count__26667_26675 = G__26683;
i__26668_26676 = G__26684;
continue;
} else {
var temp__4425__auto___26685 = cljs.core.seq(seq__26665_26673);
if(temp__4425__auto___26685){
var seq__26665_26686__$1 = temp__4425__auto___26685;
if(cljs.core.chunked_seq_QMARK_(seq__26665_26686__$1)){
var c__5315__auto___26687 = cljs.core.chunk_first(seq__26665_26686__$1);
var G__26688 = cljs.core.chunk_rest(seq__26665_26686__$1);
var G__26689 = c__5315__auto___26687;
var G__26690 = cljs.core.count(c__5315__auto___26687);
var G__26691 = (0);
seq__26665_26673 = G__26688;
chunk__26666_26674 = G__26689;
count__26667_26675 = G__26690;
i__26668_26676 = G__26691;
continue;
} else {
var v_26692 = cljs.core.first(seq__26665_26686__$1);
var m26663_26693 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26671_26694 = m_atom__14277__auto__;
var G__26672_26695 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26663_26693,(f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(v_26692) : f.call(null,v_26692)),v_26692);
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26671_26694,G__26672_26695) : cljs.core.reset_BANG_.call(null,G__26671_26694,G__26672_26695));

var G__26696 = cljs.core.next(seq__26665_26686__$1);
var G__26697 = null;
var G__26698 = (0);
var G__26699 = (0);
seq__26665_26673 = G__26696;
chunk__26666_26674 = G__26697;
count__26667_26675 = G__26698;
i__26668_26676 = G__26699;
continue;
}
} else {
}
}
break;
}

return cljs.core.persistent_BANG_((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__)));
});
/**
 * Dissociate this keyseq from m, removing any empty maps created as a result
 * (including at the top-level).
 */
plumbing.core.dissoc_in = (function plumbing$core$dissoc_in(m,p__26700){
var vec__26704 = p__26700;
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26704,(0),null);
var ks = cljs.core.nthnext(vec__26704,(1));
if(cljs.core.truth_(m)){
var temp__4423__auto__ = (function (){var and__4500__auto__ = ks;
if(cljs.core.truth_(and__4500__auto__)){
return plumbing$core$dissoc_in(cljs.core.get.cljs$core$IFn$_invoke$arity$2(m,k),ks);
} else {
return and__4500__auto__;
}
})();
if(cljs.core.truth_(temp__4423__auto__)){
var res = temp__4423__auto__;
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,k,res);
} else {
var res = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(m,k);
if(cljs.core.empty_QMARK_(res)){
return null;
} else {
return res;
}
}
} else {
return null;
}
});
/**
 * Recursively convert maps in m (including itself)
 * to have keyword keys instead of string
 */
plumbing.core.keywordize_map = (function plumbing$core$keywordize_map(x){
if(cljs.core.map_QMARK_(x)){
var m_atom__14277__auto__ = (function (){var G__26718 = cljs.core.transient$(cljs.core.PersistentArrayMap.EMPTY);
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__26718) : cljs.core.atom.call(null,G__26718));
})();
var seq__26719_26729 = cljs.core.seq(x);
var chunk__26720_26730 = null;
var count__26721_26731 = (0);
var i__26722_26732 = (0);
while(true){
if((i__26722_26732 < count__26721_26731)){
var vec__26723_26733 = chunk__26720_26730.cljs$core$IIndexed$_nth$arity$2(null,i__26722_26732);
var k_26734 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26723_26733,(0),null);
var v_26735 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26723_26733,(1),null);
var m26717_26736 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26724_26737 = m_atom__14277__auto__;
var G__26725_26738 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26717_26736,((typeof k_26734 === 'string')?cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(k_26734):k_26734),plumbing$core$keywordize_map(v_26735));
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26724_26737,G__26725_26738) : cljs.core.reset_BANG_.call(null,G__26724_26737,G__26725_26738));

var G__26739 = seq__26719_26729;
var G__26740 = chunk__26720_26730;
var G__26741 = count__26721_26731;
var G__26742 = (i__26722_26732 + (1));
seq__26719_26729 = G__26739;
chunk__26720_26730 = G__26740;
count__26721_26731 = G__26741;
i__26722_26732 = G__26742;
continue;
} else {
var temp__4425__auto___26743 = cljs.core.seq(seq__26719_26729);
if(temp__4425__auto___26743){
var seq__26719_26744__$1 = temp__4425__auto___26743;
if(cljs.core.chunked_seq_QMARK_(seq__26719_26744__$1)){
var c__5315__auto___26745 = cljs.core.chunk_first(seq__26719_26744__$1);
var G__26746 = cljs.core.chunk_rest(seq__26719_26744__$1);
var G__26747 = c__5315__auto___26745;
var G__26748 = cljs.core.count(c__5315__auto___26745);
var G__26749 = (0);
seq__26719_26729 = G__26746;
chunk__26720_26730 = G__26747;
count__26721_26731 = G__26748;
i__26722_26732 = G__26749;
continue;
} else {
var vec__26726_26750 = cljs.core.first(seq__26719_26744__$1);
var k_26751 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26726_26750,(0),null);
var v_26752 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26726_26750,(1),null);
var m26717_26753 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__));
var G__26727_26754 = m_atom__14277__auto__;
var G__26728_26755 = cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(m26717_26753,((typeof k_26751 === 'string')?cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(k_26751):k_26751),plumbing$core$keywordize_map(v_26752));
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__26727_26754,G__26728_26755) : cljs.core.reset_BANG_.call(null,G__26727_26754,G__26728_26755));

var G__26756 = cljs.core.next(seq__26719_26744__$1);
var G__26757 = null;
var G__26758 = (0);
var G__26759 = (0);
seq__26719_26729 = G__26756;
chunk__26720_26730 = G__26757;
count__26721_26731 = G__26758;
i__26722_26732 = G__26759;
continue;
}
} else {
}
}
break;
}

return cljs.core.persistent_BANG_((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(m_atom__14277__auto__) : cljs.core.deref.call(null,m_atom__14277__auto__)));
} else {
if(cljs.core.seq_QMARK_(x)){
return cljs.core.map.cljs$core$IFn$_invoke$arity$2(plumbing$core$keywordize_map,x);
} else {
if(cljs.core.vector_QMARK_(x)){
return cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(plumbing$core$keywordize_map,x);
} else {
return x;

}
}
}
});
/**
 * Like get but throw an exception if not found
 */
plumbing.core.safe_get = (function plumbing$core$safe_get(m,k){
var temp__4423__auto__ = cljs.core.find(m,k);
if(cljs.core.truth_(temp__4423__auto__)){
var pair__14358__auto__ = temp__4423__auto__;
return cljs.core.val(pair__14358__auto__);
} else {
throw (new Error(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Key %s not found in %s",cljs.core.array_seq([k,cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(cljs.core.key,m)], 0))));

}
});
/**
 * Like get-in but throws exception if not found
 */
plumbing.core.safe_get_in = (function plumbing$core$safe_get_in(m,ks){
while(true){
if(cljs.core.seq(ks)){
var G__26760 = plumbing.core.safe_get(m,cljs.core.first(ks));
var G__26761 = cljs.core.next(ks);
m = G__26760;
ks = G__26761;
continue;
} else {
return m;
}
break;
}
});
/**
 * Like assoc but only assocs when value is truthy
 */
plumbing.core.assoc_when = (function plumbing$core$assoc_when(var_args){
var args__5577__auto__ = [];
var len__5570__auto___26774 = arguments.length;
var i__5571__auto___26775 = (0);
while(true){
if((i__5571__auto___26775 < len__5570__auto___26774)){
args__5577__auto__.push((arguments[i__5571__auto___26775]));

var G__26776 = (i__5571__auto___26775 + (1));
i__5571__auto___26775 = G__26776;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return plumbing.core.assoc_when.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

plumbing.core.assoc_when.cljs$core$IFn$_invoke$arity$variadic = (function (m,kvs){
if(cljs.core.even_QMARK_(cljs.core.count(kvs))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(cljs.core.cst$sym$even_QMARK_,cljs.core.list(cljs.core.cst$sym$count,cljs.core.cst$sym$kvs))], 0)))].join('')));
}

return cljs.core.into.cljs$core$IFn$_invoke$arity$2((function (){var or__4512__auto__ = m;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return cljs.core.PersistentArrayMap.EMPTY;
}
})(),(function (){var iter__5284__auto__ = (function plumbing$core$iter__26764(s__26765){
return (new cljs.core.LazySeq(null,(function (){
var s__26765__$1 = s__26765;
while(true){
var temp__4425__auto__ = cljs.core.seq(s__26765__$1);
if(temp__4425__auto__){
var s__26765__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_(s__26765__$2)){
var c__5282__auto__ = cljs.core.chunk_first(s__26765__$2);
var size__5283__auto__ = cljs.core.count(c__5282__auto__);
var b__26767 = cljs.core.chunk_buffer(size__5283__auto__);
if((function (){var i__26766 = (0);
while(true){
if((i__26766 < size__5283__auto__)){
var vec__26772 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__5282__auto__,i__26766);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26772,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26772,(1),null);
if(cljs.core.truth_(v)){
cljs.core.chunk_append(b__26767,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,v], null));

var G__26777 = (i__26766 + (1));
i__26766 = G__26777;
continue;
} else {
var G__26778 = (i__26766 + (1));
i__26766 = G__26778;
continue;
}
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__26767),plumbing$core$iter__26764(cljs.core.chunk_rest(s__26765__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__26767),null);
}
} else {
var vec__26773 = cljs.core.first(s__26765__$2);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26773,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26773,(1),null);
if(cljs.core.truth_(v)){
return cljs.core.cons(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,v], null),plumbing$core$iter__26764(cljs.core.rest(s__26765__$2)));
} else {
var G__26779 = cljs.core.rest(s__26765__$2);
s__26765__$1 = G__26779;
continue;
}
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__5284__auto__(cljs.core.partition.cljs$core$IFn$_invoke$arity$2((2),kvs));
})());
});

plumbing.core.assoc_when.cljs$lang$maxFixedArity = (1);

plumbing.core.assoc_when.cljs$lang$applyTo = (function (seq26762){
var G__26763 = cljs.core.first(seq26762);
var seq26762__$1 = cljs.core.next(seq26762);
return plumbing.core.assoc_when.cljs$core$IFn$_invoke$arity$variadic(G__26763,seq26762__$1);
});
/**
 * Like update-in but returns m unchanged if key-seq is not present.
 */
plumbing.core.update_in_when = (function plumbing$core$update_in_when(var_args){
var args__5577__auto__ = [];
var len__5570__auto___26784 = arguments.length;
var i__5571__auto___26785 = (0);
while(true){
if((i__5571__auto___26785 < len__5570__auto___26784)){
args__5577__auto__.push((arguments[i__5571__auto___26785]));

var G__26786 = (i__5571__auto___26785 + (1));
i__5571__auto___26785 = G__26786;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((3) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((3)),(0))):null);
return plumbing.core.update_in_when.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5578__auto__);
});

plumbing.core.update_in_when.cljs$core$IFn$_invoke$arity$variadic = (function (m,key_seq,f,args){
var found = cljs.core.get_in.cljs$core$IFn$_invoke$arity$3(m,key_seq,plumbing.core._PLUS_none_PLUS_);
if(!((plumbing.core._PLUS_none_PLUS_ === found))){
return cljs.core.assoc_in(m,key_seq,cljs.core.apply.cljs$core$IFn$_invoke$arity$3(f,found,args));
} else {
return m;
}
});

plumbing.core.update_in_when.cljs$lang$maxFixedArity = (3);

plumbing.core.update_in_when.cljs$lang$applyTo = (function (seq26780){
var G__26781 = cljs.core.first(seq26780);
var seq26780__$1 = cljs.core.next(seq26780);
var G__26782 = cljs.core.first(seq26780__$1);
var seq26780__$2 = cljs.core.next(seq26780__$1);
var G__26783 = cljs.core.first(seq26780__$2);
var seq26780__$3 = cljs.core.next(seq26780__$2);
return plumbing.core.update_in_when.cljs$core$IFn$_invoke$arity$variadic(G__26781,G__26782,G__26783,seq26780__$3);
});
/**
 * Like group-by, but accepts a map-fn that is applied to values before
 * collected.
 */
plumbing.core.grouped_map = (function plumbing$core$grouped_map(key_fn,map_fn,coll){
return cljs.core.persistent_BANG_(cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret,x){
var k = (key_fn.cljs$core$IFn$_invoke$arity$1 ? key_fn.cljs$core$IFn$_invoke$arity$1(x) : key_fn.call(null,x));
return cljs.core.assoc_BANG_.cljs$core$IFn$_invoke$arity$3(ret,k,cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.get.cljs$core$IFn$_invoke$arity$3(ret,k,cljs.core.PersistentVector.EMPTY),(map_fn.cljs$core$IFn$_invoke$arity$1 ? map_fn.cljs$core$IFn$_invoke$arity$1(x) : map_fn.call(null,x))));
}),cljs.core.transient$(cljs.core.PersistentArrayMap.EMPTY),coll));
});
/**
 * Like (apply concat s) but lazier (and shorter) 
 */
plumbing.core.aconcat = (function plumbing$core$aconcat(s){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2((new cljs.core.LazySeq(null,(function (){
return cljs.core.first(s);
}),null,null)),(new cljs.core.LazySeq(null,(function (){
var temp__4425__auto__ = cljs.core.next(s);
if(temp__4425__auto__){
var n = temp__4425__auto__;
return plumbing$core$aconcat(n);
} else {
return null;
}
}),null,null)));
});
/**
 * Takes a seqable and returns a lazy sequence that
 * is maximally lazy and doesn't realize elements due to either
 * chunking or apply.
 * 
 * Useful when you don't want chunking, for instance,
 * (first awesome-website? (map slurp +a-bunch-of-urls+))
 * may slurp up to 31 unneed webpages, wherease
 * (first awesome-website? (map slurp (unchunk +a-bunch-of-urls+)))
 * is guaranteed to stop slurping after the first awesome website.
 * 
 *   Taken from http://stackoverflow.com/questions/3407876/how-do-i-avoid-clojures-chunking-behavior-for-lazy-seqs-that-i-want-to-short-ci
 */
plumbing.core.unchunk = (function plumbing$core$unchunk(s){
if(cljs.core.seq(s)){
return cljs.core.cons(cljs.core.first(s),(new cljs.core.LazySeq(null,(function (){
return plumbing$core$unchunk(cljs.core.rest(s));
}),null,null)));
} else {
return null;
}
});
/**
 * Return sum of (f x) for each x in xs
 */
plumbing.core.sum = (function plumbing$core$sum(var_args){
var args26788 = [];
var len__5570__auto___26791 = arguments.length;
var i__5571__auto___26792 = (0);
while(true){
if((i__5571__auto___26792 < len__5570__auto___26791)){
args26788.push((arguments[i__5571__auto___26792]));

var G__26793 = (i__5571__auto___26792 + (1));
i__5571__auto___26792 = G__26793;
continue;
} else {
}
break;
}

var G__26790 = args26788.length;
switch (G__26790) {
case 2:
return plumbing.core.sum.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 1:
return plumbing.core.sum.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args26788.length)].join('')));

}
});

plumbing.core.sum.cljs$core$IFn$_invoke$arity$2 = (function (f,xs){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$2(cljs.core._PLUS_,cljs.core.map.cljs$core$IFn$_invoke$arity$2(f,xs));
});

plumbing.core.sum.cljs$core$IFn$_invoke$arity$1 = (function (xs){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$2(cljs.core._PLUS_,xs);
});

plumbing.core.sum.cljs$lang$maxFixedArity = 2;
/**
 * returns (first xs) when xs has only 1 element
 */
plumbing.core.singleton = (function plumbing$core$singleton(xs){
var temp__4425__auto__ = cljs.core.seq(xs);
if(temp__4425__auto__){
var xs__$1 = temp__4425__auto__;
if(cljs.core.next(xs__$1)){
return null;
} else {
return cljs.core.first(xs__$1);
}
} else {
return null;
}
});
/**
 * Returns [idx x] for x in seqable s
 */
plumbing.core.indexed = (function plumbing$core$indexed(s){
return cljs.core.map_indexed.cljs$core$IFn$_invoke$arity$2(cljs.core.vector,s);
});
/**
 * Returns indices idx of sequence s where (f (nth s idx))
 */
plumbing.core.positions = (function plumbing$core$positions(f,s){
return cljs.core.keep_indexed.cljs$core$IFn$_invoke$arity$2((function (i,x){
if(cljs.core.truth_((f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(x) : f.call(null,x)))){
return i;
} else {
return null;
}
}),s);
});
/**
 * Returns elements of xs which return unique
 * values according to f. If multiple elements of xs return the same
 * value under f, the first is returned
 */
plumbing.core.distinct_by = (function plumbing$core$distinct_by(f,xs){
var s = (function (){var G__26802 = cljs.core.PersistentHashSet.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__26802) : cljs.core.atom.call(null,G__26802));
})();
var iter__5284__auto__ = ((function (s){
return (function plumbing$core$distinct_by_$_iter__26803(s__26804){
return (new cljs.core.LazySeq(null,((function (s){
return (function (){
var s__26804__$1 = s__26804;
while(true){
var temp__4425__auto__ = cljs.core.seq(s__26804__$1);
if(temp__4425__auto__){
var s__26804__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_(s__26804__$2)){
var c__5282__auto__ = cljs.core.chunk_first(s__26804__$2);
var size__5283__auto__ = cljs.core.count(c__5282__auto__);
var b__26806 = cljs.core.chunk_buffer(size__5283__auto__);
if((function (){var i__26805 = (0);
while(true){
if((i__26805 < size__5283__auto__)){
var x = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__5282__auto__,i__26805);
var id = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(x) : f.call(null,x));
if(!(cljs.core.contains_QMARK_((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(s) : cljs.core.deref.call(null,s)),id))){
cljs.core.chunk_append(b__26806,(function (){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(s,cljs.core.conj,id);

return x;
})()
);

var G__26809 = (i__26805 + (1));
i__26805 = G__26809;
continue;
} else {
var G__26810 = (i__26805 + (1));
i__26805 = G__26810;
continue;
}
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__26806),plumbing$core$distinct_by_$_iter__26803(cljs.core.chunk_rest(s__26804__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__26806),null);
}
} else {
var x = cljs.core.first(s__26804__$2);
var id = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(x) : f.call(null,x));
if(!(cljs.core.contains_QMARK_((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(s) : cljs.core.deref.call(null,s)),id))){
return cljs.core.cons((function (){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(s,cljs.core.conj,id);

return x;
})()
,plumbing$core$distinct_by_$_iter__26803(cljs.core.rest(s__26804__$2)));
} else {
var G__26811 = cljs.core.rest(s__26804__$2);
s__26804__$1 = G__26811;
continue;
}
}
} else {
return null;
}
break;
}
});})(s))
,null,null));
});})(s))
;
return iter__5284__auto__(xs);
});
/**
 * Analogy: partition:partition-all :: interleave:interleave-all
 */
plumbing.core.interleave_all = (function plumbing$core$interleave_all(var_args){
var args__5577__auto__ = [];
var len__5570__auto___26814 = arguments.length;
var i__5571__auto___26815 = (0);
while(true){
if((i__5571__auto___26815 < len__5570__auto___26814)){
args__5577__auto__.push((arguments[i__5571__auto___26815]));

var G__26816 = (i__5571__auto___26815 + (1));
i__5571__auto___26815 = G__26816;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((0) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((0)),(0))):null);
return plumbing.core.interleave_all.cljs$core$IFn$_invoke$arity$variadic(argseq__5578__auto__);
});

plumbing.core.interleave_all.cljs$core$IFn$_invoke$arity$variadic = (function (colls){
return (new cljs.core.LazySeq(null,(function (){
return (function plumbing$core$helper(seqs){
if(cljs.core.seq(seqs)){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.first,seqs),(new cljs.core.LazySeq(null,(function (){
return plumbing$core$helper(cljs.core.keep.cljs$core$IFn$_invoke$arity$2(cljs.core.next,seqs));
}),null,null)));
} else {
return null;
}
}).call(null,cljs.core.keep.cljs$core$IFn$_invoke$arity$2(cljs.core.seq,colls));
}),null,null));
});

plumbing.core.interleave_all.cljs$lang$maxFixedArity = (0);

plumbing.core.interleave_all.cljs$lang$applyTo = (function (seq26812){
return plumbing.core.interleave_all.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq26812));
});
/**
 * Returns # of elements of xs where pred holds
 */
plumbing.core.count_when = (function plumbing$core$count_when(pred,xs){
return cljs.core.count(cljs.core.filter.cljs$core$IFn$_invoke$arity$2(pred,xs));
});
/**
 * Like conj but ignores non-truthy values
 */
plumbing.core.conj_when = (function plumbing$core$conj_when(var_args){
var args26817 = [];
var len__5570__auto___26823 = arguments.length;
var i__5571__auto___26824 = (0);
while(true){
if((i__5571__auto___26824 < len__5570__auto___26823)){
args26817.push((arguments[i__5571__auto___26824]));

var G__26825 = (i__5571__auto___26824 + (1));
i__5571__auto___26824 = G__26825;
continue;
} else {
}
break;
}

var G__26822 = args26817.length;
switch (G__26822) {
case 2:
return plumbing.core.conj_when.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__5589__auto__ = (new cljs.core.IndexedSeq(args26817.slice((2)),(0)));
return plumbing.core.conj_when.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__5589__auto__);

}
});

plumbing.core.conj_when.cljs$core$IFn$_invoke$arity$2 = (function (coll,x){
if(cljs.core.truth_(x)){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(coll,x);
} else {
return coll;
}
});

plumbing.core.conj_when.cljs$core$IFn$_invoke$arity$variadic = (function (coll,x,xs){
while(true){
if(cljs.core.truth_(xs)){
var G__26827 = plumbing.core.conj_when.cljs$core$IFn$_invoke$arity$2(coll,x);
var G__26828 = cljs.core.first(xs);
var G__26829 = cljs.core.next(xs);
coll = G__26827;
x = G__26828;
xs = G__26829;
continue;
} else {
return plumbing.core.conj_when.cljs$core$IFn$_invoke$arity$2(coll,x);
}
break;
}
});

plumbing.core.conj_when.cljs$lang$applyTo = (function (seq26818){
var G__26819 = cljs.core.first(seq26818);
var seq26818__$1 = cljs.core.next(seq26818);
var G__26820 = cljs.core.first(seq26818__$1);
var seq26818__$2 = cljs.core.next(seq26818__$1);
return plumbing.core.conj_when.cljs$core$IFn$_invoke$arity$variadic(G__26819,G__26820,seq26818__$2);
});

plumbing.core.conj_when.cljs$lang$maxFixedArity = (2);
/**
 * Like cons but does nothing if x is non-truthy.
 */
plumbing.core.cons_when = (function plumbing$core$cons_when(x,s){
if(cljs.core.truth_(x)){
return cljs.core.cons(x,s);
} else {
return s;
}
});
/**
 * Like sort-by, but prefers higher values rather than lower ones.
 */
plumbing.core.rsort_by = cljs.core.comp.cljs$core$IFn$_invoke$arity$2(cljs.core.reverse,cljs.core.sort_by);
/**
 * Like swap! but returns a pair [old-val new-val]
 */
plumbing.core.swap_pair_BANG_ = (function plumbing$core$swap_pair_BANG_(var_args){
var args26831 = [];
var len__5570__auto___26837 = arguments.length;
var i__5571__auto___26838 = (0);
while(true){
if((i__5571__auto___26838 < len__5570__auto___26837)){
args26831.push((arguments[i__5571__auto___26838]));

var G__26839 = (i__5571__auto___26838 + (1));
i__5571__auto___26838 = G__26839;
continue;
} else {
}
break;
}

var G__26836 = args26831.length;
switch (G__26836) {
case 2:
return plumbing.core.swap_pair_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__5589__auto__ = (new cljs.core.IndexedSeq(args26831.slice((2)),(0)));
return plumbing.core.swap_pair_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__5589__auto__);

}
});

plumbing.core.swap_pair_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (a,f){
while(true){
var old_val = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(a) : cljs.core.deref.call(null,a));
var new_val = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(old_val) : f.call(null,old_val));
if(cljs.core.truth_(cljs.core.compare_and_set_BANG_(a,old_val,new_val))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [old_val,new_val], null);
} else {
continue;
}
break;
}
});

plumbing.core.swap_pair_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (a,f,args){
return plumbing.core.swap_pair_BANG_.cljs$core$IFn$_invoke$arity$2(a,(function (p1__26830_SHARP_){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(f,p1__26830_SHARP_,args);
}));
});

plumbing.core.swap_pair_BANG_.cljs$lang$applyTo = (function (seq26832){
var G__26833 = cljs.core.first(seq26832);
var seq26832__$1 = cljs.core.next(seq26832);
var G__26834 = cljs.core.first(seq26832__$1);
var seq26832__$2 = cljs.core.next(seq26832__$1);
return plumbing.core.swap_pair_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__26833,G__26834,seq26832__$2);
});

plumbing.core.swap_pair_BANG_.cljs$lang$maxFixedArity = (2);
/**
 * Like reset! but returns old-val
 */
plumbing.core.get_and_set_BANG_ = (function plumbing$core$get_and_set_BANG_(a,new_val){
return cljs.core.first(plumbing.core.swap_pair_BANG_.cljs$core$IFn$_invoke$arity$2(a,cljs.core.constantly(new_val)));
});
plumbing.core.millis = (function plumbing$core$millis(){
return (new Date()).getTime();
});
/**
 * Like apply, but applies a map to a function with positional map
 *   arguments. Can take optional initial args just like apply.
 */
plumbing.core.mapply = (function plumbing$core$mapply(var_args){
var args26841 = [];
var len__5570__auto___26847 = arguments.length;
var i__5571__auto___26848 = (0);
while(true){
if((i__5571__auto___26848 < len__5570__auto___26847)){
args26841.push((arguments[i__5571__auto___26848]));

var G__26849 = (i__5571__auto___26848 + (1));
i__5571__auto___26848 = G__26849;
continue;
} else {
}
break;
}

var G__26846 = args26841.length;
switch (G__26846) {
case 2:
return plumbing.core.mapply.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__5589__auto__ = (new cljs.core.IndexedSeq(args26841.slice((2)),(0)));
return plumbing.core.mapply.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__5589__auto__);

}
});

plumbing.core.mapply.cljs$core$IFn$_invoke$arity$2 = (function (f,m){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,m));
});

plumbing.core.mapply.cljs$core$IFn$_invoke$arity$variadic = (function (f,arg,args){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(f,arg,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(cljs.core.butlast(args),cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,cljs.core.last(args))));
});

plumbing.core.mapply.cljs$lang$applyTo = (function (seq26842){
var G__26843 = cljs.core.first(seq26842);
var seq26842__$1 = cljs.core.next(seq26842);
var G__26844 = cljs.core.first(seq26842__$1);
var seq26842__$2 = cljs.core.next(seq26842__$1);
return plumbing.core.mapply.cljs$core$IFn$_invoke$arity$variadic(G__26843,G__26844,seq26842__$2);
});

plumbing.core.mapply.cljs$lang$maxFixedArity = (2);
