// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('plumbing.fnk.schema');
goog.require('cljs.core');
goog.require('schema.core');
goog.require('schema.utils');
plumbing.fnk.schema.Schema = cljs.core.with_meta(schema.core.__GT_Protocol(schema.core.Schema),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$proto_DASH_sym,cljs.core.cst$sym$s_SLASH_Schema,cljs.core.cst$kw$proto_DASH_pred,(function (p1__8433__8434__auto__){
if(!((p1__8433__8434__auto__ == null))){
if((false) || (p1__8433__8434__auto__.schema$core$Schema$)){
return true;
} else {
if((!p1__8433__8434__auto__.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(schema.core.Schema,p1__8433__8434__auto__);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(schema.core.Schema,p1__8433__8434__auto__);
}
})], null));
plumbing.fnk.schema.InputSchema = cljs.core.PersistentArrayMap.fromArray([schema.core.either.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([schema.core.eq(schema.core.Keyword),schema.core.OptionalKey,schema.core.Keyword], 0)),plumbing.fnk.schema.Schema], true, false);
plumbing.fnk.schema.OutputSchema = plumbing.fnk.schema.Schema;
plumbing.fnk.schema.IOSchemata = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(plumbing.fnk.schema.InputSchema,cljs.core.cst$sym$input),schema.core.one(plumbing.fnk.schema.OutputSchema,cljs.core.cst$sym$output)], null);
plumbing.fnk.schema.GraphInputSchema = cljs.core.PersistentArrayMap.fromArray([schema.core.either.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([schema.core.OptionalKey,schema.core.Keyword], 0)),plumbing.fnk.schema.Schema], true, false);
plumbing.fnk.schema.MapOutputSchema = cljs.core.PersistentArrayMap.fromArray([schema.core.Keyword,plumbing.fnk.schema.Schema], true, false);
plumbing.fnk.schema.GraphIOSchemata = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(plumbing.fnk.schema.GraphInputSchema,cljs.core.cst$sym$input),schema.core.one(plumbing.fnk.schema.MapOutputSchema,cljs.core.cst$sym$output)], null);
/**
 * Like (assert (distinct? things)) but with a more helpful error message.
 */
plumbing.fnk.schema.assert_distinct = (function plumbing$fnk$schema$assert_distinct(things){
var repeated_things = cljs.core.seq(cljs.core.filter.cljs$core$IFn$_invoke$arity$2((function (p1__26105_SHARP_){
return (cljs.core.val(p1__26105_SHARP_) > (1));
}),cljs.core.frequencies(things)));
if(cljs.core.empty_QMARK_(repeated_things)){
return null;
} else {
throw (new Error(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Got repeated items (expected distinct): %s",cljs.core.array_seq([repeated_things], 0))));
}
});
/**
 * Like (get m k), but throws if k is not present in m.
 */
plumbing.fnk.schema.safe_get = (function plumbing$fnk$schema$safe_get(m,k,key_path){
if(cljs.core.map_QMARK_(m)){
} else {
throw (new Error(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Expected a map at key-path %s, got type %s",cljs.core.array_seq([key_path,schema.utils.type_of(m)], 0))));
}

var vec__26107 = cljs.core.find(m,k);
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26107,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26107,(1),null);
var p = vec__26107;
if(cljs.core.truth_(p)){
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Key %s not found in %s",cljs.core.array_seq([k,cljs.core.keys(m)], 0)),new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$error,cljs.core.cst$kw$missing_DASH_key,cljs.core.cst$kw$key,k,cljs.core.cst$kw$map,m], null));
}

return v;
});
plumbing.fnk.schema.non_map_union = (function plumbing$fnk$schema$non_map_union(s1,s2){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(s1,s2)){
return s1;
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(s1,schema.core.Any)){
return s2;
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(s2,schema.core.Any)){
return s1;
} else {
return schema.core.both.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([s1,s2], 0));

}
}
}
});
/**
 * Return a difference of schmas s1 and s2, where one is not a map.
 * Punt for now, assuming s2 always satisfies s1.
 */
plumbing.fnk.schema.non_map_diff = (function plumbing$fnk$schema$non_map_diff(s1,s2){
return null;
});
plumbing.fnk.schema.map_schema_QMARK_ = (function plumbing$fnk$schema$map_schema_QMARK_(m){
return ((m instanceof cljs.core.PersistentArrayMap)) || ((m instanceof cljs.core.PersistentHashMap));
});
var ufv___26113 = schema.utils.use_fn_validation;
var output_schema26108_26114 = schema.core.maybe(schema.core.pair(schema.core.Keyword,"k",schema.core.Bool,"optional?"));
var input_schema26109_26115 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$k,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker26110_26116 = schema.core.checker(input_schema26109_26115);
var output_checker26111_26117 = schema.core.checker(output_schema26108_26114);
/**
 * Inputs: [k]
 *   Returns: (s/maybe (s/pair s/Keyword "k" s/Bool "optional?"))
 * 
 *   Given a possibly-unevaluated schema map key form, unpack an explicit keyword
 * and optional? flag, or return nil for a non-explicit key
 */
plumbing.fnk.schema.unwrap_schema_form_key = ((function (ufv___26113,output_schema26108_26114,input_schema26109_26115,input_checker26110_26116,output_checker26111_26117){
return (function plumbing$fnk$schema$unwrap_schema_form_key(G__26112){
var validate__8403__auto__ = ufv___26113.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___26118 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__26112], null);
var temp__4425__auto___26119 = (input_checker26110_26116.cljs$core$IFn$_invoke$arity$1 ? input_checker26110_26116.cljs$core$IFn$_invoke$arity$1(args__8404__auto___26118) : input_checker26110_26116.call(null,args__8404__auto___26118));
if(cljs.core.truth_(temp__4425__auto___26119)){
var error__8405__auto___26120 = temp__4425__auto___26119;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$unwrap_DASH_schema_DASH_form_DASH_key,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.list(cljs.core.cst$sym$s_SLASH_maybe,cljs.core.list(cljs.core.cst$sym$s_SLASH_pair,cljs.core.cst$sym$s_SLASH_Keyword,"k",cljs.core.cst$sym$s_SLASH_Bool,"optional?")),cljs.core.cst$kw$doc,"Given a possibly-unevaluated schema map key form, unpack an explicit keyword\n   and optional? flag, or return nil for a non-explicit key"], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26120], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema26109_26115,cljs.core.cst$kw$value,args__8404__auto___26118,cljs.core.cst$kw$error,error__8405__auto___26120], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var k = G__26112;
while(true){
if(cljs.core.truth_(schema.core.specific_key_QMARK_(k))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.explicit_schema_key(k),schema.core.required_key_QMARK_(k)], null);
} else {
if((cljs.core.sequential_QMARK_(k)) && (!(cljs.core.vector_QMARK_(k))) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.count(k),(2))) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(k),cljs.core.cst$sym$schema$core_SLASH_optional_DASH_key))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.second(k),false], null);
} else {
return null;
}
}
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___26121 = (output_checker26111_26117.cljs$core$IFn$_invoke$arity$1 ? output_checker26111_26117.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker26111_26117.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___26121)){
var error__8405__auto___26122 = temp__4425__auto___26121;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$unwrap_DASH_schema_DASH_form_DASH_key,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.list(cljs.core.cst$sym$s_SLASH_maybe,cljs.core.list(cljs.core.cst$sym$s_SLASH_pair,cljs.core.cst$sym$s_SLASH_Keyword,"k",cljs.core.cst$sym$s_SLASH_Bool,"optional?")),cljs.core.cst$kw$doc,"Given a possibly-unevaluated schema map key form, unpack an explicit keyword\n   and optional? flag, or return nil for a non-explicit key"], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26122], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema26108_26114,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___26122], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___26113,output_schema26108_26114,input_schema26109_26115,input_checker26110_26116,output_checker26111_26117))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(plumbing.fnk.schema.unwrap_schema_form_key),schema.core.make_fn_schema(output_schema26108_26114,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema26109_26115], null)));
var ufv___26128 = schema.utils.use_fn_validation;
var output_schema26123_26129 = cljs.core.PersistentArrayMap.fromArray([schema.core.Keyword,schema.core.Bool], true, false);
var input_schema26124_26130 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Any,cljs.core.with_meta(cljs.core.cst$sym$s,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any], null)))], null);
var input_checker26125_26131 = schema.core.checker(input_schema26124_26130);
var output_checker26126_26132 = schema.core.checker(output_schema26123_26129);
/**
 * Inputs: [s]
 *   Returns: {s/Keyword s/Bool}
 * 
 *   Given a possibly-unevaluated map schema, return a map from bare keyword to true
 * (for required) or false (for optional)
 */
plumbing.fnk.schema.explicit_schema_key_map = ((function (ufv___26128,output_schema26123_26129,input_schema26124_26130,input_checker26125_26131,output_checker26126_26132){
return (function plumbing$fnk$schema$explicit_schema_key_map(G__26127){
var validate__8403__auto__ = ufv___26128.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___26133 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__26127], null);
var temp__4425__auto___26134 = (input_checker26125_26131.cljs$core$IFn$_invoke$arity$1 ? input_checker26125_26131.cljs$core$IFn$_invoke$arity$1(args__8404__auto___26133) : input_checker26125_26131.call(null,args__8404__auto___26133));
if(cljs.core.truth_(temp__4425__auto___26134)){
var error__8405__auto___26135 = temp__4425__auto___26134;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$explicit_DASH_schema_DASH_key_DASH_map,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$sym$s_SLASH_Keyword,cljs.core.cst$sym$s_SLASH_Bool], null),cljs.core.cst$kw$doc,"Given a possibly-unevaluated map schema, return a map from bare keyword to true\n   (for required) or false (for optional)"], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26135], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema26124_26130,cljs.core.cst$kw$value,args__8404__auto___26133,cljs.core.cst$kw$error,error__8405__auto___26135], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var s = G__26127;
while(true){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,cljs.core.keep.cljs$core$IFn$_invoke$arity$2(plumbing.fnk.schema.unwrap_schema_form_key,cljs.core.keys(s)));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___26136 = (output_checker26126_26132.cljs$core$IFn$_invoke$arity$1 ? output_checker26126_26132.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker26126_26132.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___26136)){
var error__8405__auto___26137 = temp__4425__auto___26136;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$explicit_DASH_schema_DASH_key_DASH_map,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$sym$s_SLASH_Keyword,cljs.core.cst$sym$s_SLASH_Bool], null),cljs.core.cst$kw$doc,"Given a possibly-unevaluated map schema, return a map from bare keyword to true\n   (for required) or false (for optional)"], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26137], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema26123_26129,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___26137], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___26128,output_schema26123_26129,input_schema26124_26130,input_checker26125_26131,output_checker26126_26132))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(plumbing.fnk.schema.explicit_schema_key_map),schema.core.make_fn_schema(output_schema26123_26129,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema26124_26130], null)));
var ufv___26143 = schema.utils.use_fn_validation;
var output_schema26138_26144 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.Keyword], null),cljs.core.cst$sym$required),schema.core.one(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.Keyword], null),cljs.core.cst$sym$optional)], null);
var input_schema26139_26145 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(cljs.core.PersistentArrayMap.fromArray([schema.core.Keyword,schema.core.Bool], true, false),cljs.core.with_meta(cljs.core.cst$sym$s,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$sym$s_SLASH_Keyword,cljs.core.cst$sym$s_SLASH_Bool], null)], null)))], null);
var input_checker26140_26146 = schema.core.checker(input_schema26139_26145);
var output_checker26141_26147 = schema.core.checker(output_schema26138_26144);
/**
 * Inputs: [s :- {s/Keyword s/Bool}]
 *   Returns: [(s/one [s/Keyword] (quote required)) (s/one [s/Keyword] (quote optional))]
 * 
 *   Given output of explicit-schema-key-map, split into seq [req opt].
 */
plumbing.fnk.schema.split_schema_keys = ((function (ufv___26143,output_schema26138_26144,input_schema26139_26145,input_checker26140_26146,output_checker26141_26147){
return (function plumbing$fnk$schema$split_schema_keys(G__26142){
var validate__8403__auto__ = ufv___26143.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___26148 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__26142], null);
var temp__4425__auto___26149 = (input_checker26140_26146.cljs$core$IFn$_invoke$arity$1 ? input_checker26140_26146.cljs$core$IFn$_invoke$arity$1(args__8404__auto___26148) : input_checker26140_26146.call(null,args__8404__auto___26148));
if(cljs.core.truth_(temp__4425__auto___26149)){
var error__8405__auto___26150 = temp__4425__auto___26149;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$split_DASH_schema_DASH_keys,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.list(cljs.core.cst$sym$s_SLASH_one,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Keyword], null),cljs.core.list(cljs.core.cst$sym$quote,cljs.core.cst$sym$required)),cljs.core.list(cljs.core.cst$sym$s_SLASH_one,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Keyword], null),cljs.core.list(cljs.core.cst$sym$quote,cljs.core.cst$sym$optional))], null),cljs.core.cst$kw$doc,"Given output of explicit-schema-key-map, split into seq [req opt]."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26150], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema26139_26145,cljs.core.cst$kw$value,args__8404__auto___26148,cljs.core.cst$kw$error,error__8405__auto___26150], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var s = G__26142;
while(true){
return cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.mapv,cljs.core.key),cljs.core.juxt.cljs$core$IFn$_invoke$arity$2(cljs.core.filter,cljs.core.remove).call(null,cljs.core.val,s));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___26151 = (output_checker26141_26147.cljs$core$IFn$_invoke$arity$1 ? output_checker26141_26147.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker26141_26147.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___26151)){
var error__8405__auto___26152 = temp__4425__auto___26151;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$split_DASH_schema_DASH_keys,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.list(cljs.core.cst$sym$s_SLASH_one,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Keyword], null),cljs.core.list(cljs.core.cst$sym$quote,cljs.core.cst$sym$required)),cljs.core.list(cljs.core.cst$sym$s_SLASH_one,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Keyword], null),cljs.core.list(cljs.core.cst$sym$quote,cljs.core.cst$sym$optional))], null),cljs.core.cst$kw$doc,"Given output of explicit-schema-key-map, split into seq [req opt]."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26152], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema26138_26144,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___26152], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___26143,output_schema26138_26144,input_schema26139_26145,input_checker26140_26146,output_checker26141_26147))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(plumbing.fnk.schema.split_schema_keys),schema.core.make_fn_schema(output_schema26138_26144,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema26139_26145], null)));
/**
 * Like merge-with, but also projects keys to a smaller space and merges them similar to the
 * values.
 */
plumbing.fnk.schema.merge_on_with = (function plumbing$fnk$schema$merge_on_with(var_args){
var args__5577__auto__ = [];
var len__5570__auto___26160 = arguments.length;
var i__5571__auto___26161 = (0);
while(true){
if((i__5571__auto___26161 < len__5570__auto___26160)){
args__5577__auto__.push((arguments[i__5571__auto___26161]));

var G__26162 = (i__5571__auto___26161 + (1));
i__5571__auto___26161 = G__26162;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((3) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((3)),(0))):null);
return plumbing.fnk.schema.merge_on_with.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5578__auto__);
});

plumbing.fnk.schema.merge_on_with.cljs$core$IFn$_invoke$arity$variadic = (function (key_project,key_combine,val_combine,maps){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,cljs.core.vals(cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (m,p__26157){
var vec__26158 = p__26157;
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26158,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26158,(1),null);
var pk = (key_project.cljs$core$IFn$_invoke$arity$1 ? key_project.cljs$core$IFn$_invoke$arity$1(k) : key_project.call(null,k));
var temp__4423__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(m,pk);
if(cljs.core.truth_(temp__4423__auto__)){
var vec__26159 = temp__4423__auto__;
var ok = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26159,(0),null);
var ov = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26159,(1),null);
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,pk,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(key_combine.cljs$core$IFn$_invoke$arity$2 ? key_combine.cljs$core$IFn$_invoke$arity$2(ok,k) : key_combine.call(null,ok,k)),(val_combine.cljs$core$IFn$_invoke$arity$2 ? val_combine.cljs$core$IFn$_invoke$arity$2(ov,v) : val_combine.call(null,ov,v))], null));
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,pk,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,v], null));
}
}),cljs.core.PersistentArrayMap.EMPTY,cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,maps))));
});

plumbing.fnk.schema.merge_on_with.cljs$lang$maxFixedArity = (3);

plumbing.fnk.schema.merge_on_with.cljs$lang$applyTo = (function (seq26153){
var G__26154 = cljs.core.first(seq26153);
var seq26153__$1 = cljs.core.next(seq26153);
var G__26155 = cljs.core.first(seq26153__$1);
var seq26153__$2 = cljs.core.next(seq26153__$1);
var G__26156 = cljs.core.first(seq26153__$2);
var seq26153__$3 = cljs.core.next(seq26153__$2);
return plumbing.fnk.schema.merge_on_with.cljs$core$IFn$_invoke$arity$variadic(G__26154,G__26155,G__26156,seq26153__$3);
});
var ufv___26170 = schema.utils.use_fn_validation;
var output_schema26164_26171 = plumbing.fnk.schema.InputSchema;
var input_schema26165_26172 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(plumbing.fnk.schema.InputSchema,cljs.core.with_meta(cljs.core.cst$sym$i1,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$InputSchema], null))),schema.core.one(plumbing.fnk.schema.InputSchema,cljs.core.with_meta(cljs.core.cst$sym$i2,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$InputSchema], null)))], null);
var input_checker26166_26173 = schema.core.checker(input_schema26165_26172);
var output_checker26167_26174 = schema.core.checker(output_schema26164_26171);
/**
 * Inputs: [i1 :- InputSchema i2 :- InputSchema]
 *   Returns: InputSchema
 * 
 *   Returns a minimal input schema schema that entails satisfaction of both s1 and s2
 */
plumbing.fnk.schema.union_input_schemata = ((function (ufv___26170,output_schema26164_26171,input_schema26165_26172,input_checker26166_26173,output_checker26167_26174){
return (function plumbing$fnk$schema$union_input_schemata(G__26168,G__26169){
var validate__8403__auto__ = ufv___26170.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___26175 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__26168,G__26169], null);
var temp__4425__auto___26176 = (input_checker26166_26173.cljs$core$IFn$_invoke$arity$1 ? input_checker26166_26173.cljs$core$IFn$_invoke$arity$1(args__8404__auto___26175) : input_checker26166_26173.call(null,args__8404__auto___26175));
if(cljs.core.truth_(temp__4425__auto___26176)){
var error__8405__auto___26177 = temp__4425__auto___26176;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$union_DASH_input_DASH_schemata,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$InputSchema,cljs.core.cst$kw$doc,"Returns a minimal input schema schema that entails satisfaction of both s1 and s2"], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26177], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema26165_26172,cljs.core.cst$kw$value,args__8404__auto___26175,cljs.core.cst$kw$error,error__8405__auto___26177], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var i1 = G__26168;
var i2 = G__26169;
while(true){
return plumbing.fnk.schema.merge_on_with.cljs$core$IFn$_invoke$arity$variadic(((function (validate__8403__auto__,ufv___26170,output_schema26164_26171,input_schema26165_26172,input_checker26166_26173,output_checker26167_26174){
return (function (p1__26163_SHARP_){
if(cljs.core.truth_(schema.core.specific_key_QMARK_(p1__26163_SHARP_))){
return schema.core.explicit_schema_key(p1__26163_SHARP_);
} else {
return cljs.core.cst$kw$extra;
}
});})(validate__8403__auto__,ufv___26170,output_schema26164_26171,input_schema26165_26172,input_checker26166_26173,output_checker26167_26174))
,((function (validate__8403__auto__,ufv___26170,output_schema26164_26171,input_schema26165_26172,input_checker26166_26173,output_checker26167_26174){
return (function (k1,k2){
if(cljs.core.truth_(schema.core.required_key_QMARK_(k1))){
return k1;
} else {
if(cljs.core.truth_(schema.core.required_key_QMARK_(k2))){
return k2;
} else {
if(cljs.core.truth_(schema.core.optional_key_QMARK_(k1))){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(k1,k2)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(cljs.core.cst$sym$_EQ_,cljs.core.cst$sym$k1,cljs.core.cst$sym$k2)], 0)))].join('')));
}

return k1;
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(k1,k2)){
return k1;
} else {
throw (new Error(schema.utils.format_STAR_("Only one extra schema allowed")));


}
}
}
}
});})(validate__8403__auto__,ufv___26170,output_schema26164_26171,input_schema26165_26172,input_checker26166_26173,output_checker26167_26174))
,((function (validate__8403__auto__,ufv___26170,output_schema26164_26171,input_schema26165_26172,input_checker26166_26173,output_checker26167_26174){
return (function (s1,s2){
if(cljs.core.truth_((function (){var and__4500__auto__ = plumbing.fnk.schema.map_schema_QMARK_(s1);
if(cljs.core.truth_(and__4500__auto__)){
return plumbing.fnk.schema.map_schema_QMARK_(s2);
} else {
return and__4500__auto__;
}
})())){
return plumbing$fnk$schema$union_input_schemata(s1,s2);
} else {
return plumbing.fnk.schema.non_map_union(s1,s2);
}
});})(validate__8403__auto__,ufv___26170,output_schema26164_26171,input_schema26165_26172,input_checker26166_26173,output_checker26167_26174))
,cljs.core.array_seq([i1,i2], 0));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___26178 = (output_checker26167_26174.cljs$core$IFn$_invoke$arity$1 ? output_checker26167_26174.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker26167_26174.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___26178)){
var error__8405__auto___26179 = temp__4425__auto___26178;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$union_DASH_input_DASH_schemata,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$InputSchema,cljs.core.cst$kw$doc,"Returns a minimal input schema schema that entails satisfaction of both s1 and s2"], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26179], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema26164_26171,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___26179], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___26170,output_schema26164_26171,input_schema26165_26172,input_checker26166_26173,output_checker26167_26174))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(plumbing.fnk.schema.union_input_schemata),schema.core.make_fn_schema(output_schema26164_26171,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema26165_26172], null)));
var ufv___26185 = schema.utils.use_fn_validation;
var output_schema26180_26186 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.Keyword], null);
var input_schema26181_26187 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(plumbing.fnk.schema.InputSchema,cljs.core.with_meta(cljs.core.cst$sym$input_DASH_schema,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$InputSchema], null)))], null);
var input_checker26182_26188 = schema.core.checker(input_schema26181_26187);
var output_checker26183_26189 = schema.core.checker(output_schema26180_26186);
/**
 * Inputs: [input-schema :- InputSchema]
 *   Returns: [s/Keyword]
 * 
 *   Which top-level keys are required (i.e., non-false) by this input schema.
 */
plumbing.fnk.schema.required_toplevel_keys = ((function (ufv___26185,output_schema26180_26186,input_schema26181_26187,input_checker26182_26188,output_checker26183_26189){
return (function plumbing$fnk$schema$required_toplevel_keys(G__26184){
var validate__8403__auto__ = ufv___26185.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___26190 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__26184], null);
var temp__4425__auto___26191 = (input_checker26182_26188.cljs$core$IFn$_invoke$arity$1 ? input_checker26182_26188.cljs$core$IFn$_invoke$arity$1(args__8404__auto___26190) : input_checker26182_26188.call(null,args__8404__auto___26190));
if(cljs.core.truth_(temp__4425__auto___26191)){
var error__8405__auto___26192 = temp__4425__auto___26191;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$required_DASH_toplevel_DASH_keys,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Keyword], null),cljs.core.cst$kw$doc,"Which top-level keys are required (i.e., non-false) by this input schema."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26192], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema26181_26187,cljs.core.cst$kw$value,args__8404__auto___26190,cljs.core.cst$kw$error,error__8405__auto___26192], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var input_schema = G__26184;
while(true){
return cljs.core.keep.cljs$core$IFn$_invoke$arity$2(((function (validate__8403__auto__,ufv___26185,output_schema26180_26186,input_schema26181_26187,input_checker26182_26188,output_checker26183_26189){
return (function (k){
if(cljs.core.truth_(schema.core.required_key_QMARK_(k))){
return schema.core.explicit_schema_key(k);
} else {
return null;
}
});})(validate__8403__auto__,ufv___26185,output_schema26180_26186,input_schema26181_26187,input_checker26182_26188,output_checker26183_26189))
,cljs.core.keys(input_schema));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___26193 = (output_checker26183_26189.cljs$core$IFn$_invoke$arity$1 ? output_checker26183_26189.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker26183_26189.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___26193)){
var error__8405__auto___26194 = temp__4425__auto___26193;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$required_DASH_toplevel_DASH_keys,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Keyword], null),cljs.core.cst$kw$doc,"Which top-level keys are required (i.e., non-false) by this input schema."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26194], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema26180_26186,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___26194], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___26185,output_schema26180_26186,input_schema26181_26187,input_checker26182_26188,output_checker26183_26189))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(plumbing.fnk.schema.required_toplevel_keys),schema.core.make_fn_schema(output_schema26180_26186,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema26181_26187], null)));
/**
 * Guess an output schema for an expr.  Currently just looks for literal map structure and
 * all keyword keys.
 */
plumbing.fnk.schema.guess_expr_output_schema = (function plumbing$fnk$schema$guess_expr_output_schema(expr){
if((cljs.core.map_QMARK_(expr)) && (cljs.core.every_QMARK_(cljs.core.keyword_QMARK_,cljs.core.keys(expr)))){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,(function (){var iter__5284__auto__ = (function plumbing$fnk$schema$guess_expr_output_schema_$_iter__26205(s__26206){
return (new cljs.core.LazySeq(null,(function (){
var s__26206__$1 = s__26206;
while(true){
var temp__4425__auto__ = cljs.core.seq(s__26206__$1);
if(temp__4425__auto__){
var s__26206__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_(s__26206__$2)){
var c__5282__auto__ = cljs.core.chunk_first(s__26206__$2);
var size__5283__auto__ = cljs.core.count(c__5282__auto__);
var b__26208 = cljs.core.chunk_buffer(size__5283__auto__);
if((function (){var i__26207 = (0);
while(true){
if((i__26207 < size__5283__auto__)){
var vec__26213 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__5282__auto__,i__26207);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26213,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26213,(1),null);
cljs.core.chunk_append(b__26208,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,plumbing$fnk$schema$guess_expr_output_schema(v)], null));

var G__26215 = (i__26207 + (1));
i__26207 = G__26215;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__26208),plumbing$fnk$schema$guess_expr_output_schema_$_iter__26205(cljs.core.chunk_rest(s__26206__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__26208),null);
}
} else {
var vec__26214 = cljs.core.first(s__26206__$2);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26214,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26214,(1),null);
return cljs.core.cons(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,plumbing$fnk$schema$guess_expr_output_schema(v)], null),plumbing$fnk$schema$guess_expr_output_schema_$_iter__26205(cljs.core.rest(s__26206__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__5284__auto__(expr);
})());
} else {
return cljs.core.cst$sym$schema$core_SLASH_Any;
}
});
/**
 * Subtract output-schema from input-schema, returning nil if it's possible that an object
 * satisfying the output-schema satisfies the input-schema, or otherwise a description
 * of the part(s) of input-schema not met by output-schema.  Strict about the map structure
 * of output-schema matching input-schema, but loose about everything else (only looks at
 * required keys of output-schema.
 */
plumbing.fnk.schema.schema_diff = (function plumbing$fnk$schema$schema_diff(input_schema,output_schema){
if(cljs.core.not(plumbing.fnk.schema.map_schema_QMARK_(input_schema))){
return plumbing.fnk.schema.non_map_diff(input_schema,output_schema);
} else {
if(cljs.core.not(plumbing.fnk.schema.map_schema_QMARK_(output_schema))){
return schema.utils.error(schema.utils.__GT_ValidationError(input_schema,output_schema,(new cljs.core.Delay((function (){
return cljs.core._conj(cljs.core._conj(cljs.core.List.EMPTY,schema.core.explain(output_schema)),cljs.core.cst$sym$map_QMARK_);
}),null)),null));
} else {
return cljs.core.not_empty(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,(function (){var iter__5284__auto__ = (function plumbing$fnk$schema$schema_diff_$_iter__26234(s__26235){
return (new cljs.core.LazySeq(null,(function (){
var s__26235__$1 = s__26235;
while(true){
var temp__4425__auto__ = cljs.core.seq(s__26235__$1);
if(temp__4425__auto__){
var s__26235__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_(s__26235__$2)){
var c__5282__auto__ = cljs.core.chunk_first(s__26235__$2);
var size__5283__auto__ = cljs.core.count(c__5282__auto__);
var b__26237 = cljs.core.chunk_buffer(size__5283__auto__);
if((function (){var i__26236 = (0);
while(true){
if((i__26236 < size__5283__auto__)){
var vec__26242 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__5282__auto__,i__26236);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26242,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26242,(1),null);
if(cljs.core.truth_(schema.core.specific_key_QMARK_(k))){
var required_QMARK_ = schema.core.required_key_QMARK_(k);
var raw_k = schema.core.explicit_schema_key(k);
var present_QMARK_ = cljs.core.contains_QMARK_(output_schema,raw_k);
if(cljs.core.truth_((function (){var or__4512__auto__ = required_QMARK_;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return present_QMARK_;
}
})())){
var fail = ((!(present_QMARK_))?cljs.core.cst$sym$missing_DASH_required_DASH_key:plumbing$fnk$schema$schema_diff(v,cljs.core.get.cljs$core$IFn$_invoke$arity$2(output_schema,raw_k)));
if(cljs.core.truth_(fail)){
cljs.core.chunk_append(b__26237,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,fail], null));

var G__26244 = (i__26236 + (1));
i__26236 = G__26244;
continue;
} else {
var G__26245 = (i__26236 + (1));
i__26236 = G__26245;
continue;
}
} else {
var G__26246 = (i__26236 + (1));
i__26236 = G__26246;
continue;
}
} else {
var G__26247 = (i__26236 + (1));
i__26236 = G__26247;
continue;
}
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__26237),plumbing$fnk$schema$schema_diff_$_iter__26234(cljs.core.chunk_rest(s__26235__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__26237),null);
}
} else {
var vec__26243 = cljs.core.first(s__26235__$2);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26243,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26243,(1),null);
if(cljs.core.truth_(schema.core.specific_key_QMARK_(k))){
var required_QMARK_ = schema.core.required_key_QMARK_(k);
var raw_k = schema.core.explicit_schema_key(k);
var present_QMARK_ = cljs.core.contains_QMARK_(output_schema,raw_k);
if(cljs.core.truth_((function (){var or__4512__auto__ = required_QMARK_;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return present_QMARK_;
}
})())){
var fail = ((!(present_QMARK_))?cljs.core.cst$sym$missing_DASH_required_DASH_key:plumbing$fnk$schema$schema_diff(v,cljs.core.get.cljs$core$IFn$_invoke$arity$2(output_schema,raw_k)));
if(cljs.core.truth_(fail)){
return cljs.core.cons(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,fail], null),plumbing$fnk$schema$schema_diff_$_iter__26234(cljs.core.rest(s__26235__$2)));
} else {
var G__26248 = cljs.core.rest(s__26235__$2);
s__26235__$1 = G__26248;
continue;
}
} else {
var G__26249 = cljs.core.rest(s__26235__$2);
s__26235__$1 = G__26249;
continue;
}
} else {
var G__26250 = cljs.core.rest(s__26235__$2);
s__26235__$1 = G__26250;
continue;
}
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__5284__auto__(input_schema);
})()));

}
}
});
plumbing.fnk.schema.assert_satisfies_schema = (function plumbing$fnk$schema$assert_satisfies_schema(input_schema,output_schema){
var fails = plumbing.fnk.schema.schema_diff(input_schema,output_schema);
if(cljs.core.truth_(fails)){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2([cljs.core.str(fails)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$error,cljs.core.cst$kw$does_DASH_not_DASH_satisfy_DASH_schema,cljs.core.cst$kw$failures,fails], null));
} else {
return null;
}
});
var ufv___26273 = schema.utils.use_fn_validation;
var output_schema26251_26274 = schema.core.Any;
var input_schema26252_26275 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(plumbing.fnk.schema.IOSchemata,cljs.core.cst$sym$arg0),schema.core.one(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(plumbing.fnk.schema.InputSchema,cljs.core.cst$sym$input),schema.core.one(plumbing.fnk.schema.MapOutputSchema,cljs.core.cst$sym$output)], null),cljs.core.cst$sym$arg1)], null);
var input_checker26253_26276 = schema.core.checker(input_schema26252_26275);
var output_checker26254_26277 = schema.core.checker(output_schema26251_26274);
/**
 * Inputs: [[i2 o2] :- IOSchemata [i1 o1] :- [(s/one InputSchema (quote input)) (s/one MapOutputSchema (quote output))]]
 * 
 *   Given pairs of input and output schemata for fnks f1 and f2,
 * return a pair of input and output schemata for #(f2 (merge % (f1 %))).
 * f1's output schema must not contain any optional keys.
 */
plumbing.fnk.schema.compose_schemata = ((function (ufv___26273,output_schema26251_26274,input_schema26252_26275,input_checker26253_26276,output_checker26254_26277){
return (function plumbing$fnk$schema$compose_schemata(G__26255,G__26256){
var validate__8403__auto__ = true;
if(validate__8403__auto__){
var args__8404__auto___26278 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__26255,G__26256], null);
var temp__4425__auto___26279 = (input_checker26253_26276.cljs$core$IFn$_invoke$arity$1 ? input_checker26253_26276.cljs$core$IFn$_invoke$arity$1(args__8404__auto___26278) : input_checker26253_26276.call(null,args__8404__auto___26278));
if(cljs.core.truth_(temp__4425__auto___26279)){
var error__8405__auto___26280 = temp__4425__auto___26279;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$compose_DASH_schemata,new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$always_DASH_validate,true,cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"Given pairs of input and output schemata for fnks f1 and f2,\n   return a pair of input and output schemata for #(f2 (merge % (f1 %))).\n   f1's output schema must not contain any optional keys."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26280], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema26252_26275,cljs.core.cst$kw$value,args__8404__auto___26278,cljs.core.cst$kw$error,error__8405__auto___26280], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__26267 = G__26255;
var vec__26269 = G__26267;
var i2 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26269,(0),null);
var o2 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26269,(1),null);
var G__26268 = G__26256;
var vec__26270 = G__26268;
var i1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26270,(0),null);
var o1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26270,(1),null);
var G__26267__$1 = G__26267;
var G__26268__$1 = G__26268;
while(true){
var vec__26271 = G__26267__$1;
var i2__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26271,(0),null);
var o2__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26271,(1),null);
var vec__26272 = G__26268__$1;
var i1__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26272,(0),null);
var o1__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26272,(1),null);
plumbing.fnk.schema.assert_satisfies_schema(cljs.core.select_keys(i2__$1,cljs.core.keys(o1__$1)),o1__$1);

return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [plumbing.fnk.schema.union_input_schemata(cljs.core.apply.cljs$core$IFn$_invoke$arity$3(cljs.core.dissoc,i2__$1,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(cljs.core.keys(o1__$1),cljs.core.map.cljs$core$IFn$_invoke$arity$2(schema.core.optional_key,cljs.core.keys(o1__$1)))),i1__$1),o2__$1], null);
break;
}
})();
if(validate__8403__auto__){
var temp__4425__auto___26281 = (output_checker26254_26277.cljs$core$IFn$_invoke$arity$1 ? output_checker26254_26277.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker26254_26277.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___26281)){
var error__8405__auto___26282 = temp__4425__auto___26281;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$compose_DASH_schemata,new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$always_DASH_validate,true,cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"Given pairs of input and output schemata for fnks f1 and f2,\n   return a pair of input and output schemata for #(f2 (merge % (f1 %))).\n   f1's output schema must not contain any optional keys."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26282], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema26251_26274,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___26282], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___26273,output_schema26251_26274,input_schema26252_26275,input_checker26253_26276,output_checker26254_26277))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(plumbing.fnk.schema.compose_schemata),schema.core.make_fn_schema(output_schema26251_26274,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema26252_26275], null)));
plumbing.fnk.schema.schema_key = (function plumbing$fnk$schema$schema_key(m,k){
if(cljs.core.contains_QMARK_(m,k)){
return k;
} else {
if(cljs.core.contains_QMARK_(m,schema.core.optional_key(k))){
return schema.core.optional_key(k);
} else {
return null;

}
}
});
plumbing.fnk.schema.possibly_contains_QMARK_ = (function plumbing$fnk$schema$possibly_contains_QMARK_(m,k){
return cljs.core.boolean$(plumbing.fnk.schema.schema_key(m,k));
});
var ufv___26381 = schema.utils.use_fn_validation;
var output_schema26283_26382 = schema.core.Any;
var input_schema26284_26383 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(plumbing.fnk.schema.InputSchema,cljs.core.with_meta(cljs.core.cst$sym$s,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,cljs.core.cst$sym$InputSchema], null))),schema.core.one(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.Keyword], null),cljs.core.with_meta(cljs.core.cst$sym$ks,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$schema,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$s_SLASH_Keyword], null)], null)))], null);
var input_checker26285_26384 = schema.core.checker(input_schema26284_26383);
var output_checker26286_26385 = schema.core.checker(output_schema26283_26382);
/**
 * Inputs: [s :- InputSchema ks :- [s/Keyword]]
 * 
 *   Return a pair [ks-part non-ks-part], with any extra schema removed.
 */
plumbing.fnk.schema.split_schema = ((function (ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385){
return (function plumbing$fnk$schema$split_schema(G__26287,G__26288){
var validate__8403__auto__ = ufv___26381.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___26386 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__26287,G__26288], null);
var temp__4425__auto___26387 = (input_checker26285_26384.cljs$core$IFn$_invoke$arity$1 ? input_checker26285_26384.cljs$core$IFn$_invoke$arity$1(args__8404__auto___26386) : input_checker26285_26384.call(null,args__8404__auto___26386));
if(cljs.core.truth_(temp__4425__auto___26387)){
var error__8405__auto___26388 = temp__4425__auto___26387;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$split_DASH_schema,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"Return a pair [ks-part non-ks-part], with any extra schema removed."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26388], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema26284_26383,cljs.core.cst$kw$value,args__8404__auto___26386,cljs.core.cst$kw$error,error__8405__auto___26388], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var s = G__26287;
var ks = G__26288;
while(true){
var ks__$1 = cljs.core.set(ks);
var iter__5284__auto__ = ((function (ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385){
return (function plumbing$fnk$schema$split_schema_$_iter__26335(s__26336){
return (new cljs.core.LazySeq(null,((function (ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385){
return (function (){
var s__26336__$1 = s__26336;
while(true){
var temp__4425__auto__ = cljs.core.seq(s__26336__$1);
if(temp__4425__auto__){
var s__26336__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_(s__26336__$2)){
var c__5282__auto__ = cljs.core.chunk_first(s__26336__$2);
var size__5283__auto__ = cljs.core.count(c__5282__auto__);
var b__26338 = cljs.core.chunk_buffer(size__5283__auto__);
if((function (){var i__26337 = (0);
while(true){
if((i__26337 < size__5283__auto__)){
var in_QMARK_ = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__5282__auto__,i__26337);
cljs.core.chunk_append(b__26338,cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,(function (){var iter__5284__auto__ = ((function (i__26337,in_QMARK_,c__5282__auto__,size__5283__auto__,b__26338,s__26336__$2,temp__4425__auto__,ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385){
return (function plumbing$fnk$schema$split_schema_$_iter__26335_$_iter__26361(s__26362){
return (new cljs.core.LazySeq(null,((function (i__26337,in_QMARK_,c__5282__auto__,size__5283__auto__,b__26338,s__26336__$2,temp__4425__auto__,ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385){
return (function (){
var s__26362__$1 = s__26362;
while(true){
var temp__4425__auto____$1 = cljs.core.seq(s__26362__$1);
if(temp__4425__auto____$1){
var s__26362__$2 = temp__4425__auto____$1;
if(cljs.core.chunked_seq_QMARK_(s__26362__$2)){
var c__5282__auto____$1 = cljs.core.chunk_first(s__26362__$2);
var size__5283__auto____$1 = cljs.core.count(c__5282__auto____$1);
var b__26364 = cljs.core.chunk_buffer(size__5283__auto____$1);
if((function (){var i__26363 = (0);
while(true){
if((i__26363 < size__5283__auto____$1)){
var vec__26369 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__5282__auto____$1,i__26363);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26369,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26369,(1),null);
if(cljs.core.truth_((function (){var and__4500__auto__ = schema.core.specific_key_QMARK_(k);
if(cljs.core.truth_(and__4500__auto__)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(in_QMARK_,cljs.core.contains_QMARK_(ks__$1,schema.core.explicit_schema_key(k)));
} else {
return and__4500__auto__;
}
})())){
cljs.core.chunk_append(b__26364,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,v], null));

var G__26389 = (i__26363 + (1));
i__26363 = G__26389;
continue;
} else {
var G__26390 = (i__26363 + (1));
i__26363 = G__26390;
continue;
}
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__26364),plumbing$fnk$schema$split_schema_$_iter__26335_$_iter__26361(cljs.core.chunk_rest(s__26362__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__26364),null);
}
} else {
var vec__26370 = cljs.core.first(s__26362__$2);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26370,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26370,(1),null);
if(cljs.core.truth_((function (){var and__4500__auto__ = schema.core.specific_key_QMARK_(k);
if(cljs.core.truth_(and__4500__auto__)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(in_QMARK_,cljs.core.contains_QMARK_(ks__$1,schema.core.explicit_schema_key(k)));
} else {
return and__4500__auto__;
}
})())){
return cljs.core.cons(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,v], null),plumbing$fnk$schema$split_schema_$_iter__26335_$_iter__26361(cljs.core.rest(s__26362__$2)));
} else {
var G__26391 = cljs.core.rest(s__26362__$2);
s__26362__$1 = G__26391;
continue;
}
}
} else {
return null;
}
break;
}
});})(i__26337,in_QMARK_,c__5282__auto__,size__5283__auto__,b__26338,s__26336__$2,temp__4425__auto__,ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385))
,null,null));
});})(i__26337,in_QMARK_,c__5282__auto__,size__5283__auto__,b__26338,s__26336__$2,temp__4425__auto__,ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385))
;
return iter__5284__auto__(s);
})()));

var G__26392 = (i__26337 + (1));
i__26337 = G__26392;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__26338),plumbing$fnk$schema$split_schema_$_iter__26335(cljs.core.chunk_rest(s__26336__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__26338),null);
}
} else {
var in_QMARK_ = cljs.core.first(s__26336__$2);
return cljs.core.cons(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,(function (){var iter__5284__auto__ = ((function (in_QMARK_,s__26336__$2,temp__4425__auto__,ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385){
return (function plumbing$fnk$schema$split_schema_$_iter__26335_$_iter__26371(s__26372){
return (new cljs.core.LazySeq(null,((function (in_QMARK_,s__26336__$2,temp__4425__auto__,ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385){
return (function (){
var s__26372__$1 = s__26372;
while(true){
var temp__4425__auto____$1 = cljs.core.seq(s__26372__$1);
if(temp__4425__auto____$1){
var s__26372__$2 = temp__4425__auto____$1;
if(cljs.core.chunked_seq_QMARK_(s__26372__$2)){
var c__5282__auto__ = cljs.core.chunk_first(s__26372__$2);
var size__5283__auto__ = cljs.core.count(c__5282__auto__);
var b__26374 = cljs.core.chunk_buffer(size__5283__auto__);
if((function (){var i__26373 = (0);
while(true){
if((i__26373 < size__5283__auto__)){
var vec__26379 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__5282__auto__,i__26373);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26379,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26379,(1),null);
if(cljs.core.truth_((function (){var and__4500__auto__ = schema.core.specific_key_QMARK_(k);
if(cljs.core.truth_(and__4500__auto__)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(in_QMARK_,cljs.core.contains_QMARK_(ks__$1,schema.core.explicit_schema_key(k)));
} else {
return and__4500__auto__;
}
})())){
cljs.core.chunk_append(b__26374,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,v], null));

var G__26393 = (i__26373 + (1));
i__26373 = G__26393;
continue;
} else {
var G__26394 = (i__26373 + (1));
i__26373 = G__26394;
continue;
}
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__26374),plumbing$fnk$schema$split_schema_$_iter__26335_$_iter__26371(cljs.core.chunk_rest(s__26372__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__26374),null);
}
} else {
var vec__26380 = cljs.core.first(s__26372__$2);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26380,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26380,(1),null);
if(cljs.core.truth_((function (){var and__4500__auto__ = schema.core.specific_key_QMARK_(k);
if(cljs.core.truth_(and__4500__auto__)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(in_QMARK_,cljs.core.contains_QMARK_(ks__$1,schema.core.explicit_schema_key(k)));
} else {
return and__4500__auto__;
}
})())){
return cljs.core.cons(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [k,v], null),plumbing$fnk$schema$split_schema_$_iter__26335_$_iter__26371(cljs.core.rest(s__26372__$2)));
} else {
var G__26395 = cljs.core.rest(s__26372__$2);
s__26372__$1 = G__26395;
continue;
}
}
} else {
return null;
}
break;
}
});})(in_QMARK_,s__26336__$2,temp__4425__auto__,ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385))
,null,null));
});})(in_QMARK_,s__26336__$2,temp__4425__auto__,ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385))
;
return iter__5284__auto__(s);
})()),plumbing$fnk$schema$split_schema_$_iter__26335(cljs.core.rest(s__26336__$2)));
}
} else {
return null;
}
break;
}
});})(ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385))
,null,null));
});})(ks__$1,validate__8403__auto__,ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385))
;
return iter__5284__auto__(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [true,false], null));
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___26396 = (output_checker26286_26385.cljs$core$IFn$_invoke$arity$1 ? output_checker26286_26385.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker26286_26385.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___26396)){
var error__8405__auto___26397 = temp__4425__auto___26396;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$split_DASH_schema,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$schema$core_SLASH_Any,cljs.core.cst$kw$doc,"Return a pair [ks-part non-ks-part], with any extra schema removed."], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26397], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema26283_26382,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___26397], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___26381,output_schema26283_26382,input_schema26284_26383,input_checker26285_26384,output_checker26286_26385))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(plumbing.fnk.schema.split_schema),schema.core.make_fn_schema(output_schema26283_26382,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema26284_26383], null)));
var ufv___26428 = schema.utils.use_fn_validation;
var output_schema26398_26429 = plumbing.fnk.schema.GraphIOSchemata;
var input_schema26399_26430 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(plumbing.fnk.schema.GraphIOSchemata,cljs.core.cst$sym$arg0),schema.core.one(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema.core.one(schema.core.Keyword,"key"),schema.core.one(plumbing.fnk.schema.IOSchemata,"inner-schemas")], null),cljs.core.cst$sym$arg1)], null);
var input_checker26400_26431 = schema.core.checker(input_schema26399_26430);
var output_checker26401_26432 = schema.core.checker(output_schema26398_26429);
/**
 * Inputs: [[i1 o1] :- GraphIOSchemata [k [i2 o2]] :- [(s/one s/Keyword "key") (s/one IOSchemata "inner-schemas")]]
 *   Returns: GraphIOSchemata
 * 
 *   Given pairs of input and output schemata for fnks f1 and f2, and a keyword k,
 * return a pair of input and output schemata for #(let [v1 (f1 %)] (assoc v1 k (f2 (merge-disjoint % v1))))
 */
plumbing.fnk.schema.sequence_schemata = ((function (ufv___26428,output_schema26398_26429,input_schema26399_26430,input_checker26400_26431,output_checker26401_26432){
return (function plumbing$fnk$schema$sequence_schemata(G__26402,G__26403){
var validate__8403__auto__ = ufv___26428.get_cell();
if(cljs.core.truth_(validate__8403__auto__)){
var args__8404__auto___26433 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [G__26402,G__26403], null);
var temp__4425__auto___26434 = (input_checker26400_26431.cljs$core$IFn$_invoke$arity$1 ? input_checker26400_26431.cljs$core$IFn$_invoke$arity$1(args__8404__auto___26433) : input_checker26400_26431.call(null,args__8404__auto___26433));
if(cljs.core.truth_(temp__4425__auto___26434)){
var error__8405__auto___26435 = temp__4425__auto___26434;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Input to %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$sequence_DASH_schemata,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$GraphIOSchemata,cljs.core.cst$kw$doc,"Given pairs of input and output schemata for fnks f1 and f2, and a keyword k,\n   return a pair of input and output schemata for #(let [v1 (f1 %)] (assoc v1 k (f2 (merge-disjoint % v1))))"], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26435], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,input_schema26399_26430,cljs.core.cst$kw$value,args__8404__auto___26433,cljs.core.cst$kw$error,error__8405__auto___26435], null));
} else {
}
} else {
}

var o__8406__auto__ = (function (){var G__26419 = G__26402;
var vec__26421 = G__26419;
var i1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26421,(0),null);
var o1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26421,(1),null);
var G__26420 = G__26403;
var vec__26422 = G__26420;
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26422,(0),null);
var vec__26423 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26422,(1),null);
var i2 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26423,(0),null);
var o2 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26423,(1),null);
var G__26419__$1 = G__26419;
var G__26420__$1 = G__26420;
while(true){
var vec__26424 = G__26419__$1;
var i1__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26424,(0),null);
var o1__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26424,(1),null);
var vec__26425 = G__26420__$1;
var k__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26425,(0),null);
var vec__26426 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26425,(1),null);
var i2__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26426,(0),null);
var o2__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26426,(1),null);
if(cljs.core.not(plumbing.fnk.schema.possibly_contains_QMARK_(i1__$1,k__$1))){
} else {
throw (new Error(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Duplicate key output (possibly due to a misordered graph) %s for input %s from input %s",cljs.core.array_seq([k__$1,schema.core.explain(i2__$1),schema.core.explain(i1__$1)], 0))));
}

if(cljs.core.not(plumbing.fnk.schema.possibly_contains_QMARK_(i2__$1,k__$1))){
} else {
throw (new Error(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Node outputs a key %s in its inputs %s",cljs.core.array_seq([k__$1,schema.core.explain(i2__$1)], 0))));
}

if(cljs.core.not(plumbing.fnk.schema.possibly_contains_QMARK_(o1__$1,k__$1))){
} else {
throw (new Error(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Node outputs a duplicate key %s given inputs %s",cljs.core.array_seq([k__$1,schema.core.explain(i1__$1)], 0))));
}

var vec__26427 = plumbing.fnk.schema.split_schema(i2__$1,cljs.core.keys(o1__$1));
var used = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26427,(0),null);
var unused = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__26427,(1),null);
plumbing.fnk.schema.assert_satisfies_schema(used,o1__$1);

return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [plumbing.fnk.schema.union_input_schemata(unused,i1__$1),cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(o1__$1,k__$1,o2__$1)], null);
break;
}
})();
if(cljs.core.truth_(validate__8403__auto__)){
var temp__4425__auto___26436 = (output_checker26401_26432.cljs$core$IFn$_invoke$arity$1 ? output_checker26401_26432.cljs$core$IFn$_invoke$arity$1(o__8406__auto__) : output_checker26401_26432.call(null,o__8406__auto__));
if(cljs.core.truth_(temp__4425__auto___26436)){
var error__8405__auto___26437 = temp__4425__auto___26436;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(schema.utils.format_STAR_.cljs$core$IFn$_invoke$arity$variadic("Output of %s does not match schema: %s",cljs.core.array_seq([cljs.core.with_meta(cljs.core.cst$sym$sequence_DASH_schemata,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$schema,cljs.core.cst$sym$GraphIOSchemata,cljs.core.cst$kw$doc,"Given pairs of input and output schemata for fnks f1 and f2, and a keyword k,\n   return a pair of input and output schemata for #(let [v1 (f1 %)] (assoc v1 k (f2 (merge-disjoint % v1))))"], null)),cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([error__8405__auto___26437], 0))], 0)),new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$type,cljs.core.cst$kw$schema$core_SLASH_error,cljs.core.cst$kw$schema,output_schema26398_26429,cljs.core.cst$kw$value,o__8406__auto__,cljs.core.cst$kw$error,error__8405__auto___26437], null));
} else {
}
} else {
}

return o__8406__auto__;
});})(ufv___26428,output_schema26398_26429,input_schema26399_26430,input_checker26400_26431,output_checker26401_26432))
;

schema.utils.declare_class_schema_BANG_(schema.utils.fn_schema_bearer(plumbing.fnk.schema.sequence_schemata),schema.core.make_fn_schema(output_schema26398_26429,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [input_schema26399_26430], null)));
