// Compiled by ClojureScript 1.7.145 {:static-fns true, :optimize-constants true}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(f){
if(typeof cljs.core.async.t_cljs$core$async23676 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async23676 = (function (fn_handler,f,meta23677){
this.fn_handler = fn_handler;
this.f = f;
this.meta23677 = meta23677;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async23676.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_23678,meta23677__$1){
var self__ = this;
var _23678__$1 = this;
return (new cljs.core.async.t_cljs$core$async23676(self__.fn_handler,self__.f,meta23677__$1));
});

cljs.core.async.t_cljs$core$async23676.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_23678){
var self__ = this;
var _23678__$1 = this;
return self__.meta23677;
});

cljs.core.async.t_cljs$core$async23676.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async23676.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async23676.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async23676.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$fn_DASH_handler,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f], null)))], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$meta23677], null);
});

cljs.core.async.t_cljs$core$async23676.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async23676.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async23676";

cljs.core.async.t_cljs$core$async23676.cljs$lang$ctorPrWriter = (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async23676");
});

cljs.core.async.__GT_t_cljs$core$async23676 = (function cljs$core$async$fn_handler_$___GT_t_cljs$core$async23676(fn_handler__$1,f__$1,meta23677){
return (new cljs.core.async.t_cljs$core$async23676(fn_handler__$1,f__$1,meta23677));
});

}

return (new cljs.core.async.t_cljs$core$async23676(cljs$core$async$fn_handler,f,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || (buff.cljs$core$async$impl$protocols$UnblockingBuffer$)){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer. If buf-or-n is a number,
 *   will create and use a fixed buffer of that size.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args23681 = [];
var len__5570__auto___23684 = arguments.length;
var i__5571__auto___23685 = (0);
while(true){
if((i__5571__auto___23685 < len__5570__auto___23684)){
args23681.push((arguments[i__5571__auto___23685]));

var G__23686 = (i__5571__auto___23685 + (1));
i__5571__auto___23685 = G__23686;
continue;
} else {
}
break;
}

var G__23683 = args23681.length;
switch (G__23683) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args23681.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
return cljs.core.async.impl.channels.chan(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1));
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 1;
/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("<! used not in (go ...) block"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([null], 0)))].join('')));

});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args23688 = [];
var len__5570__auto___23691 = arguments.length;
var i__5571__auto___23692 = (0);
while(true){
if((i__5571__auto___23692 < len__5570__auto___23691)){
args23688.push((arguments[i__5571__auto___23692]));

var G__23693 = (i__5571__auto___23692 + (1));
i__5571__auto___23692 = G__23693;
continue;
} else {
}
break;
}

var G__23690 = args23688.length;
switch (G__23690) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args23688.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler(fn1));
if(cljs.core.truth_(ret)){
var val_23695 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_23695) : fn1.call(null,val_23695));
} else {
cljs.core.async.impl.dispatch.run(((function (val_23695,ret){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_23695) : fn1.call(null,val_23695));
});})(val_23695,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;
cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(">! used not in (go ...) block"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([null], 0)))].join('')));

});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args23696 = [];
var len__5570__auto___23699 = arguments.length;
var i__5571__auto___23700 = (0);
while(true){
if((i__5571__auto___23700 < len__5570__auto___23699)){
args23696.push((arguments[i__5571__auto___23700]));

var G__23701 = (i__5571__auto___23700 + (1));
i__5571__auto___23700 = G__23701;
continue;
} else {
}
break;
}

var G__23698 = args23696.length;
switch (G__23698) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args23696.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4423__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4423__auto__)){
var ret = temp__4423__auto__;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4423__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler(fn1));
if(cljs.core.truth_(temp__4423__auto__)){
var retb = temp__4423__auto__;
var ret = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(retb) : cljs.core.deref.call(null,retb));
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
} else {
cljs.core.async.impl.dispatch.run(((function (ret,retb,temp__4423__auto__){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
});})(ret,retb,temp__4423__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;
cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__5415__auto___23703 = n;
var x_23704 = (0);
while(true){
if((x_23704 < n__5415__auto___23703)){
(a[x_23704] = (0));

var G__23705 = (x_23704 + (1));
x_23704 = G__23705;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(i,n)){
return a;
} else {
var j = cljs.core.rand_int(i);
(a[i] = (a[j]));

(a[j] = i);

var G__23706 = (i + (1));
i = G__23706;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true) : cljs.core.atom.call(null,true));
if(typeof cljs.core.async.t_cljs$core$async23710 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async23710 = (function (alt_flag,flag,meta23711){
this.alt_flag = alt_flag;
this.flag = flag;
this.meta23711 = meta23711;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async23710.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_23712,meta23711__$1){
var self__ = this;
var _23712__$1 = this;
return (new cljs.core.async.t_cljs$core$async23710(self__.alt_flag,self__.flag,meta23711__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async23710.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_23712){
var self__ = this;
var _23712__$1 = this;
return self__.meta23711;
});})(flag))
;

cljs.core.async.t_cljs$core$async23710.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async23710.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(self__.flag) : cljs.core.deref.call(null,self__.flag));
});})(flag))
;

cljs.core.async.t_cljs$core$async23710.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(self__.flag,null) : cljs.core.reset_BANG_.call(null,self__.flag,null));

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async23710.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$alt_DASH_flag,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(cljs.core.PersistentVector.EMPTY))], null)),cljs.core.cst$sym$flag,cljs.core.cst$sym$meta23711], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async23710.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async23710.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async23710";

cljs.core.async.t_cljs$core$async23710.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async23710");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async23710 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async23710(alt_flag__$1,flag__$1,meta23711){
return (new cljs.core.async.t_cljs$core$async23710(alt_flag__$1,flag__$1,meta23711));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async23710(cljs$core$async$alt_flag,flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async23716 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async23716 = (function (alt_handler,flag,cb,meta23717){
this.alt_handler = alt_handler;
this.flag = flag;
this.cb = cb;
this.meta23717 = meta23717;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async23716.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_23718,meta23717__$1){
var self__ = this;
var _23718__$1 = this;
return (new cljs.core.async.t_cljs$core$async23716(self__.alt_handler,self__.flag,self__.cb,meta23717__$1));
});

cljs.core.async.t_cljs$core$async23716.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_23718){
var self__ = this;
var _23718__$1 = this;
return self__.meta23717;
});

cljs.core.async.t_cljs$core$async23716.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async23716.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
});

cljs.core.async.t_cljs$core$async23716.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async23716.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$alt_DASH_handler,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$flag,cljs.core.cst$sym$cb], null)))], null)),cljs.core.cst$sym$flag,cljs.core.cst$sym$cb,cljs.core.cst$sym$meta23717], null);
});

cljs.core.async.t_cljs$core$async23716.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async23716.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async23716";

cljs.core.async.t_cljs$core$async23716.cljs$lang$ctorPrWriter = (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async23716");
});

cljs.core.async.__GT_t_cljs$core$async23716 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async23716(alt_handler__$1,flag__$1,cb__$1,meta23717){
return (new cljs.core.async.t_cljs$core$async23716(alt_handler__$1,flag__$1,cb__$1,meta23717));
});

}

return (new cljs.core.async.t_cljs$core$async23716(cljs$core$async$alt_handler,flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = cljs.core.cst$kw$priority.cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((0)) : port.call(null,(0))):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((1)) : port.call(null,(1)));
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__23719_SHARP_){
var G__23723 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__23719_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__23723) : fret.call(null,G__23723));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__23720_SHARP_){
var G__23724 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__23720_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__23724) : fret.call(null,G__23724));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(vbox) : cljs.core.deref.call(null,vbox)),(function (){var or__4512__auto__ = wport;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return port;
}
})()], null));
} else {
var G__23725 = (i + (1));
i = G__23725;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4512__auto__ = ret;
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,cljs.core.cst$kw$default)){
var temp__4425__auto__ = (function (){var and__4500__auto__ = cljs.core.async.impl.protocols.active_QMARK_(flag);
if(cljs.core.truth_(and__4500__auto__)){
return cljs.core.async.impl.protocols.commit(flag);
} else {
return and__4500__auto__;
}
})();
if(cljs.core.truth_(temp__4425__auto__)){
var got = temp__4425__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$default.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$default], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__5577__auto__ = [];
var len__5570__auto___23731 = arguments.length;
var i__5571__auto___23732 = (0);
while(true){
if((i__5571__auto___23732 < len__5570__auto___23731)){
args__5577__auto__.push((arguments[i__5571__auto___23732]));

var G__23733 = (i__5571__auto___23732 + (1));
i__5571__auto___23732 = G__23733;
continue;
} else {
}
break;
}

var argseq__5578__auto__ = ((((1) < args__5577__auto__.length))?(new cljs.core.IndexedSeq(args__5577__auto__.slice((1)),(0))):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5578__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__23728){
var map__23729 = p__23728;
var map__23729__$1 = ((((!((map__23729 == null)))?((((map__23729.cljs$lang$protocol_mask$partition0$ & (64))) || (map__23729.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__23729):map__23729);
var opts = map__23729__$1;
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("alts! used not in (go ...) block"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([null], 0)))].join('')));

});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq23726){
var G__23727 = cljs.core.first(seq23726);
var seq23726__$1 = cljs.core.next(seq23726);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__23727,seq23726__$1);
});
/**
 * Takes a function and a source channel, and returns a channel which
 *   contains the values produced by applying f to each value taken from
 *   the source channel
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async23743 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async23743 = (function (map_LT_,f,ch,meta23744){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta23744 = meta23744;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_23745,meta23744__$1){
var self__ = this;
var _23745__$1 = this;
return (new cljs.core.async.t_cljs$core$async23743(self__.map_LT_,self__.f,self__.ch,meta23744__$1));
});

cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_23745){
var self__ = this;
var _23745__$1 = this;
return self__.meta23744;
});

cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async23746 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async23746 = (function (map_LT_,f,ch,meta23744,_,fn1,meta23747){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta23744 = meta23744;
this._ = _;
this.fn1 = fn1;
this.meta23747 = meta23747;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async23746.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_23748,meta23747__$1){
var self__ = this;
var _23748__$1 = this;
return (new cljs.core.async.t_cljs$core$async23746(self__.map_LT_,self__.f,self__.ch,self__.meta23744,self__._,self__.fn1,meta23747__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async23746.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_23748){
var self__ = this;
var _23748__$1 = this;
return self__.meta23747;
});})(___$1))
;

cljs.core.async.t_cljs$core$async23746.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async23746.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async23746.prototype.cljs$core$async$impl$protocols$Handler$lock_id$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return (cljs.core.async.impl.protocols.lock_id.cljs$core$IFn$_invoke$arity$1 ? cljs.core.async.impl.protocols.lock_id.cljs$core$IFn$_invoke$arity$1(self__.fn1) : cljs.core.async.impl.protocols.lock_id.call(null,self__.fn1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async23746.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__23734_SHARP_){
var G__23749 = (((p1__23734_SHARP_ == null))?null:(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(p1__23734_SHARP_) : self__.f.call(null,p1__23734_SHARP_)));
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__23749) : f1.call(null,G__23749));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async23746.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_LT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Takes a function and a source channel, and returns a channel which\n  contains the values produced by applying f to each value taken from\n  the source channel"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta23744,cljs.core.with_meta(cljs.core.cst$sym$_,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$tag,cljs.core.cst$sym$cljs$core$async_SLASH_t_cljs$core$async23743], null)),cljs.core.cst$sym$fn1,cljs.core.cst$sym$meta23747], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async23746.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async23746.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async23746";

cljs.core.async.t_cljs$core$async23746.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async23746");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async23746 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async23746(map_LT___$1,f__$1,ch__$1,meta23744__$1,___$2,fn1__$1,meta23747){
return (new cljs.core.async.t_cljs$core$async23746(map_LT___$1,f__$1,ch__$1,meta23744__$1,___$2,fn1__$1,meta23747));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async23746(self__.map_LT_,self__.f,self__.ch,self__.meta23744,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4500__auto__ = ret;
if(cljs.core.truth_(and__4500__auto__)){
return !(((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret)) == null));
} else {
return and__4500__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__23750 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__23750) : self__.f.call(null,G__23750));
})());
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async23743.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async23743.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_LT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Takes a function and a source channel, and returns a channel which\n  contains the values produced by applying f to each value taken from\n  the source channel"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta23744], null);
});

cljs.core.async.t_cljs$core$async23743.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async23743.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async23743";

cljs.core.async.t_cljs$core$async23743.cljs$lang$ctorPrWriter = (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async23743");
});

cljs.core.async.__GT_t_cljs$core$async23743 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async23743(map_LT___$1,f__$1,ch__$1,meta23744){
return (new cljs.core.async.t_cljs$core$async23743(map_LT___$1,f__$1,ch__$1,meta23744));
});

}

return (new cljs.core.async.t_cljs$core$async23743(cljs$core$async$map_LT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Takes a function and a target channel, and returns a channel which
 *   applies f to each value before supplying it to the target channel.
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async23754 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async23754 = (function (map_GT_,f,ch,meta23755){
this.map_GT_ = map_GT_;
this.f = f;
this.ch = ch;
this.meta23755 = meta23755;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async23754.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_23756,meta23755__$1){
var self__ = this;
var _23756__$1 = this;
return (new cljs.core.async.t_cljs$core$async23754(self__.map_GT_,self__.f,self__.ch,meta23755__$1));
});

cljs.core.async.t_cljs$core$async23754.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_23756){
var self__ = this;
var _23756__$1 = this;
return self__.meta23755;
});

cljs.core.async.t_cljs$core$async23754.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async23754.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async23754.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async23754.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async23754.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async23754.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(val) : self__.f.call(null,val)),fn1);
});

cljs.core.async.t_cljs$core$async23754.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_GT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Takes a function and a target channel, and returns a channel which\n  applies f to each value before supplying it to the target channel."], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta23755], null);
});

cljs.core.async.t_cljs$core$async23754.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async23754.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async23754";

cljs.core.async.t_cljs$core$async23754.cljs$lang$ctorPrWriter = (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async23754");
});

cljs.core.async.__GT_t_cljs$core$async23754 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async23754(map_GT___$1,f__$1,ch__$1,meta23755){
return (new cljs.core.async.t_cljs$core$async23754(map_GT___$1,f__$1,ch__$1,meta23755));
});

}

return (new cljs.core.async.t_cljs$core$async23754(cljs$core$async$map_GT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Takes a predicate and a target channel, and returns a channel which
 *   supplies only the values for which the predicate returns true to the
 *   target channel.
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async23760 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async23760 = (function (filter_GT_,p,ch,meta23761){
this.filter_GT_ = filter_GT_;
this.p = p;
this.ch = ch;
this.meta23761 = meta23761;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_23762,meta23761__$1){
var self__ = this;
var _23762__$1 = this;
return (new cljs.core.async.t_cljs$core$async23760(self__.filter_GT_,self__.p,self__.ch,meta23761__$1));
});

cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_23762){
var self__ = this;
var _23762__$1 = this;
return self__.meta23761;
});

cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async23760.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(val) : self__.p.call(null,val)))){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
});

cljs.core.async.t_cljs$core$async23760.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$filter_GT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$p,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Takes a predicate and a target channel, and returns a channel which\n  supplies only the values for which the predicate returns true to the\n  target channel."], null)),cljs.core.cst$sym$p,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta23761], null);
});

cljs.core.async.t_cljs$core$async23760.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async23760.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async23760";

cljs.core.async.t_cljs$core$async23760.cljs$lang$ctorPrWriter = (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async23760");
});

cljs.core.async.__GT_t_cljs$core$async23760 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async23760(filter_GT___$1,p__$1,ch__$1,meta23761){
return (new cljs.core.async.t_cljs$core$async23760(filter_GT___$1,p__$1,ch__$1,meta23761));
});

}

return (new cljs.core.async.t_cljs$core$async23760(cljs$core$async$filter_GT_,p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Takes a predicate and a target channel, and returns a channel which
 *   supplies only the values for which the predicate returns false to the
 *   target channel.
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Takes a predicate and a source channel, and returns a channel which
 *   contains only the values taken from the source channel for which the
 *   predicate returns true. The returned channel will be unbuffered by
 *   default, or a buf-or-n can be supplied. The channel will close
 *   when the source channel closes.
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args23763 = [];
var len__5570__auto___23807 = arguments.length;
var i__5571__auto___23808 = (0);
while(true){
if((i__5571__auto___23808 < len__5570__auto___23807)){
args23763.push((arguments[i__5571__auto___23808]));

var G__23809 = (i__5571__auto___23808 + (1));
i__5571__auto___23808 = G__23809;
continue;
} else {
}
break;
}

var G__23765 = args23763.length;
switch (G__23765) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args23763.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__16730__auto___23811 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___23811,out){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___23811,out){
return (function (state_23786){
var state_val_23787 = (state_23786[(1)]);
if((state_val_23787 === (7))){
var inst_23782 = (state_23786[(2)]);
var state_23786__$1 = state_23786;
var statearr_23788_23812 = state_23786__$1;
(statearr_23788_23812[(2)] = inst_23782);

(statearr_23788_23812[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23787 === (1))){
var state_23786__$1 = state_23786;
var statearr_23789_23813 = state_23786__$1;
(statearr_23789_23813[(2)] = null);

(statearr_23789_23813[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23787 === (4))){
var inst_23768 = (state_23786[(7)]);
var inst_23768__$1 = (state_23786[(2)]);
var inst_23769 = (inst_23768__$1 == null);
var state_23786__$1 = (function (){var statearr_23790 = state_23786;
(statearr_23790[(7)] = inst_23768__$1);

return statearr_23790;
})();
if(cljs.core.truth_(inst_23769)){
var statearr_23791_23814 = state_23786__$1;
(statearr_23791_23814[(1)] = (5));

} else {
var statearr_23792_23815 = state_23786__$1;
(statearr_23792_23815[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_23787 === (6))){
var inst_23768 = (state_23786[(7)]);
var inst_23773 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_23768) : p.call(null,inst_23768));
var state_23786__$1 = state_23786;
if(cljs.core.truth_(inst_23773)){
var statearr_23793_23816 = state_23786__$1;
(statearr_23793_23816[(1)] = (8));

} else {
var statearr_23794_23817 = state_23786__$1;
(statearr_23794_23817[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_23787 === (3))){
var inst_23784 = (state_23786[(2)]);
var state_23786__$1 = state_23786;
return cljs.core.async.impl.ioc_helpers.return_chan(state_23786__$1,inst_23784);
} else {
if((state_val_23787 === (2))){
var state_23786__$1 = state_23786;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_23786__$1,(4),ch);
} else {
if((state_val_23787 === (11))){
var inst_23776 = (state_23786[(2)]);
var state_23786__$1 = state_23786;
var statearr_23795_23818 = state_23786__$1;
(statearr_23795_23818[(2)] = inst_23776);

(statearr_23795_23818[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23787 === (9))){
var state_23786__$1 = state_23786;
var statearr_23796_23819 = state_23786__$1;
(statearr_23796_23819[(2)] = null);

(statearr_23796_23819[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23787 === (5))){
var inst_23771 = cljs.core.async.close_BANG_(out);
var state_23786__$1 = state_23786;
var statearr_23797_23820 = state_23786__$1;
(statearr_23797_23820[(2)] = inst_23771);

(statearr_23797_23820[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23787 === (10))){
var inst_23779 = (state_23786[(2)]);
var state_23786__$1 = (function (){var statearr_23798 = state_23786;
(statearr_23798[(8)] = inst_23779);

return statearr_23798;
})();
var statearr_23799_23821 = state_23786__$1;
(statearr_23799_23821[(2)] = null);

(statearr_23799_23821[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23787 === (8))){
var inst_23768 = (state_23786[(7)]);
var state_23786__$1 = state_23786;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_23786__$1,(11),out,inst_23768);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___23811,out))
;
return ((function (switch__16649__auto__,c__16730__auto___23811,out){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_23803 = [null,null,null,null,null,null,null,null,null];
(statearr_23803[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_23803[(1)] = (1));

return statearr_23803;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_23786){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_23786);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e23804){if((e23804 instanceof Object)){
var ex__16653__auto__ = e23804;
var statearr_23805_23822 = state_23786;
(statearr_23805_23822[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_23786);

return cljs.core.cst$kw$recur;
} else {
throw e23804;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__23823 = state_23786;
state_23786 = G__23823;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_23786){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_23786);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___23811,out))
})();
var state__16732__auto__ = (function (){var statearr_23806 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_23806[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___23811);

return statearr_23806;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___23811,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Takes a predicate and a source channel, and returns a channel which
 *   contains only the values taken from the source channel for which the
 *   predicate returns false. The returned channel will be unbuffered by
 *   default, or a buf-or-n can be supplied. The channel will close
 *   when the source channel closes.
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args23824 = [];
var len__5570__auto___23827 = arguments.length;
var i__5571__auto___23828 = (0);
while(true){
if((i__5571__auto___23828 < len__5570__auto___23827)){
args23824.push((arguments[i__5571__auto___23828]));

var G__23829 = (i__5571__auto___23828 + (1));
i__5571__auto___23828 = G__23829;
continue;
} else {
}
break;
}

var G__23826 = args23824.length;
switch (G__23826) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args23824.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;
cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__16730__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto__){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto__){
return (function (state_23996){
var state_val_23997 = (state_23996[(1)]);
if((state_val_23997 === (7))){
var inst_23992 = (state_23996[(2)]);
var state_23996__$1 = state_23996;
var statearr_23998_24039 = state_23996__$1;
(statearr_23998_24039[(2)] = inst_23992);

(statearr_23998_24039[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (20))){
var inst_23962 = (state_23996[(7)]);
var inst_23973 = (state_23996[(2)]);
var inst_23974 = cljs.core.next(inst_23962);
var inst_23948 = inst_23974;
var inst_23949 = null;
var inst_23950 = (0);
var inst_23951 = (0);
var state_23996__$1 = (function (){var statearr_23999 = state_23996;
(statearr_23999[(8)] = inst_23949);

(statearr_23999[(9)] = inst_23973);

(statearr_23999[(10)] = inst_23950);

(statearr_23999[(11)] = inst_23948);

(statearr_23999[(12)] = inst_23951);

return statearr_23999;
})();
var statearr_24000_24040 = state_23996__$1;
(statearr_24000_24040[(2)] = null);

(statearr_24000_24040[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (1))){
var state_23996__$1 = state_23996;
var statearr_24001_24041 = state_23996__$1;
(statearr_24001_24041[(2)] = null);

(statearr_24001_24041[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (4))){
var inst_23937 = (state_23996[(13)]);
var inst_23937__$1 = (state_23996[(2)]);
var inst_23938 = (inst_23937__$1 == null);
var state_23996__$1 = (function (){var statearr_24002 = state_23996;
(statearr_24002[(13)] = inst_23937__$1);

return statearr_24002;
})();
if(cljs.core.truth_(inst_23938)){
var statearr_24003_24042 = state_23996__$1;
(statearr_24003_24042[(1)] = (5));

} else {
var statearr_24004_24043 = state_23996__$1;
(statearr_24004_24043[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (15))){
var state_23996__$1 = state_23996;
var statearr_24008_24044 = state_23996__$1;
(statearr_24008_24044[(2)] = null);

(statearr_24008_24044[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (21))){
var state_23996__$1 = state_23996;
var statearr_24009_24045 = state_23996__$1;
(statearr_24009_24045[(2)] = null);

(statearr_24009_24045[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (13))){
var inst_23949 = (state_23996[(8)]);
var inst_23950 = (state_23996[(10)]);
var inst_23948 = (state_23996[(11)]);
var inst_23951 = (state_23996[(12)]);
var inst_23958 = (state_23996[(2)]);
var inst_23959 = (inst_23951 + (1));
var tmp24005 = inst_23949;
var tmp24006 = inst_23950;
var tmp24007 = inst_23948;
var inst_23948__$1 = tmp24007;
var inst_23949__$1 = tmp24005;
var inst_23950__$1 = tmp24006;
var inst_23951__$1 = inst_23959;
var state_23996__$1 = (function (){var statearr_24010 = state_23996;
(statearr_24010[(8)] = inst_23949__$1);

(statearr_24010[(14)] = inst_23958);

(statearr_24010[(10)] = inst_23950__$1);

(statearr_24010[(11)] = inst_23948__$1);

(statearr_24010[(12)] = inst_23951__$1);

return statearr_24010;
})();
var statearr_24011_24046 = state_23996__$1;
(statearr_24011_24046[(2)] = null);

(statearr_24011_24046[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (22))){
var state_23996__$1 = state_23996;
var statearr_24012_24047 = state_23996__$1;
(statearr_24012_24047[(2)] = null);

(statearr_24012_24047[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (6))){
var inst_23937 = (state_23996[(13)]);
var inst_23946 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_23937) : f.call(null,inst_23937));
var inst_23947 = cljs.core.seq(inst_23946);
var inst_23948 = inst_23947;
var inst_23949 = null;
var inst_23950 = (0);
var inst_23951 = (0);
var state_23996__$1 = (function (){var statearr_24013 = state_23996;
(statearr_24013[(8)] = inst_23949);

(statearr_24013[(10)] = inst_23950);

(statearr_24013[(11)] = inst_23948);

(statearr_24013[(12)] = inst_23951);

return statearr_24013;
})();
var statearr_24014_24048 = state_23996__$1;
(statearr_24014_24048[(2)] = null);

(statearr_24014_24048[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (17))){
var inst_23962 = (state_23996[(7)]);
var inst_23966 = cljs.core.chunk_first(inst_23962);
var inst_23967 = cljs.core.chunk_rest(inst_23962);
var inst_23968 = cljs.core.count(inst_23966);
var inst_23948 = inst_23967;
var inst_23949 = inst_23966;
var inst_23950 = inst_23968;
var inst_23951 = (0);
var state_23996__$1 = (function (){var statearr_24015 = state_23996;
(statearr_24015[(8)] = inst_23949);

(statearr_24015[(10)] = inst_23950);

(statearr_24015[(11)] = inst_23948);

(statearr_24015[(12)] = inst_23951);

return statearr_24015;
})();
var statearr_24016_24049 = state_23996__$1;
(statearr_24016_24049[(2)] = null);

(statearr_24016_24049[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (3))){
var inst_23994 = (state_23996[(2)]);
var state_23996__$1 = state_23996;
return cljs.core.async.impl.ioc_helpers.return_chan(state_23996__$1,inst_23994);
} else {
if((state_val_23997 === (12))){
var inst_23982 = (state_23996[(2)]);
var state_23996__$1 = state_23996;
var statearr_24017_24050 = state_23996__$1;
(statearr_24017_24050[(2)] = inst_23982);

(statearr_24017_24050[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (2))){
var state_23996__$1 = state_23996;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_23996__$1,(4),in$);
} else {
if((state_val_23997 === (23))){
var inst_23990 = (state_23996[(2)]);
var state_23996__$1 = state_23996;
var statearr_24018_24051 = state_23996__$1;
(statearr_24018_24051[(2)] = inst_23990);

(statearr_24018_24051[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (19))){
var inst_23977 = (state_23996[(2)]);
var state_23996__$1 = state_23996;
var statearr_24019_24052 = state_23996__$1;
(statearr_24019_24052[(2)] = inst_23977);

(statearr_24019_24052[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (11))){
var inst_23948 = (state_23996[(11)]);
var inst_23962 = (state_23996[(7)]);
var inst_23962__$1 = cljs.core.seq(inst_23948);
var state_23996__$1 = (function (){var statearr_24020 = state_23996;
(statearr_24020[(7)] = inst_23962__$1);

return statearr_24020;
})();
if(inst_23962__$1){
var statearr_24021_24053 = state_23996__$1;
(statearr_24021_24053[(1)] = (14));

} else {
var statearr_24022_24054 = state_23996__$1;
(statearr_24022_24054[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (9))){
var inst_23984 = (state_23996[(2)]);
var inst_23985 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_23996__$1 = (function (){var statearr_24023 = state_23996;
(statearr_24023[(15)] = inst_23984);

return statearr_24023;
})();
if(cljs.core.truth_(inst_23985)){
var statearr_24024_24055 = state_23996__$1;
(statearr_24024_24055[(1)] = (21));

} else {
var statearr_24025_24056 = state_23996__$1;
(statearr_24025_24056[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (5))){
var inst_23940 = cljs.core.async.close_BANG_(out);
var state_23996__$1 = state_23996;
var statearr_24026_24057 = state_23996__$1;
(statearr_24026_24057[(2)] = inst_23940);

(statearr_24026_24057[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (14))){
var inst_23962 = (state_23996[(7)]);
var inst_23964 = cljs.core.chunked_seq_QMARK_(inst_23962);
var state_23996__$1 = state_23996;
if(inst_23964){
var statearr_24027_24058 = state_23996__$1;
(statearr_24027_24058[(1)] = (17));

} else {
var statearr_24028_24059 = state_23996__$1;
(statearr_24028_24059[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (16))){
var inst_23980 = (state_23996[(2)]);
var state_23996__$1 = state_23996;
var statearr_24029_24060 = state_23996__$1;
(statearr_24029_24060[(2)] = inst_23980);

(statearr_24029_24060[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_23997 === (10))){
var inst_23949 = (state_23996[(8)]);
var inst_23951 = (state_23996[(12)]);
var inst_23956 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_23949,inst_23951);
var state_23996__$1 = state_23996;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_23996__$1,(13),out,inst_23956);
} else {
if((state_val_23997 === (18))){
var inst_23962 = (state_23996[(7)]);
var inst_23971 = cljs.core.first(inst_23962);
var state_23996__$1 = state_23996;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_23996__$1,(20),out,inst_23971);
} else {
if((state_val_23997 === (8))){
var inst_23950 = (state_23996[(10)]);
var inst_23951 = (state_23996[(12)]);
var inst_23953 = (inst_23951 < inst_23950);
var inst_23954 = inst_23953;
var state_23996__$1 = state_23996;
if(cljs.core.truth_(inst_23954)){
var statearr_24030_24061 = state_23996__$1;
(statearr_24030_24061[(1)] = (10));

} else {
var statearr_24031_24062 = state_23996__$1;
(statearr_24031_24062[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto__))
;
return ((function (switch__16649__auto__,c__16730__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__16650__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__16650__auto____0 = (function (){
var statearr_24035 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_24035[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__16650__auto__);

(statearr_24035[(1)] = (1));

return statearr_24035;
});
var cljs$core$async$mapcat_STAR__$_state_machine__16650__auto____1 = (function (state_23996){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_23996);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e24036){if((e24036 instanceof Object)){
var ex__16653__auto__ = e24036;
var statearr_24037_24063 = state_23996;
(statearr_24037_24063[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_23996);

return cljs.core.cst$kw$recur;
} else {
throw e24036;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__24064 = state_23996;
state_23996 = G__24064;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__16650__auto__ = function(state_23996){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__16650__auto____1.call(this,state_23996);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__16650__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__16650__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto__))
})();
var state__16732__auto__ = (function (){var statearr_24038 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_24038[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto__);

return statearr_24038;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto__))
);

return c__16730__auto__;
});
/**
 * Takes a function and a source channel, and returns a channel which
 *   contains the values in each collection produced by applying f to
 *   each value taken from the source channel. f must return a
 *   collection.
 * 
 *   The returned channel will be unbuffered by default, or a buf-or-n
 *   can be supplied. The channel will close when the source channel
 *   closes.
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args24065 = [];
var len__5570__auto___24068 = arguments.length;
var i__5571__auto___24069 = (0);
while(true){
if((i__5571__auto___24069 < len__5570__auto___24068)){
args24065.push((arguments[i__5571__auto___24069]));

var G__24070 = (i__5571__auto___24069 + (1));
i__5571__auto___24069 = G__24070;
continue;
} else {
}
break;
}

var G__24067 = args24065.length;
switch (G__24067) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args24065.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Takes a function and a target channel, and returns a channel which
 *   applies f to each value put, then supplies each element of the result
 *   to the target channel. f must return a collection.
 * 
 *   The returned channel will be unbuffered by default, or a buf-or-n
 *   can be supplied. The target channel will be closed when the source
 *   channel closes.
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args24072 = [];
var len__5570__auto___24075 = arguments.length;
var i__5571__auto___24076 = (0);
while(true){
if((i__5571__auto___24076 < len__5570__auto___24075)){
args24072.push((arguments[i__5571__auto___24076]));

var G__24077 = (i__5571__auto___24076 + (1));
i__5571__auto___24076 = G__24077;
continue;
} else {
}
break;
}

var G__24074 = args24072.length;
switch (G__24074) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args24072.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args24079 = [];
var len__5570__auto___24129 = arguments.length;
var i__5571__auto___24130 = (0);
while(true){
if((i__5571__auto___24130 < len__5570__auto___24129)){
args24079.push((arguments[i__5571__auto___24130]));

var G__24131 = (i__5571__auto___24130 + (1));
i__5571__auto___24130 = G__24131;
continue;
} else {
}
break;
}

var G__24081 = args24079.length;
switch (G__24081) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args24079.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__16730__auto___24133 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___24133){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___24133){
return (function (state_24105){
var state_val_24106 = (state_24105[(1)]);
if((state_val_24106 === (7))){
var inst_24101 = (state_24105[(2)]);
var state_24105__$1 = state_24105;
var statearr_24107_24134 = state_24105__$1;
(statearr_24107_24134[(2)] = inst_24101);

(statearr_24107_24134[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (1))){
var state_24105__$1 = state_24105;
var statearr_24108_24135 = state_24105__$1;
(statearr_24108_24135[(2)] = null);

(statearr_24108_24135[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (4))){
var inst_24084 = (state_24105[(7)]);
var inst_24084__$1 = (state_24105[(2)]);
var inst_24085 = (inst_24084__$1 == null);
var state_24105__$1 = (function (){var statearr_24109 = state_24105;
(statearr_24109[(7)] = inst_24084__$1);

return statearr_24109;
})();
if(cljs.core.truth_(inst_24085)){
var statearr_24110_24136 = state_24105__$1;
(statearr_24110_24136[(1)] = (5));

} else {
var statearr_24111_24137 = state_24105__$1;
(statearr_24111_24137[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (13))){
var state_24105__$1 = state_24105;
var statearr_24112_24138 = state_24105__$1;
(statearr_24112_24138[(2)] = null);

(statearr_24112_24138[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (6))){
var inst_24084 = (state_24105[(7)]);
var state_24105__$1 = state_24105;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_24105__$1,(11),to,inst_24084);
} else {
if((state_val_24106 === (3))){
var inst_24103 = (state_24105[(2)]);
var state_24105__$1 = state_24105;
return cljs.core.async.impl.ioc_helpers.return_chan(state_24105__$1,inst_24103);
} else {
if((state_val_24106 === (12))){
var state_24105__$1 = state_24105;
var statearr_24113_24139 = state_24105__$1;
(statearr_24113_24139[(2)] = null);

(statearr_24113_24139[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (2))){
var state_24105__$1 = state_24105;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_24105__$1,(4),from);
} else {
if((state_val_24106 === (11))){
var inst_24094 = (state_24105[(2)]);
var state_24105__$1 = state_24105;
if(cljs.core.truth_(inst_24094)){
var statearr_24114_24140 = state_24105__$1;
(statearr_24114_24140[(1)] = (12));

} else {
var statearr_24115_24141 = state_24105__$1;
(statearr_24115_24141[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (9))){
var state_24105__$1 = state_24105;
var statearr_24116_24142 = state_24105__$1;
(statearr_24116_24142[(2)] = null);

(statearr_24116_24142[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (5))){
var state_24105__$1 = state_24105;
if(cljs.core.truth_(close_QMARK_)){
var statearr_24117_24143 = state_24105__$1;
(statearr_24117_24143[(1)] = (8));

} else {
var statearr_24118_24144 = state_24105__$1;
(statearr_24118_24144[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (14))){
var inst_24099 = (state_24105[(2)]);
var state_24105__$1 = state_24105;
var statearr_24119_24145 = state_24105__$1;
(statearr_24119_24145[(2)] = inst_24099);

(statearr_24119_24145[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (10))){
var inst_24091 = (state_24105[(2)]);
var state_24105__$1 = state_24105;
var statearr_24120_24146 = state_24105__$1;
(statearr_24120_24146[(2)] = inst_24091);

(statearr_24120_24146[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24106 === (8))){
var inst_24088 = cljs.core.async.close_BANG_(to);
var state_24105__$1 = state_24105;
var statearr_24121_24147 = state_24105__$1;
(statearr_24121_24147[(2)] = inst_24088);

(statearr_24121_24147[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___24133))
;
return ((function (switch__16649__auto__,c__16730__auto___24133){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_24125 = [null,null,null,null,null,null,null,null];
(statearr_24125[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_24125[(1)] = (1));

return statearr_24125;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_24105){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_24105);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e24126){if((e24126 instanceof Object)){
var ex__16653__auto__ = e24126;
var statearr_24127_24148 = state_24105;
(statearr_24127_24148[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_24105);

return cljs.core.cst$kw$recur;
} else {
throw e24126;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__24149 = state_24105;
state_24105 = G__24149;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_24105){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_24105);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___24133))
})();
var state__16732__auto__ = (function (){var statearr_24128 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_24128[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___24133);

return statearr_24128;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___24133))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;
/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args24150 = [];
var len__5570__auto___24203 = arguments.length;
var i__5571__auto___24204 = (0);
while(true){
if((i__5571__auto___24204 < len__5570__auto___24203)){
args24150.push((arguments[i__5571__auto___24204]));

var G__24205 = (i__5571__auto___24204 + (1));
i__5571__auto___24204 = G__24205;
continue;
} else {
}
break;
}

var G__24152 = args24150.length;
switch (G__24152) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args24150.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__16730__auto___24207 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___24207,tc,fc){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___24207,tc,fc){
return (function (state_24178){
var state_val_24179 = (state_24178[(1)]);
if((state_val_24179 === (7))){
var inst_24174 = (state_24178[(2)]);
var state_24178__$1 = state_24178;
var statearr_24180_24208 = state_24178__$1;
(statearr_24180_24208[(2)] = inst_24174);

(statearr_24180_24208[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (1))){
var state_24178__$1 = state_24178;
var statearr_24181_24209 = state_24178__$1;
(statearr_24181_24209[(2)] = null);

(statearr_24181_24209[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (4))){
var inst_24155 = (state_24178[(7)]);
var inst_24155__$1 = (state_24178[(2)]);
var inst_24156 = (inst_24155__$1 == null);
var state_24178__$1 = (function (){var statearr_24182 = state_24178;
(statearr_24182[(7)] = inst_24155__$1);

return statearr_24182;
})();
if(cljs.core.truth_(inst_24156)){
var statearr_24183_24210 = state_24178__$1;
(statearr_24183_24210[(1)] = (5));

} else {
var statearr_24184_24211 = state_24178__$1;
(statearr_24184_24211[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (13))){
var state_24178__$1 = state_24178;
var statearr_24185_24212 = state_24178__$1;
(statearr_24185_24212[(2)] = null);

(statearr_24185_24212[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (6))){
var inst_24155 = (state_24178[(7)]);
var inst_24161 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_24155) : p.call(null,inst_24155));
var state_24178__$1 = state_24178;
if(cljs.core.truth_(inst_24161)){
var statearr_24186_24213 = state_24178__$1;
(statearr_24186_24213[(1)] = (9));

} else {
var statearr_24187_24214 = state_24178__$1;
(statearr_24187_24214[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (3))){
var inst_24176 = (state_24178[(2)]);
var state_24178__$1 = state_24178;
return cljs.core.async.impl.ioc_helpers.return_chan(state_24178__$1,inst_24176);
} else {
if((state_val_24179 === (12))){
var state_24178__$1 = state_24178;
var statearr_24188_24215 = state_24178__$1;
(statearr_24188_24215[(2)] = null);

(statearr_24188_24215[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (2))){
var state_24178__$1 = state_24178;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_24178__$1,(4),ch);
} else {
if((state_val_24179 === (11))){
var inst_24155 = (state_24178[(7)]);
var inst_24165 = (state_24178[(2)]);
var state_24178__$1 = state_24178;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_24178__$1,(8),inst_24165,inst_24155);
} else {
if((state_val_24179 === (9))){
var state_24178__$1 = state_24178;
var statearr_24189_24216 = state_24178__$1;
(statearr_24189_24216[(2)] = tc);

(statearr_24189_24216[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (5))){
var inst_24158 = cljs.core.async.close_BANG_(tc);
var inst_24159 = cljs.core.async.close_BANG_(fc);
var state_24178__$1 = (function (){var statearr_24190 = state_24178;
(statearr_24190[(8)] = inst_24158);

return statearr_24190;
})();
var statearr_24191_24217 = state_24178__$1;
(statearr_24191_24217[(2)] = inst_24159);

(statearr_24191_24217[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (14))){
var inst_24172 = (state_24178[(2)]);
var state_24178__$1 = state_24178;
var statearr_24192_24218 = state_24178__$1;
(statearr_24192_24218[(2)] = inst_24172);

(statearr_24192_24218[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (10))){
var state_24178__$1 = state_24178;
var statearr_24193_24219 = state_24178__$1;
(statearr_24193_24219[(2)] = fc);

(statearr_24193_24219[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24179 === (8))){
var inst_24167 = (state_24178[(2)]);
var state_24178__$1 = state_24178;
if(cljs.core.truth_(inst_24167)){
var statearr_24194_24220 = state_24178__$1;
(statearr_24194_24220[(1)] = (12));

} else {
var statearr_24195_24221 = state_24178__$1;
(statearr_24195_24221[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___24207,tc,fc))
;
return ((function (switch__16649__auto__,c__16730__auto___24207,tc,fc){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_24199 = [null,null,null,null,null,null,null,null,null];
(statearr_24199[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_24199[(1)] = (1));

return statearr_24199;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_24178){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_24178);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e24200){if((e24200 instanceof Object)){
var ex__16653__auto__ = e24200;
var statearr_24201_24222 = state_24178;
(statearr_24201_24222[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_24178);

return cljs.core.cst$kw$recur;
} else {
throw e24200;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__24223 = state_24178;
state_24178 = G__24223;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_24178){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_24178);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___24207,tc,fc))
})();
var state__16732__auto__ = (function (){var statearr_24202 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_24202[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___24207);

return statearr_24202;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___24207,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;
/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__16730__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto__){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto__){
return (function (state_24270){
var state_val_24271 = (state_24270[(1)]);
if((state_val_24271 === (1))){
var inst_24256 = init;
var state_24270__$1 = (function (){var statearr_24272 = state_24270;
(statearr_24272[(7)] = inst_24256);

return statearr_24272;
})();
var statearr_24273_24288 = state_24270__$1;
(statearr_24273_24288[(2)] = null);

(statearr_24273_24288[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24271 === (2))){
var state_24270__$1 = state_24270;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_24270__$1,(4),ch);
} else {
if((state_val_24271 === (3))){
var inst_24268 = (state_24270[(2)]);
var state_24270__$1 = state_24270;
return cljs.core.async.impl.ioc_helpers.return_chan(state_24270__$1,inst_24268);
} else {
if((state_val_24271 === (4))){
var inst_24259 = (state_24270[(8)]);
var inst_24259__$1 = (state_24270[(2)]);
var inst_24260 = (inst_24259__$1 == null);
var state_24270__$1 = (function (){var statearr_24274 = state_24270;
(statearr_24274[(8)] = inst_24259__$1);

return statearr_24274;
})();
if(cljs.core.truth_(inst_24260)){
var statearr_24275_24289 = state_24270__$1;
(statearr_24275_24289[(1)] = (5));

} else {
var statearr_24276_24290 = state_24270__$1;
(statearr_24276_24290[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24271 === (5))){
var inst_24256 = (state_24270[(7)]);
var state_24270__$1 = state_24270;
var statearr_24277_24291 = state_24270__$1;
(statearr_24277_24291[(2)] = inst_24256);

(statearr_24277_24291[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24271 === (6))){
var inst_24259 = (state_24270[(8)]);
var inst_24256 = (state_24270[(7)]);
var inst_24263 = (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(inst_24256,inst_24259) : f.call(null,inst_24256,inst_24259));
var inst_24256__$1 = inst_24263;
var state_24270__$1 = (function (){var statearr_24278 = state_24270;
(statearr_24278[(7)] = inst_24256__$1);

return statearr_24278;
})();
var statearr_24279_24292 = state_24270__$1;
(statearr_24279_24292[(2)] = null);

(statearr_24279_24292[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24271 === (7))){
var inst_24266 = (state_24270[(2)]);
var state_24270__$1 = state_24270;
var statearr_24280_24293 = state_24270__$1;
(statearr_24280_24293[(2)] = inst_24266);

(statearr_24280_24293[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(c__16730__auto__))
;
return ((function (switch__16649__auto__,c__16730__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__16650__auto__ = null;
var cljs$core$async$reduce_$_state_machine__16650__auto____0 = (function (){
var statearr_24284 = [null,null,null,null,null,null,null,null,null];
(statearr_24284[(0)] = cljs$core$async$reduce_$_state_machine__16650__auto__);

(statearr_24284[(1)] = (1));

return statearr_24284;
});
var cljs$core$async$reduce_$_state_machine__16650__auto____1 = (function (state_24270){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_24270);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e24285){if((e24285 instanceof Object)){
var ex__16653__auto__ = e24285;
var statearr_24286_24294 = state_24270;
(statearr_24286_24294[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_24270);

return cljs.core.cst$kw$recur;
} else {
throw e24285;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__24295 = state_24270;
state_24270 = G__24295;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__16650__auto__ = function(state_24270){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__16650__auto____1.call(this,state_24270);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__16650__auto____0;
cljs$core$async$reduce_$_state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__16650__auto____1;
return cljs$core$async$reduce_$_state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto__))
})();
var state__16732__auto__ = (function (){var statearr_24287 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_24287[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto__);

return statearr_24287;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto__))
);

return c__16730__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args24296 = [];
var len__5570__auto___24348 = arguments.length;
var i__5571__auto___24349 = (0);
while(true){
if((i__5571__auto___24349 < len__5570__auto___24348)){
args24296.push((arguments[i__5571__auto___24349]));

var G__24350 = (i__5571__auto___24349 + (1));
i__5571__auto___24349 = G__24350;
continue;
} else {
}
break;
}

var G__24298 = args24296.length;
switch (G__24298) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args24296.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__16730__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto__){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto__){
return (function (state_24323){
var state_val_24324 = (state_24323[(1)]);
if((state_val_24324 === (7))){
var inst_24305 = (state_24323[(2)]);
var state_24323__$1 = state_24323;
var statearr_24325_24352 = state_24323__$1;
(statearr_24325_24352[(2)] = inst_24305);

(statearr_24325_24352[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (1))){
var inst_24299 = cljs.core.seq(coll);
var inst_24300 = inst_24299;
var state_24323__$1 = (function (){var statearr_24326 = state_24323;
(statearr_24326[(7)] = inst_24300);

return statearr_24326;
})();
var statearr_24327_24353 = state_24323__$1;
(statearr_24327_24353[(2)] = null);

(statearr_24327_24353[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (4))){
var inst_24300 = (state_24323[(7)]);
var inst_24303 = cljs.core.first(inst_24300);
var state_24323__$1 = state_24323;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_24323__$1,(7),ch,inst_24303);
} else {
if((state_val_24324 === (13))){
var inst_24317 = (state_24323[(2)]);
var state_24323__$1 = state_24323;
var statearr_24328_24354 = state_24323__$1;
(statearr_24328_24354[(2)] = inst_24317);

(statearr_24328_24354[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (6))){
var inst_24308 = (state_24323[(2)]);
var state_24323__$1 = state_24323;
if(cljs.core.truth_(inst_24308)){
var statearr_24329_24355 = state_24323__$1;
(statearr_24329_24355[(1)] = (8));

} else {
var statearr_24330_24356 = state_24323__$1;
(statearr_24330_24356[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (3))){
var inst_24321 = (state_24323[(2)]);
var state_24323__$1 = state_24323;
return cljs.core.async.impl.ioc_helpers.return_chan(state_24323__$1,inst_24321);
} else {
if((state_val_24324 === (12))){
var state_24323__$1 = state_24323;
var statearr_24331_24357 = state_24323__$1;
(statearr_24331_24357[(2)] = null);

(statearr_24331_24357[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (2))){
var inst_24300 = (state_24323[(7)]);
var state_24323__$1 = state_24323;
if(cljs.core.truth_(inst_24300)){
var statearr_24332_24358 = state_24323__$1;
(statearr_24332_24358[(1)] = (4));

} else {
var statearr_24333_24359 = state_24323__$1;
(statearr_24333_24359[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (11))){
var inst_24314 = cljs.core.async.close_BANG_(ch);
var state_24323__$1 = state_24323;
var statearr_24334_24360 = state_24323__$1;
(statearr_24334_24360[(2)] = inst_24314);

(statearr_24334_24360[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (9))){
var state_24323__$1 = state_24323;
if(cljs.core.truth_(close_QMARK_)){
var statearr_24335_24361 = state_24323__$1;
(statearr_24335_24361[(1)] = (11));

} else {
var statearr_24336_24362 = state_24323__$1;
(statearr_24336_24362[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (5))){
var inst_24300 = (state_24323[(7)]);
var state_24323__$1 = state_24323;
var statearr_24337_24363 = state_24323__$1;
(statearr_24337_24363[(2)] = inst_24300);

(statearr_24337_24363[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (10))){
var inst_24319 = (state_24323[(2)]);
var state_24323__$1 = state_24323;
var statearr_24338_24364 = state_24323__$1;
(statearr_24338_24364[(2)] = inst_24319);

(statearr_24338_24364[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24324 === (8))){
var inst_24300 = (state_24323[(7)]);
var inst_24310 = cljs.core.next(inst_24300);
var inst_24300__$1 = inst_24310;
var state_24323__$1 = (function (){var statearr_24339 = state_24323;
(statearr_24339[(7)] = inst_24300__$1);

return statearr_24339;
})();
var statearr_24340_24365 = state_24323__$1;
(statearr_24340_24365[(2)] = null);

(statearr_24340_24365[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto__))
;
return ((function (switch__16649__auto__,c__16730__auto__){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_24344 = [null,null,null,null,null,null,null,null];
(statearr_24344[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_24344[(1)] = (1));

return statearr_24344;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_24323){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_24323);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e24345){if((e24345 instanceof Object)){
var ex__16653__auto__ = e24345;
var statearr_24346_24366 = state_24323;
(statearr_24346_24366[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_24323);

return cljs.core.cst$kw$recur;
} else {
throw e24345;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__24367 = state_24323;
state_24323 = G__24367;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_24323){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_24323);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto__))
})();
var state__16732__auto__ = (function (){var statearr_24347 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_24347[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto__);

return statearr_24347;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto__))
);

return c__16730__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;
/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__5167__auto__ = (((_ == null))?null:_);
var m__5168__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__5168__auto__.call(null,_));
} else {
var m__5168__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$1(_) : m__5168__auto____$1.call(null,_));
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__5167__auto__ = (((m == null))?null:m);
var m__5168__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__5168__auto__.call(null,m,ch,close_QMARK_));
} else {
var m__5168__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$3 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__5168__auto____$1.call(null,m,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__5167__auto__ = (((m == null))?null:m);
var m__5168__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5168__auto__.call(null,m,ch));
} else {
var m__5168__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5168__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__5167__auto__ = (((m == null))?null:m);
var m__5168__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5168__auto__.call(null,m));
} else {
var m__5168__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$1(m) : m__5168__auto____$1.call(null,m));
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = (function (){var G__24592 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__24592) : cljs.core.atom.call(null,G__24592));
})();
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async24593 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async24593 = (function (mult,ch,cs,meta24594){
this.mult = mult;
this.ch = ch;
this.cs = cs;
this.meta24594 = meta24594;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async24593.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_24595,meta24594__$1){
var self__ = this;
var _24595__$1 = this;
return (new cljs.core.async.t_cljs$core$async24593(self__.mult,self__.ch,self__.cs,meta24594__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async24593.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_24595){
var self__ = this;
var _24595__$1 = this;
return self__.meta24594;
});})(cs))
;

cljs.core.async.t_cljs$core$async24593.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async24593.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async24593.prototype.cljs$core$async$Mult$ = true;

cljs.core.async.t_cljs$core$async24593.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async24593.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async24593.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__24596_24816 = self__.cs;
var G__24597_24817 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__24596_24816,G__24597_24817) : cljs.core.reset_BANG_.call(null,G__24596_24816,G__24597_24817));

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async24593.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$mult,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Creates and returns a mult(iple) of the supplied channel. Channels\n  containing copies of the channel can be created with 'tap', and\n  detached with 'untap'.\n\n  Each item is distributed to all taps in parallel and synchronously,\n  i.e. each tap must accept before the next item is distributed. Use\n  buffering/windowing to prevent slow taps from holding up the mult.\n\n  Items received when there are no taps get dropped.\n\n  If a tap puts to a closed channel, it will be removed from the mult."], null)),cljs.core.cst$sym$ch,cljs.core.cst$sym$cs,cljs.core.cst$sym$meta24594], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async24593.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async24593.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async24593";

cljs.core.async.t_cljs$core$async24593.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async24593");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async24593 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async24593(mult__$1,ch__$1,cs__$1,meta24594){
return (new cljs.core.async.t_cljs$core$async24593(mult__$1,ch__$1,cs__$1,meta24594));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async24593(cljs$core$async$mult,ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null) : cljs.core.atom.call(null,null));
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__16730__auto___24818 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___24818,cs,m,dchan,dctr,done){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___24818,cs,m,dchan,dctr,done){
return (function (state_24728){
var state_val_24729 = (state_24728[(1)]);
if((state_val_24729 === (7))){
var inst_24724 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24730_24819 = state_24728__$1;
(statearr_24730_24819[(2)] = inst_24724);

(statearr_24730_24819[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (20))){
var inst_24629 = (state_24728[(7)]);
var inst_24639 = cljs.core.first(inst_24629);
var inst_24640 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_24639,(0),null);
var inst_24641 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_24639,(1),null);
var state_24728__$1 = (function (){var statearr_24731 = state_24728;
(statearr_24731[(8)] = inst_24640);

return statearr_24731;
})();
if(cljs.core.truth_(inst_24641)){
var statearr_24732_24820 = state_24728__$1;
(statearr_24732_24820[(1)] = (22));

} else {
var statearr_24733_24821 = state_24728__$1;
(statearr_24733_24821[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (27))){
var inst_24671 = (state_24728[(9)]);
var inst_24600 = (state_24728[(10)]);
var inst_24669 = (state_24728[(11)]);
var inst_24676 = (state_24728[(12)]);
var inst_24676__$1 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_24669,inst_24671);
var inst_24677 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_24676__$1,inst_24600,done);
var state_24728__$1 = (function (){var statearr_24734 = state_24728;
(statearr_24734[(12)] = inst_24676__$1);

return statearr_24734;
})();
if(cljs.core.truth_(inst_24677)){
var statearr_24735_24822 = state_24728__$1;
(statearr_24735_24822[(1)] = (30));

} else {
var statearr_24736_24823 = state_24728__$1;
(statearr_24736_24823[(1)] = (31));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (1))){
var state_24728__$1 = state_24728;
var statearr_24737_24824 = state_24728__$1;
(statearr_24737_24824[(2)] = null);

(statearr_24737_24824[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (24))){
var inst_24629 = (state_24728[(7)]);
var inst_24646 = (state_24728[(2)]);
var inst_24647 = cljs.core.next(inst_24629);
var inst_24609 = inst_24647;
var inst_24610 = null;
var inst_24611 = (0);
var inst_24612 = (0);
var state_24728__$1 = (function (){var statearr_24738 = state_24728;
(statearr_24738[(13)] = inst_24609);

(statearr_24738[(14)] = inst_24612);

(statearr_24738[(15)] = inst_24611);

(statearr_24738[(16)] = inst_24646);

(statearr_24738[(17)] = inst_24610);

return statearr_24738;
})();
var statearr_24739_24825 = state_24728__$1;
(statearr_24739_24825[(2)] = null);

(statearr_24739_24825[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (39))){
var state_24728__$1 = state_24728;
var statearr_24743_24826 = state_24728__$1;
(statearr_24743_24826[(2)] = null);

(statearr_24743_24826[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (4))){
var inst_24600 = (state_24728[(10)]);
var inst_24600__$1 = (state_24728[(2)]);
var inst_24601 = (inst_24600__$1 == null);
var state_24728__$1 = (function (){var statearr_24744 = state_24728;
(statearr_24744[(10)] = inst_24600__$1);

return statearr_24744;
})();
if(cljs.core.truth_(inst_24601)){
var statearr_24745_24827 = state_24728__$1;
(statearr_24745_24827[(1)] = (5));

} else {
var statearr_24746_24828 = state_24728__$1;
(statearr_24746_24828[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (15))){
var inst_24609 = (state_24728[(13)]);
var inst_24612 = (state_24728[(14)]);
var inst_24611 = (state_24728[(15)]);
var inst_24610 = (state_24728[(17)]);
var inst_24625 = (state_24728[(2)]);
var inst_24626 = (inst_24612 + (1));
var tmp24740 = inst_24609;
var tmp24741 = inst_24611;
var tmp24742 = inst_24610;
var inst_24609__$1 = tmp24740;
var inst_24610__$1 = tmp24742;
var inst_24611__$1 = tmp24741;
var inst_24612__$1 = inst_24626;
var state_24728__$1 = (function (){var statearr_24747 = state_24728;
(statearr_24747[(13)] = inst_24609__$1);

(statearr_24747[(14)] = inst_24612__$1);

(statearr_24747[(15)] = inst_24611__$1);

(statearr_24747[(18)] = inst_24625);

(statearr_24747[(17)] = inst_24610__$1);

return statearr_24747;
})();
var statearr_24748_24829 = state_24728__$1;
(statearr_24748_24829[(2)] = null);

(statearr_24748_24829[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (21))){
var inst_24650 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24752_24830 = state_24728__$1;
(statearr_24752_24830[(2)] = inst_24650);

(statearr_24752_24830[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (31))){
var inst_24676 = (state_24728[(12)]);
var inst_24680 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var inst_24681 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_24676);
var state_24728__$1 = (function (){var statearr_24753 = state_24728;
(statearr_24753[(19)] = inst_24680);

return statearr_24753;
})();
var statearr_24754_24831 = state_24728__$1;
(statearr_24754_24831[(2)] = inst_24681);

(statearr_24754_24831[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (32))){
var inst_24671 = (state_24728[(9)]);
var inst_24670 = (state_24728[(20)]);
var inst_24668 = (state_24728[(21)]);
var inst_24669 = (state_24728[(11)]);
var inst_24683 = (state_24728[(2)]);
var inst_24684 = (inst_24671 + (1));
var tmp24749 = inst_24670;
var tmp24750 = inst_24668;
var tmp24751 = inst_24669;
var inst_24668__$1 = tmp24750;
var inst_24669__$1 = tmp24751;
var inst_24670__$1 = tmp24749;
var inst_24671__$1 = inst_24684;
var state_24728__$1 = (function (){var statearr_24755 = state_24728;
(statearr_24755[(22)] = inst_24683);

(statearr_24755[(9)] = inst_24671__$1);

(statearr_24755[(20)] = inst_24670__$1);

(statearr_24755[(21)] = inst_24668__$1);

(statearr_24755[(11)] = inst_24669__$1);

return statearr_24755;
})();
var statearr_24756_24832 = state_24728__$1;
(statearr_24756_24832[(2)] = null);

(statearr_24756_24832[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (40))){
var inst_24696 = (state_24728[(23)]);
var inst_24700 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var inst_24701 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_24696);
var state_24728__$1 = (function (){var statearr_24757 = state_24728;
(statearr_24757[(24)] = inst_24700);

return statearr_24757;
})();
var statearr_24758_24833 = state_24728__$1;
(statearr_24758_24833[(2)] = inst_24701);

(statearr_24758_24833[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (33))){
var inst_24687 = (state_24728[(25)]);
var inst_24689 = cljs.core.chunked_seq_QMARK_(inst_24687);
var state_24728__$1 = state_24728;
if(inst_24689){
var statearr_24759_24834 = state_24728__$1;
(statearr_24759_24834[(1)] = (36));

} else {
var statearr_24760_24835 = state_24728__$1;
(statearr_24760_24835[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (13))){
var inst_24619 = (state_24728[(26)]);
var inst_24622 = cljs.core.async.close_BANG_(inst_24619);
var state_24728__$1 = state_24728;
var statearr_24761_24836 = state_24728__$1;
(statearr_24761_24836[(2)] = inst_24622);

(statearr_24761_24836[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (22))){
var inst_24640 = (state_24728[(8)]);
var inst_24643 = cljs.core.async.close_BANG_(inst_24640);
var state_24728__$1 = state_24728;
var statearr_24762_24837 = state_24728__$1;
(statearr_24762_24837[(2)] = inst_24643);

(statearr_24762_24837[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (36))){
var inst_24687 = (state_24728[(25)]);
var inst_24691 = cljs.core.chunk_first(inst_24687);
var inst_24692 = cljs.core.chunk_rest(inst_24687);
var inst_24693 = cljs.core.count(inst_24691);
var inst_24668 = inst_24692;
var inst_24669 = inst_24691;
var inst_24670 = inst_24693;
var inst_24671 = (0);
var state_24728__$1 = (function (){var statearr_24763 = state_24728;
(statearr_24763[(9)] = inst_24671);

(statearr_24763[(20)] = inst_24670);

(statearr_24763[(21)] = inst_24668);

(statearr_24763[(11)] = inst_24669);

return statearr_24763;
})();
var statearr_24764_24838 = state_24728__$1;
(statearr_24764_24838[(2)] = null);

(statearr_24764_24838[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (41))){
var inst_24687 = (state_24728[(25)]);
var inst_24703 = (state_24728[(2)]);
var inst_24704 = cljs.core.next(inst_24687);
var inst_24668 = inst_24704;
var inst_24669 = null;
var inst_24670 = (0);
var inst_24671 = (0);
var state_24728__$1 = (function (){var statearr_24765 = state_24728;
(statearr_24765[(27)] = inst_24703);

(statearr_24765[(9)] = inst_24671);

(statearr_24765[(20)] = inst_24670);

(statearr_24765[(21)] = inst_24668);

(statearr_24765[(11)] = inst_24669);

return statearr_24765;
})();
var statearr_24766_24839 = state_24728__$1;
(statearr_24766_24839[(2)] = null);

(statearr_24766_24839[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (43))){
var state_24728__$1 = state_24728;
var statearr_24767_24840 = state_24728__$1;
(statearr_24767_24840[(2)] = null);

(statearr_24767_24840[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (29))){
var inst_24712 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24768_24841 = state_24728__$1;
(statearr_24768_24841[(2)] = inst_24712);

(statearr_24768_24841[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (44))){
var inst_24721 = (state_24728[(2)]);
var state_24728__$1 = (function (){var statearr_24769 = state_24728;
(statearr_24769[(28)] = inst_24721);

return statearr_24769;
})();
var statearr_24770_24842 = state_24728__$1;
(statearr_24770_24842[(2)] = null);

(statearr_24770_24842[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (6))){
var inst_24660 = (state_24728[(29)]);
var inst_24659 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var inst_24660__$1 = cljs.core.keys(inst_24659);
var inst_24661 = cljs.core.count(inst_24660__$1);
var inst_24662 = (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,inst_24661) : cljs.core.reset_BANG_.call(null,dctr,inst_24661));
var inst_24667 = cljs.core.seq(inst_24660__$1);
var inst_24668 = inst_24667;
var inst_24669 = null;
var inst_24670 = (0);
var inst_24671 = (0);
var state_24728__$1 = (function (){var statearr_24771 = state_24728;
(statearr_24771[(9)] = inst_24671);

(statearr_24771[(29)] = inst_24660__$1);

(statearr_24771[(20)] = inst_24670);

(statearr_24771[(30)] = inst_24662);

(statearr_24771[(21)] = inst_24668);

(statearr_24771[(11)] = inst_24669);

return statearr_24771;
})();
var statearr_24772_24843 = state_24728__$1;
(statearr_24772_24843[(2)] = null);

(statearr_24772_24843[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (28))){
var inst_24687 = (state_24728[(25)]);
var inst_24668 = (state_24728[(21)]);
var inst_24687__$1 = cljs.core.seq(inst_24668);
var state_24728__$1 = (function (){var statearr_24773 = state_24728;
(statearr_24773[(25)] = inst_24687__$1);

return statearr_24773;
})();
if(inst_24687__$1){
var statearr_24774_24844 = state_24728__$1;
(statearr_24774_24844[(1)] = (33));

} else {
var statearr_24775_24845 = state_24728__$1;
(statearr_24775_24845[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (25))){
var inst_24671 = (state_24728[(9)]);
var inst_24670 = (state_24728[(20)]);
var inst_24673 = (inst_24671 < inst_24670);
var inst_24674 = inst_24673;
var state_24728__$1 = state_24728;
if(cljs.core.truth_(inst_24674)){
var statearr_24776_24846 = state_24728__$1;
(statearr_24776_24846[(1)] = (27));

} else {
var statearr_24777_24847 = state_24728__$1;
(statearr_24777_24847[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (34))){
var state_24728__$1 = state_24728;
var statearr_24778_24848 = state_24728__$1;
(statearr_24778_24848[(2)] = null);

(statearr_24778_24848[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (17))){
var state_24728__$1 = state_24728;
var statearr_24779_24849 = state_24728__$1;
(statearr_24779_24849[(2)] = null);

(statearr_24779_24849[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (3))){
var inst_24726 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
return cljs.core.async.impl.ioc_helpers.return_chan(state_24728__$1,inst_24726);
} else {
if((state_val_24729 === (12))){
var inst_24655 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24780_24850 = state_24728__$1;
(statearr_24780_24850[(2)] = inst_24655);

(statearr_24780_24850[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (2))){
var state_24728__$1 = state_24728;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_24728__$1,(4),ch);
} else {
if((state_val_24729 === (23))){
var state_24728__$1 = state_24728;
var statearr_24781_24851 = state_24728__$1;
(statearr_24781_24851[(2)] = null);

(statearr_24781_24851[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (35))){
var inst_24710 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24782_24852 = state_24728__$1;
(statearr_24782_24852[(2)] = inst_24710);

(statearr_24782_24852[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (19))){
var inst_24629 = (state_24728[(7)]);
var inst_24633 = cljs.core.chunk_first(inst_24629);
var inst_24634 = cljs.core.chunk_rest(inst_24629);
var inst_24635 = cljs.core.count(inst_24633);
var inst_24609 = inst_24634;
var inst_24610 = inst_24633;
var inst_24611 = inst_24635;
var inst_24612 = (0);
var state_24728__$1 = (function (){var statearr_24783 = state_24728;
(statearr_24783[(13)] = inst_24609);

(statearr_24783[(14)] = inst_24612);

(statearr_24783[(15)] = inst_24611);

(statearr_24783[(17)] = inst_24610);

return statearr_24783;
})();
var statearr_24784_24853 = state_24728__$1;
(statearr_24784_24853[(2)] = null);

(statearr_24784_24853[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (11))){
var inst_24609 = (state_24728[(13)]);
var inst_24629 = (state_24728[(7)]);
var inst_24629__$1 = cljs.core.seq(inst_24609);
var state_24728__$1 = (function (){var statearr_24785 = state_24728;
(statearr_24785[(7)] = inst_24629__$1);

return statearr_24785;
})();
if(inst_24629__$1){
var statearr_24786_24854 = state_24728__$1;
(statearr_24786_24854[(1)] = (16));

} else {
var statearr_24787_24855 = state_24728__$1;
(statearr_24787_24855[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (9))){
var inst_24657 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24788_24856 = state_24728__$1;
(statearr_24788_24856[(2)] = inst_24657);

(statearr_24788_24856[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (5))){
var inst_24607 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var inst_24608 = cljs.core.seq(inst_24607);
var inst_24609 = inst_24608;
var inst_24610 = null;
var inst_24611 = (0);
var inst_24612 = (0);
var state_24728__$1 = (function (){var statearr_24789 = state_24728;
(statearr_24789[(13)] = inst_24609);

(statearr_24789[(14)] = inst_24612);

(statearr_24789[(15)] = inst_24611);

(statearr_24789[(17)] = inst_24610);

return statearr_24789;
})();
var statearr_24790_24857 = state_24728__$1;
(statearr_24790_24857[(2)] = null);

(statearr_24790_24857[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (14))){
var state_24728__$1 = state_24728;
var statearr_24791_24858 = state_24728__$1;
(statearr_24791_24858[(2)] = null);

(statearr_24791_24858[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (45))){
var inst_24718 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24792_24859 = state_24728__$1;
(statearr_24792_24859[(2)] = inst_24718);

(statearr_24792_24859[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (26))){
var inst_24660 = (state_24728[(29)]);
var inst_24714 = (state_24728[(2)]);
var inst_24715 = cljs.core.seq(inst_24660);
var state_24728__$1 = (function (){var statearr_24793 = state_24728;
(statearr_24793[(31)] = inst_24714);

return statearr_24793;
})();
if(inst_24715){
var statearr_24794_24860 = state_24728__$1;
(statearr_24794_24860[(1)] = (42));

} else {
var statearr_24795_24861 = state_24728__$1;
(statearr_24795_24861[(1)] = (43));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (16))){
var inst_24629 = (state_24728[(7)]);
var inst_24631 = cljs.core.chunked_seq_QMARK_(inst_24629);
var state_24728__$1 = state_24728;
if(inst_24631){
var statearr_24796_24862 = state_24728__$1;
(statearr_24796_24862[(1)] = (19));

} else {
var statearr_24797_24863 = state_24728__$1;
(statearr_24797_24863[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (38))){
var inst_24707 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24798_24864 = state_24728__$1;
(statearr_24798_24864[(2)] = inst_24707);

(statearr_24798_24864[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (30))){
var state_24728__$1 = state_24728;
var statearr_24799_24865 = state_24728__$1;
(statearr_24799_24865[(2)] = null);

(statearr_24799_24865[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (10))){
var inst_24612 = (state_24728[(14)]);
var inst_24610 = (state_24728[(17)]);
var inst_24618 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_24610,inst_24612);
var inst_24619 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_24618,(0),null);
var inst_24620 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_24618,(1),null);
var state_24728__$1 = (function (){var statearr_24800 = state_24728;
(statearr_24800[(26)] = inst_24619);

return statearr_24800;
})();
if(cljs.core.truth_(inst_24620)){
var statearr_24801_24866 = state_24728__$1;
(statearr_24801_24866[(1)] = (13));

} else {
var statearr_24802_24867 = state_24728__$1;
(statearr_24802_24867[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (18))){
var inst_24653 = (state_24728[(2)]);
var state_24728__$1 = state_24728;
var statearr_24803_24868 = state_24728__$1;
(statearr_24803_24868[(2)] = inst_24653);

(statearr_24803_24868[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (42))){
var state_24728__$1 = state_24728;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_24728__$1,(45),dchan);
} else {
if((state_val_24729 === (37))){
var inst_24687 = (state_24728[(25)]);
var inst_24696 = (state_24728[(23)]);
var inst_24600 = (state_24728[(10)]);
var inst_24696__$1 = cljs.core.first(inst_24687);
var inst_24697 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_24696__$1,inst_24600,done);
var state_24728__$1 = (function (){var statearr_24804 = state_24728;
(statearr_24804[(23)] = inst_24696__$1);

return statearr_24804;
})();
if(cljs.core.truth_(inst_24697)){
var statearr_24805_24869 = state_24728__$1;
(statearr_24805_24869[(1)] = (39));

} else {
var statearr_24806_24870 = state_24728__$1;
(statearr_24806_24870[(1)] = (40));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_24729 === (8))){
var inst_24612 = (state_24728[(14)]);
var inst_24611 = (state_24728[(15)]);
var inst_24614 = (inst_24612 < inst_24611);
var inst_24615 = inst_24614;
var state_24728__$1 = state_24728;
if(cljs.core.truth_(inst_24615)){
var statearr_24807_24871 = state_24728__$1;
(statearr_24807_24871[(1)] = (10));

} else {
var statearr_24808_24872 = state_24728__$1;
(statearr_24808_24872[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___24818,cs,m,dchan,dctr,done))
;
return ((function (switch__16649__auto__,c__16730__auto___24818,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__16650__auto__ = null;
var cljs$core$async$mult_$_state_machine__16650__auto____0 = (function (){
var statearr_24812 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_24812[(0)] = cljs$core$async$mult_$_state_machine__16650__auto__);

(statearr_24812[(1)] = (1));

return statearr_24812;
});
var cljs$core$async$mult_$_state_machine__16650__auto____1 = (function (state_24728){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_24728);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e24813){if((e24813 instanceof Object)){
var ex__16653__auto__ = e24813;
var statearr_24814_24873 = state_24728;
(statearr_24814_24873[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_24728);

return cljs.core.cst$kw$recur;
} else {
throw e24813;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__24874 = state_24728;
state_24728 = G__24874;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__16650__auto__ = function(state_24728){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__16650__auto____1.call(this,state_24728);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__16650__auto____0;
cljs$core$async$mult_$_state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__16650__auto____1;
return cljs$core$async$mult_$_state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___24818,cs,m,dchan,dctr,done))
})();
var state__16732__auto__ = (function (){var statearr_24815 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_24815[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___24818);

return statearr_24815;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___24818,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args24875 = [];
var len__5570__auto___24878 = arguments.length;
var i__5571__auto___24879 = (0);
while(true){
if((i__5571__auto___24879 < len__5570__auto___24878)){
args24875.push((arguments[i__5571__auto___24879]));

var G__24880 = (i__5571__auto___24879 + (1));
i__5571__auto___24879 = G__24880;
continue;
} else {
}
break;
}

var G__24877 = args24875.length;
switch (G__24877) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args24875.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;
/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__5167__auto__ = (((m == null))?null:m);
var m__5168__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5168__auto__.call(null,m,ch));
} else {
var m__5168__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5168__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__5167__auto__ = (((m == null))?null:m);
var m__5168__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5168__auto__.call(null,m,ch));
} else {
var m__5168__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5168__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__5167__auto__ = (((m == null))?null:m);
var m__5168__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5168__auto__.call(null,m));
} else {
var m__5168__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$1(m) : m__5168__auto____$1.call(null,m));
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__5167__auto__ = (((m == null))?null:m);
var m__5168__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__5168__auto__.call(null,m,state_map));
} else {
var m__5168__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__5168__auto____$1.call(null,m,state_map));
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__5167__auto__ = (((m == null))?null:m);
var m__5168__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__5168__auto__.call(null,m,mode));
} else {
var m__5168__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2(m,mode) : m__5168__auto____$1.call(null,m,mode));
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
}
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = (function (){var G__25048 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__25048) : cljs.core.atom.call(null,G__25048));
})();
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$pause,null,cljs.core.cst$kw$mute,null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,cljs.core.cst$kw$solo);
var solo_mode = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.cst$kw$mute) : cljs.core.atom.call(null,cljs.core.cst$kw$mute));
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv(((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_((attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(v) : attr.call(null,v)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var mode = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(solo_mode) : cljs.core.deref.call(null,solo_mode));
var solos = pick(cljs.core.cst$kw$solo,chs);
var pauses = pick(cljs.core.cst$kw$pause,chs);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$solos,solos,cljs.core.cst$kw$mutes,pick(cljs.core.cst$kw$mute,chs),cljs.core.cst$kw$reads,cljs.core.conj.cljs$core$IFn$_invoke$arity$2((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,cljs.core.cst$kw$pause)) && (!(cljs.core.empty_QMARK_(solos))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async25049 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async25049 = (function (change,mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta25050){
this.change = change;
this.mix = mix;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta25050 = meta25050;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_25051,meta25050__$1){
var self__ = this;
var _25051__$1 = this;
return (new cljs.core.async.t_cljs$core$async25049(self__.change,self__.mix,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta25050__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_25051){
var self__ = this;
var _25051__$1 = this;
return self__.meta25050;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$async$Mix$ = true;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__25052_25214 = self__.cs;
var G__25053_25215 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__25052_25214,G__25053_25215) : cljs.core.reset_BANG_.call(null,G__25052_25214,G__25053_25215));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(mode) : self__.solo_modes.call(null,mode)))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(cljs.core.cst$sym$solo_DASH_modes,cljs.core.cst$sym$mode)], 0)))].join('')));
}

(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(self__.solo_mode,mode) : cljs.core.reset_BANG_.call(null,self__.solo_mode,mode));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$change,cljs.core.with_meta(cljs.core.cst$sym$mix,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$out], null))),cljs.core.cst$kw$doc,"Creates and returns a mix of one or more input channels which will\n  be put on the supplied out channel. Input sources can be added to\n  the mix with 'admix', and removed with 'unmix'. A mix supports\n  soloing, muting and pausing multiple inputs atomically using\n  'toggle', and can solo using either muting or pausing as determined\n  by 'solo-mode'.\n\n  Each channel can have zero or more boolean modes set via 'toggle':\n\n  :solo - when true, only this (ond other soloed) channel(s) will appear\n          in the mix output channel. :mute and :pause states of soloed\n          channels are ignored. If solo-mode is :mute, non-soloed\n          channels are muted, if :pause, non-soloed channels are\n          paused.\n\n  :mute - muted channels will have their contents consumed but not included in the mix\n  :pause - paused channels will not have their contents consumed (and thus also not included in the mix)\n"], null)),cljs.core.cst$sym$solo_DASH_mode,cljs.core.cst$sym$pick,cljs.core.cst$sym$cs,cljs.core.cst$sym$calc_DASH_state,cljs.core.cst$sym$out,cljs.core.cst$sym$changed,cljs.core.cst$sym$solo_DASH_modes,cljs.core.cst$sym$attrs,cljs.core.cst$sym$meta25050], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async25049.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async25049.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async25049";

cljs.core.async.t_cljs$core$async25049.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async25049");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async25049 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async25049(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta25050){
return (new cljs.core.async.t_cljs$core$async25049(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta25050));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async25049(change,cljs$core$async$mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__16730__auto___25216 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___25216,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___25216,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_25151){
var state_val_25152 = (state_25151[(1)]);
if((state_val_25152 === (7))){
var inst_25069 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
var statearr_25153_25217 = state_25151__$1;
(statearr_25153_25217[(2)] = inst_25069);

(statearr_25153_25217[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (20))){
var inst_25081 = (state_25151[(7)]);
var state_25151__$1 = state_25151;
var statearr_25154_25218 = state_25151__$1;
(statearr_25154_25218[(2)] = inst_25081);

(statearr_25154_25218[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (27))){
var state_25151__$1 = state_25151;
var statearr_25155_25219 = state_25151__$1;
(statearr_25155_25219[(2)] = null);

(statearr_25155_25219[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (1))){
var inst_25057 = (state_25151[(8)]);
var inst_25057__$1 = calc_state();
var inst_25059 = (inst_25057__$1 == null);
var inst_25060 = cljs.core.not(inst_25059);
var state_25151__$1 = (function (){var statearr_25156 = state_25151;
(statearr_25156[(8)] = inst_25057__$1);

return statearr_25156;
})();
if(inst_25060){
var statearr_25157_25220 = state_25151__$1;
(statearr_25157_25220[(1)] = (2));

} else {
var statearr_25158_25221 = state_25151__$1;
(statearr_25158_25221[(1)] = (3));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (24))){
var inst_25104 = (state_25151[(9)]);
var inst_25125 = (state_25151[(10)]);
var inst_25111 = (state_25151[(11)]);
var inst_25125__$1 = (inst_25104.cljs$core$IFn$_invoke$arity$1 ? inst_25104.cljs$core$IFn$_invoke$arity$1(inst_25111) : inst_25104.call(null,inst_25111));
var state_25151__$1 = (function (){var statearr_25159 = state_25151;
(statearr_25159[(10)] = inst_25125__$1);

return statearr_25159;
})();
if(cljs.core.truth_(inst_25125__$1)){
var statearr_25160_25222 = state_25151__$1;
(statearr_25160_25222[(1)] = (29));

} else {
var statearr_25161_25223 = state_25151__$1;
(statearr_25161_25223[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (4))){
var inst_25072 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
if(cljs.core.truth_(inst_25072)){
var statearr_25162_25224 = state_25151__$1;
(statearr_25162_25224[(1)] = (8));

} else {
var statearr_25163_25225 = state_25151__$1;
(statearr_25163_25225[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (15))){
var inst_25098 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
if(cljs.core.truth_(inst_25098)){
var statearr_25164_25226 = state_25151__$1;
(statearr_25164_25226[(1)] = (19));

} else {
var statearr_25165_25227 = state_25151__$1;
(statearr_25165_25227[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (21))){
var inst_25103 = (state_25151[(12)]);
var inst_25103__$1 = (state_25151[(2)]);
var inst_25104 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_25103__$1,cljs.core.cst$kw$solos);
var inst_25105 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_25103__$1,cljs.core.cst$kw$mutes);
var inst_25106 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_25103__$1,cljs.core.cst$kw$reads);
var state_25151__$1 = (function (){var statearr_25166 = state_25151;
(statearr_25166[(9)] = inst_25104);

(statearr_25166[(12)] = inst_25103__$1);

(statearr_25166[(13)] = inst_25105);

return statearr_25166;
})();
return cljs.core.async.impl.ioc_helpers.ioc_alts_BANG_(state_25151__$1,(22),inst_25106);
} else {
if((state_val_25152 === (31))){
var inst_25133 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
if(cljs.core.truth_(inst_25133)){
var statearr_25167_25228 = state_25151__$1;
(statearr_25167_25228[(1)] = (32));

} else {
var statearr_25168_25229 = state_25151__$1;
(statearr_25168_25229[(1)] = (33));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (32))){
var inst_25110 = (state_25151[(14)]);
var state_25151__$1 = state_25151;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25151__$1,(35),out,inst_25110);
} else {
if((state_val_25152 === (33))){
var inst_25103 = (state_25151[(12)]);
var inst_25081 = inst_25103;
var state_25151__$1 = (function (){var statearr_25169 = state_25151;
(statearr_25169[(7)] = inst_25081);

return statearr_25169;
})();
var statearr_25170_25230 = state_25151__$1;
(statearr_25170_25230[(2)] = null);

(statearr_25170_25230[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (13))){
var inst_25081 = (state_25151[(7)]);
var inst_25088 = inst_25081.cljs$lang$protocol_mask$partition0$;
var inst_25089 = (inst_25088 & (64));
var inst_25090 = inst_25081.cljs$core$ISeq$;
var inst_25091 = (inst_25089) || (inst_25090);
var state_25151__$1 = state_25151;
if(cljs.core.truth_(inst_25091)){
var statearr_25171_25231 = state_25151__$1;
(statearr_25171_25231[(1)] = (16));

} else {
var statearr_25172_25232 = state_25151__$1;
(statearr_25172_25232[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (22))){
var inst_25110 = (state_25151[(14)]);
var inst_25111 = (state_25151[(11)]);
var inst_25109 = (state_25151[(2)]);
var inst_25110__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_25109,(0),null);
var inst_25111__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_25109,(1),null);
var inst_25112 = (inst_25110__$1 == null);
var inst_25113 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_25111__$1,change);
var inst_25114 = (inst_25112) || (inst_25113);
var state_25151__$1 = (function (){var statearr_25173 = state_25151;
(statearr_25173[(14)] = inst_25110__$1);

(statearr_25173[(11)] = inst_25111__$1);

return statearr_25173;
})();
if(cljs.core.truth_(inst_25114)){
var statearr_25174_25233 = state_25151__$1;
(statearr_25174_25233[(1)] = (23));

} else {
var statearr_25175_25234 = state_25151__$1;
(statearr_25175_25234[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (36))){
var inst_25103 = (state_25151[(12)]);
var inst_25081 = inst_25103;
var state_25151__$1 = (function (){var statearr_25176 = state_25151;
(statearr_25176[(7)] = inst_25081);

return statearr_25176;
})();
var statearr_25177_25235 = state_25151__$1;
(statearr_25177_25235[(2)] = null);

(statearr_25177_25235[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (29))){
var inst_25125 = (state_25151[(10)]);
var state_25151__$1 = state_25151;
var statearr_25178_25236 = state_25151__$1;
(statearr_25178_25236[(2)] = inst_25125);

(statearr_25178_25236[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (6))){
var state_25151__$1 = state_25151;
var statearr_25179_25237 = state_25151__$1;
(statearr_25179_25237[(2)] = false);

(statearr_25179_25237[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (28))){
var inst_25121 = (state_25151[(2)]);
var inst_25122 = calc_state();
var inst_25081 = inst_25122;
var state_25151__$1 = (function (){var statearr_25180 = state_25151;
(statearr_25180[(7)] = inst_25081);

(statearr_25180[(15)] = inst_25121);

return statearr_25180;
})();
var statearr_25181_25238 = state_25151__$1;
(statearr_25181_25238[(2)] = null);

(statearr_25181_25238[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (25))){
var inst_25147 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
var statearr_25182_25239 = state_25151__$1;
(statearr_25182_25239[(2)] = inst_25147);

(statearr_25182_25239[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (34))){
var inst_25145 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
var statearr_25183_25240 = state_25151__$1;
(statearr_25183_25240[(2)] = inst_25145);

(statearr_25183_25240[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (17))){
var state_25151__$1 = state_25151;
var statearr_25184_25241 = state_25151__$1;
(statearr_25184_25241[(2)] = false);

(statearr_25184_25241[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (3))){
var state_25151__$1 = state_25151;
var statearr_25185_25242 = state_25151__$1;
(statearr_25185_25242[(2)] = false);

(statearr_25185_25242[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (12))){
var inst_25149 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
return cljs.core.async.impl.ioc_helpers.return_chan(state_25151__$1,inst_25149);
} else {
if((state_val_25152 === (2))){
var inst_25057 = (state_25151[(8)]);
var inst_25062 = inst_25057.cljs$lang$protocol_mask$partition0$;
var inst_25063 = (inst_25062 & (64));
var inst_25064 = inst_25057.cljs$core$ISeq$;
var inst_25065 = (inst_25063) || (inst_25064);
var state_25151__$1 = state_25151;
if(cljs.core.truth_(inst_25065)){
var statearr_25186_25243 = state_25151__$1;
(statearr_25186_25243[(1)] = (5));

} else {
var statearr_25187_25244 = state_25151__$1;
(statearr_25187_25244[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (23))){
var inst_25110 = (state_25151[(14)]);
var inst_25116 = (inst_25110 == null);
var state_25151__$1 = state_25151;
if(cljs.core.truth_(inst_25116)){
var statearr_25188_25245 = state_25151__$1;
(statearr_25188_25245[(1)] = (26));

} else {
var statearr_25189_25246 = state_25151__$1;
(statearr_25189_25246[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (35))){
var inst_25136 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
if(cljs.core.truth_(inst_25136)){
var statearr_25190_25247 = state_25151__$1;
(statearr_25190_25247[(1)] = (36));

} else {
var statearr_25191_25248 = state_25151__$1;
(statearr_25191_25248[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (19))){
var inst_25081 = (state_25151[(7)]);
var inst_25100 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_25081);
var state_25151__$1 = state_25151;
var statearr_25192_25249 = state_25151__$1;
(statearr_25192_25249[(2)] = inst_25100);

(statearr_25192_25249[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (11))){
var inst_25081 = (state_25151[(7)]);
var inst_25085 = (inst_25081 == null);
var inst_25086 = cljs.core.not(inst_25085);
var state_25151__$1 = state_25151;
if(inst_25086){
var statearr_25193_25250 = state_25151__$1;
(statearr_25193_25250[(1)] = (13));

} else {
var statearr_25194_25251 = state_25151__$1;
(statearr_25194_25251[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (9))){
var inst_25057 = (state_25151[(8)]);
var state_25151__$1 = state_25151;
var statearr_25195_25252 = state_25151__$1;
(statearr_25195_25252[(2)] = inst_25057);

(statearr_25195_25252[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (5))){
var state_25151__$1 = state_25151;
var statearr_25196_25253 = state_25151__$1;
(statearr_25196_25253[(2)] = true);

(statearr_25196_25253[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (14))){
var state_25151__$1 = state_25151;
var statearr_25197_25254 = state_25151__$1;
(statearr_25197_25254[(2)] = false);

(statearr_25197_25254[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (26))){
var inst_25111 = (state_25151[(11)]);
var inst_25118 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_25111);
var state_25151__$1 = state_25151;
var statearr_25198_25255 = state_25151__$1;
(statearr_25198_25255[(2)] = inst_25118);

(statearr_25198_25255[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (16))){
var state_25151__$1 = state_25151;
var statearr_25199_25256 = state_25151__$1;
(statearr_25199_25256[(2)] = true);

(statearr_25199_25256[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (38))){
var inst_25141 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
var statearr_25200_25257 = state_25151__$1;
(statearr_25200_25257[(2)] = inst_25141);

(statearr_25200_25257[(1)] = (34));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (30))){
var inst_25104 = (state_25151[(9)]);
var inst_25105 = (state_25151[(13)]);
var inst_25111 = (state_25151[(11)]);
var inst_25128 = cljs.core.empty_QMARK_(inst_25104);
var inst_25129 = (inst_25105.cljs$core$IFn$_invoke$arity$1 ? inst_25105.cljs$core$IFn$_invoke$arity$1(inst_25111) : inst_25105.call(null,inst_25111));
var inst_25130 = cljs.core.not(inst_25129);
var inst_25131 = (inst_25128) && (inst_25130);
var state_25151__$1 = state_25151;
var statearr_25201_25258 = state_25151__$1;
(statearr_25201_25258[(2)] = inst_25131);

(statearr_25201_25258[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (10))){
var inst_25057 = (state_25151[(8)]);
var inst_25077 = (state_25151[(2)]);
var inst_25078 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_25077,cljs.core.cst$kw$solos);
var inst_25079 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_25077,cljs.core.cst$kw$mutes);
var inst_25080 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_25077,cljs.core.cst$kw$reads);
var inst_25081 = inst_25057;
var state_25151__$1 = (function (){var statearr_25202 = state_25151;
(statearr_25202[(7)] = inst_25081);

(statearr_25202[(16)] = inst_25079);

(statearr_25202[(17)] = inst_25078);

(statearr_25202[(18)] = inst_25080);

return statearr_25202;
})();
var statearr_25203_25259 = state_25151__$1;
(statearr_25203_25259[(2)] = null);

(statearr_25203_25259[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (18))){
var inst_25095 = (state_25151[(2)]);
var state_25151__$1 = state_25151;
var statearr_25204_25260 = state_25151__$1;
(statearr_25204_25260[(2)] = inst_25095);

(statearr_25204_25260[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (37))){
var state_25151__$1 = state_25151;
var statearr_25205_25261 = state_25151__$1;
(statearr_25205_25261[(2)] = null);

(statearr_25205_25261[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25152 === (8))){
var inst_25057 = (state_25151[(8)]);
var inst_25074 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_25057);
var state_25151__$1 = state_25151;
var statearr_25206_25262 = state_25151__$1;
(statearr_25206_25262[(2)] = inst_25074);

(statearr_25206_25262[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___25216,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__16649__auto__,c__16730__auto___25216,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__16650__auto__ = null;
var cljs$core$async$mix_$_state_machine__16650__auto____0 = (function (){
var statearr_25210 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_25210[(0)] = cljs$core$async$mix_$_state_machine__16650__auto__);

(statearr_25210[(1)] = (1));

return statearr_25210;
});
var cljs$core$async$mix_$_state_machine__16650__auto____1 = (function (state_25151){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_25151);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e25211){if((e25211 instanceof Object)){
var ex__16653__auto__ = e25211;
var statearr_25212_25263 = state_25151;
(statearr_25212_25263[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_25151);

return cljs.core.cst$kw$recur;
} else {
throw e25211;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__25264 = state_25151;
state_25151 = G__25264;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__16650__auto__ = function(state_25151){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__16650__auto____1.call(this,state_25151);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__16650__auto____0;
cljs$core$async$mix_$_state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__16650__auto____1;
return cljs$core$async$mix_$_state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___25216,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__16732__auto__ = (function (){var statearr_25213 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_25213[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___25216);

return statearr_25213;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___25216,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__5167__auto__ = (((p == null))?null:p);
var m__5168__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$4 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__5168__auto__.call(null,p,v,ch,close_QMARK_));
} else {
var m__5168__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$4 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__5168__auto____$1.call(null,p,v,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__5167__auto__ = (((p == null))?null:p);
var m__5168__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__5168__auto__.call(null,p,v,ch));
} else {
var m__5168__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$3 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__5168__auto____$1.call(null,p,v,ch));
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args25265 = [];
var len__5570__auto___25268 = arguments.length;
var i__5571__auto___25269 = (0);
while(true){
if((i__5571__auto___25269 < len__5570__auto___25268)){
args25265.push((arguments[i__5571__auto___25269]));

var G__25270 = (i__5571__auto___25269 + (1));
i__5571__auto___25269 = G__25270;
continue;
} else {
}
break;
}

var G__25267 = args25265.length;
switch (G__25267) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25265.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__5167__auto__ = (((p == null))?null:p);
var m__5168__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__5168__auto__.call(null,p));
} else {
var m__5168__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$1(p) : m__5168__auto____$1.call(null,p));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__5167__auto__ = (((p == null))?null:p);
var m__5168__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5167__auto__)]);
if(!((m__5168__auto__ == null))){
return (m__5168__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__5168__auto__.call(null,p,v));
} else {
var m__5168__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__5168__auto____$1 == null))){
return (m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5168__auto____$1.cljs$core$IFn$_invoke$arity$2(p,v) : m__5168__auto____$1.call(null,p,v));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;

/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args25273 = [];
var len__5570__auto___25401 = arguments.length;
var i__5571__auto___25402 = (0);
while(true){
if((i__5571__auto___25402 < len__5570__auto___25401)){
args25273.push((arguments[i__5571__auto___25402]));

var G__25403 = (i__5571__auto___25402 + (1));
i__5571__auto___25402 = G__25403;
continue;
} else {
}
break;
}

var G__25275 = args25273.length;
switch (G__25275) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25273.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = (function (){var G__25276 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__25276) : cljs.core.atom.call(null,G__25276));
})();
var ensure_mult = ((function (mults){
return (function (topic){
var or__4512__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults)),topic);
if(cljs.core.truth_(or__4512__auto__)){
return or__4512__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,((function (or__4512__auto__,mults){
return (function (p1__25272_SHARP_){
if(cljs.core.truth_((p1__25272_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__25272_SHARP_.cljs$core$IFn$_invoke$arity$1(topic) : p1__25272_SHARP_.call(null,topic)))){
return p1__25272_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__25272_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(topic) : buf_fn.call(null,topic)))));
}
});})(or__4512__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async25277 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async25277 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta25278){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta25278 = meta25278;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_25279,meta25278__$1){
var self__ = this;
var _25279__$1 = this;
return (new cljs.core.async.t_cljs$core$async25277(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta25278__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_25279){
var self__ = this;
var _25279__$1 = this;
return self__.meta25278;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$async$Pub$ = true;

cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(topic) : self__.ensure_mult.call(null,topic));
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4425__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(self__.mults) : cljs.core.deref.call(null,self__.mults)),topic);
if(cljs.core.truth_(temp__4425__auto__)){
var m = temp__4425__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__25280 = self__.mults;
var G__25281 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__25280,G__25281) : cljs.core.reset_BANG_.call(null,G__25280,G__25281));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async25277.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async25277.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch,cljs.core.cst$sym$topic_DASH_fn,cljs.core.cst$sym$buf_DASH_fn,cljs.core.cst$sym$mults,cljs.core.cst$sym$ensure_DASH_mult,cljs.core.cst$sym$meta25278], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async25277.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async25277.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async25277";

cljs.core.async.t_cljs$core$async25277.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__5110__auto__,writer__5111__auto__,opt__5112__auto__){
return cljs.core._write(writer__5111__auto__,"cljs.core.async/t_cljs$core$async25277");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async25277 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async25277(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta25278){
return (new cljs.core.async.t_cljs$core$async25277(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta25278));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async25277(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__16730__auto___25405 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___25405,mults,ensure_mult,p){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___25405,mults,ensure_mult,p){
return (function (state_25353){
var state_val_25354 = (state_25353[(1)]);
if((state_val_25354 === (7))){
var inst_25349 = (state_25353[(2)]);
var state_25353__$1 = state_25353;
var statearr_25355_25406 = state_25353__$1;
(statearr_25355_25406[(2)] = inst_25349);

(statearr_25355_25406[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (20))){
var state_25353__$1 = state_25353;
var statearr_25356_25407 = state_25353__$1;
(statearr_25356_25407[(2)] = null);

(statearr_25356_25407[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (1))){
var state_25353__$1 = state_25353;
var statearr_25357_25408 = state_25353__$1;
(statearr_25357_25408[(2)] = null);

(statearr_25357_25408[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (24))){
var inst_25332 = (state_25353[(7)]);
var inst_25341 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_25332);
var state_25353__$1 = state_25353;
var statearr_25358_25409 = state_25353__$1;
(statearr_25358_25409[(2)] = inst_25341);

(statearr_25358_25409[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (4))){
var inst_25284 = (state_25353[(8)]);
var inst_25284__$1 = (state_25353[(2)]);
var inst_25285 = (inst_25284__$1 == null);
var state_25353__$1 = (function (){var statearr_25359 = state_25353;
(statearr_25359[(8)] = inst_25284__$1);

return statearr_25359;
})();
if(cljs.core.truth_(inst_25285)){
var statearr_25360_25410 = state_25353__$1;
(statearr_25360_25410[(1)] = (5));

} else {
var statearr_25361_25411 = state_25353__$1;
(statearr_25361_25411[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (15))){
var inst_25326 = (state_25353[(2)]);
var state_25353__$1 = state_25353;
var statearr_25362_25412 = state_25353__$1;
(statearr_25362_25412[(2)] = inst_25326);

(statearr_25362_25412[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (21))){
var inst_25346 = (state_25353[(2)]);
var state_25353__$1 = (function (){var statearr_25363 = state_25353;
(statearr_25363[(9)] = inst_25346);

return statearr_25363;
})();
var statearr_25364_25413 = state_25353__$1;
(statearr_25364_25413[(2)] = null);

(statearr_25364_25413[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (13))){
var inst_25308 = (state_25353[(10)]);
var inst_25310 = cljs.core.chunked_seq_QMARK_(inst_25308);
var state_25353__$1 = state_25353;
if(inst_25310){
var statearr_25365_25414 = state_25353__$1;
(statearr_25365_25414[(1)] = (16));

} else {
var statearr_25366_25415 = state_25353__$1;
(statearr_25366_25415[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (22))){
var inst_25338 = (state_25353[(2)]);
var state_25353__$1 = state_25353;
if(cljs.core.truth_(inst_25338)){
var statearr_25367_25416 = state_25353__$1;
(statearr_25367_25416[(1)] = (23));

} else {
var statearr_25368_25417 = state_25353__$1;
(statearr_25368_25417[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (6))){
var inst_25284 = (state_25353[(8)]);
var inst_25332 = (state_25353[(7)]);
var inst_25334 = (state_25353[(11)]);
var inst_25332__$1 = (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(inst_25284) : topic_fn.call(null,inst_25284));
var inst_25333 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults));
var inst_25334__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_25333,inst_25332__$1);
var state_25353__$1 = (function (){var statearr_25369 = state_25353;
(statearr_25369[(7)] = inst_25332__$1);

(statearr_25369[(11)] = inst_25334__$1);

return statearr_25369;
})();
if(cljs.core.truth_(inst_25334__$1)){
var statearr_25370_25418 = state_25353__$1;
(statearr_25370_25418[(1)] = (19));

} else {
var statearr_25371_25419 = state_25353__$1;
(statearr_25371_25419[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (25))){
var inst_25343 = (state_25353[(2)]);
var state_25353__$1 = state_25353;
var statearr_25372_25420 = state_25353__$1;
(statearr_25372_25420[(2)] = inst_25343);

(statearr_25372_25420[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (17))){
var inst_25308 = (state_25353[(10)]);
var inst_25317 = cljs.core.first(inst_25308);
var inst_25318 = cljs.core.async.muxch_STAR_(inst_25317);
var inst_25319 = cljs.core.async.close_BANG_(inst_25318);
var inst_25320 = cljs.core.next(inst_25308);
var inst_25294 = inst_25320;
var inst_25295 = null;
var inst_25296 = (0);
var inst_25297 = (0);
var state_25353__$1 = (function (){var statearr_25373 = state_25353;
(statearr_25373[(12)] = inst_25296);

(statearr_25373[(13)] = inst_25294);

(statearr_25373[(14)] = inst_25297);

(statearr_25373[(15)] = inst_25319);

(statearr_25373[(16)] = inst_25295);

return statearr_25373;
})();
var statearr_25374_25421 = state_25353__$1;
(statearr_25374_25421[(2)] = null);

(statearr_25374_25421[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (3))){
var inst_25351 = (state_25353[(2)]);
var state_25353__$1 = state_25353;
return cljs.core.async.impl.ioc_helpers.return_chan(state_25353__$1,inst_25351);
} else {
if((state_val_25354 === (12))){
var inst_25328 = (state_25353[(2)]);
var state_25353__$1 = state_25353;
var statearr_25375_25422 = state_25353__$1;
(statearr_25375_25422[(2)] = inst_25328);

(statearr_25375_25422[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (2))){
var state_25353__$1 = state_25353;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_25353__$1,(4),ch);
} else {
if((state_val_25354 === (23))){
var state_25353__$1 = state_25353;
var statearr_25376_25423 = state_25353__$1;
(statearr_25376_25423[(2)] = null);

(statearr_25376_25423[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (19))){
var inst_25284 = (state_25353[(8)]);
var inst_25334 = (state_25353[(11)]);
var inst_25336 = cljs.core.async.muxch_STAR_(inst_25334);
var state_25353__$1 = state_25353;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25353__$1,(22),inst_25336,inst_25284);
} else {
if((state_val_25354 === (11))){
var inst_25308 = (state_25353[(10)]);
var inst_25294 = (state_25353[(13)]);
var inst_25308__$1 = cljs.core.seq(inst_25294);
var state_25353__$1 = (function (){var statearr_25377 = state_25353;
(statearr_25377[(10)] = inst_25308__$1);

return statearr_25377;
})();
if(inst_25308__$1){
var statearr_25378_25424 = state_25353__$1;
(statearr_25378_25424[(1)] = (13));

} else {
var statearr_25379_25425 = state_25353__$1;
(statearr_25379_25425[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (9))){
var inst_25330 = (state_25353[(2)]);
var state_25353__$1 = state_25353;
var statearr_25380_25426 = state_25353__$1;
(statearr_25380_25426[(2)] = inst_25330);

(statearr_25380_25426[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (5))){
var inst_25291 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults));
var inst_25292 = cljs.core.vals(inst_25291);
var inst_25293 = cljs.core.seq(inst_25292);
var inst_25294 = inst_25293;
var inst_25295 = null;
var inst_25296 = (0);
var inst_25297 = (0);
var state_25353__$1 = (function (){var statearr_25381 = state_25353;
(statearr_25381[(12)] = inst_25296);

(statearr_25381[(13)] = inst_25294);

(statearr_25381[(14)] = inst_25297);

(statearr_25381[(16)] = inst_25295);

return statearr_25381;
})();
var statearr_25382_25427 = state_25353__$1;
(statearr_25382_25427[(2)] = null);

(statearr_25382_25427[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (14))){
var state_25353__$1 = state_25353;
var statearr_25386_25428 = state_25353__$1;
(statearr_25386_25428[(2)] = null);

(statearr_25386_25428[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (16))){
var inst_25308 = (state_25353[(10)]);
var inst_25312 = cljs.core.chunk_first(inst_25308);
var inst_25313 = cljs.core.chunk_rest(inst_25308);
var inst_25314 = cljs.core.count(inst_25312);
var inst_25294 = inst_25313;
var inst_25295 = inst_25312;
var inst_25296 = inst_25314;
var inst_25297 = (0);
var state_25353__$1 = (function (){var statearr_25387 = state_25353;
(statearr_25387[(12)] = inst_25296);

(statearr_25387[(13)] = inst_25294);

(statearr_25387[(14)] = inst_25297);

(statearr_25387[(16)] = inst_25295);

return statearr_25387;
})();
var statearr_25388_25429 = state_25353__$1;
(statearr_25388_25429[(2)] = null);

(statearr_25388_25429[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (10))){
var inst_25296 = (state_25353[(12)]);
var inst_25294 = (state_25353[(13)]);
var inst_25297 = (state_25353[(14)]);
var inst_25295 = (state_25353[(16)]);
var inst_25302 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_25295,inst_25297);
var inst_25303 = cljs.core.async.muxch_STAR_(inst_25302);
var inst_25304 = cljs.core.async.close_BANG_(inst_25303);
var inst_25305 = (inst_25297 + (1));
var tmp25383 = inst_25296;
var tmp25384 = inst_25294;
var tmp25385 = inst_25295;
var inst_25294__$1 = tmp25384;
var inst_25295__$1 = tmp25385;
var inst_25296__$1 = tmp25383;
var inst_25297__$1 = inst_25305;
var state_25353__$1 = (function (){var statearr_25389 = state_25353;
(statearr_25389[(12)] = inst_25296__$1);

(statearr_25389[(13)] = inst_25294__$1);

(statearr_25389[(14)] = inst_25297__$1);

(statearr_25389[(17)] = inst_25304);

(statearr_25389[(16)] = inst_25295__$1);

return statearr_25389;
})();
var statearr_25390_25430 = state_25353__$1;
(statearr_25390_25430[(2)] = null);

(statearr_25390_25430[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (18))){
var inst_25323 = (state_25353[(2)]);
var state_25353__$1 = state_25353;
var statearr_25391_25431 = state_25353__$1;
(statearr_25391_25431[(2)] = inst_25323);

(statearr_25391_25431[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25354 === (8))){
var inst_25296 = (state_25353[(12)]);
var inst_25297 = (state_25353[(14)]);
var inst_25299 = (inst_25297 < inst_25296);
var inst_25300 = inst_25299;
var state_25353__$1 = state_25353;
if(cljs.core.truth_(inst_25300)){
var statearr_25392_25432 = state_25353__$1;
(statearr_25392_25432[(1)] = (10));

} else {
var statearr_25393_25433 = state_25353__$1;
(statearr_25393_25433[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___25405,mults,ensure_mult,p))
;
return ((function (switch__16649__auto__,c__16730__auto___25405,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_25397 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_25397[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_25397[(1)] = (1));

return statearr_25397;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_25353){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_25353);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e25398){if((e25398 instanceof Object)){
var ex__16653__auto__ = e25398;
var statearr_25399_25434 = state_25353;
(statearr_25399_25434[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_25353);

return cljs.core.cst$kw$recur;
} else {
throw e25398;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__25435 = state_25353;
state_25353 = G__25435;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_25353){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_25353);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___25405,mults,ensure_mult,p))
})();
var state__16732__auto__ = (function (){var statearr_25400 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_25400[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___25405);

return statearr_25400;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___25405,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;
/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args25436 = [];
var len__5570__auto___25439 = arguments.length;
var i__5571__auto___25440 = (0);
while(true){
if((i__5571__auto___25440 < len__5570__auto___25439)){
args25436.push((arguments[i__5571__auto___25440]));

var G__25441 = (i__5571__auto___25440 + (1));
i__5571__auto___25440 = G__25441;
continue;
} else {
}
break;
}

var G__25438 = args25436.length;
switch (G__25438) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25436.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;
/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args25443 = [];
var len__5570__auto___25446 = arguments.length;
var i__5571__auto___25447 = (0);
while(true){
if((i__5571__auto___25447 < len__5570__auto___25446)){
args25443.push((arguments[i__5571__auto___25447]));

var G__25448 = (i__5571__auto___25447 + (1));
i__5571__auto___25447 = G__25448;
continue;
} else {
}
break;
}

var G__25445 = args25443.length;
switch (G__25445) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25443.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1(p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2(p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;
/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args25450 = [];
var len__5570__auto___25521 = arguments.length;
var i__5571__auto___25522 = (0);
while(true){
if((i__5571__auto___25522 < len__5570__auto___25521)){
args25450.push((arguments[i__5571__auto___25522]));

var G__25523 = (i__5571__auto___25522 + (1));
i__5571__auto___25522 = G__25523;
continue;
} else {
}
break;
}

var G__25452 = args25450.length;
switch (G__25452) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25450.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null) : cljs.core.atom.call(null,null));
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
var c__16730__auto___25525 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___25525,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___25525,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_25491){
var state_val_25492 = (state_25491[(1)]);
if((state_val_25492 === (7))){
var state_25491__$1 = state_25491;
var statearr_25493_25526 = state_25491__$1;
(statearr_25493_25526[(2)] = null);

(statearr_25493_25526[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (1))){
var state_25491__$1 = state_25491;
var statearr_25494_25527 = state_25491__$1;
(statearr_25494_25527[(2)] = null);

(statearr_25494_25527[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (4))){
var inst_25455 = (state_25491[(7)]);
var inst_25457 = (inst_25455 < cnt);
var state_25491__$1 = state_25491;
if(cljs.core.truth_(inst_25457)){
var statearr_25495_25528 = state_25491__$1;
(statearr_25495_25528[(1)] = (6));

} else {
var statearr_25496_25529 = state_25491__$1;
(statearr_25496_25529[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (15))){
var inst_25487 = (state_25491[(2)]);
var state_25491__$1 = state_25491;
var statearr_25497_25530 = state_25491__$1;
(statearr_25497_25530[(2)] = inst_25487);

(statearr_25497_25530[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (13))){
var inst_25480 = cljs.core.async.close_BANG_(out);
var state_25491__$1 = state_25491;
var statearr_25498_25531 = state_25491__$1;
(statearr_25498_25531[(2)] = inst_25480);

(statearr_25498_25531[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (6))){
var state_25491__$1 = state_25491;
var statearr_25499_25532 = state_25491__$1;
(statearr_25499_25532[(2)] = null);

(statearr_25499_25532[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (3))){
var inst_25489 = (state_25491[(2)]);
var state_25491__$1 = state_25491;
return cljs.core.async.impl.ioc_helpers.return_chan(state_25491__$1,inst_25489);
} else {
if((state_val_25492 === (12))){
var inst_25477 = (state_25491[(8)]);
var inst_25477__$1 = (state_25491[(2)]);
var inst_25478 = cljs.core.some(cljs.core.nil_QMARK_,inst_25477__$1);
var state_25491__$1 = (function (){var statearr_25500 = state_25491;
(statearr_25500[(8)] = inst_25477__$1);

return statearr_25500;
})();
if(cljs.core.truth_(inst_25478)){
var statearr_25501_25533 = state_25491__$1;
(statearr_25501_25533[(1)] = (13));

} else {
var statearr_25502_25534 = state_25491__$1;
(statearr_25502_25534[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (2))){
var inst_25454 = (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cnt) : cljs.core.reset_BANG_.call(null,dctr,cnt));
var inst_25455 = (0);
var state_25491__$1 = (function (){var statearr_25503 = state_25491;
(statearr_25503[(9)] = inst_25454);

(statearr_25503[(7)] = inst_25455);

return statearr_25503;
})();
var statearr_25504_25535 = state_25491__$1;
(statearr_25504_25535[(2)] = null);

(statearr_25504_25535[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (11))){
var inst_25455 = (state_25491[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_25491,(10),Object,null,(9));
var inst_25464 = (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(inst_25455) : chs__$1.call(null,inst_25455));
var inst_25465 = (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(inst_25455) : done.call(null,inst_25455));
var inst_25466 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_25464,inst_25465);
var state_25491__$1 = state_25491;
var statearr_25505_25536 = state_25491__$1;
(statearr_25505_25536[(2)] = inst_25466);


cljs.core.async.impl.ioc_helpers.process_exception(state_25491__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (9))){
var inst_25455 = (state_25491[(7)]);
var inst_25468 = (state_25491[(2)]);
var inst_25469 = (inst_25455 + (1));
var inst_25455__$1 = inst_25469;
var state_25491__$1 = (function (){var statearr_25506 = state_25491;
(statearr_25506[(7)] = inst_25455__$1);

(statearr_25506[(10)] = inst_25468);

return statearr_25506;
})();
var statearr_25507_25537 = state_25491__$1;
(statearr_25507_25537[(2)] = null);

(statearr_25507_25537[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (5))){
var inst_25475 = (state_25491[(2)]);
var state_25491__$1 = (function (){var statearr_25508 = state_25491;
(statearr_25508[(11)] = inst_25475);

return statearr_25508;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_25491__$1,(12),dchan);
} else {
if((state_val_25492 === (14))){
var inst_25477 = (state_25491[(8)]);
var inst_25482 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_25477);
var state_25491__$1 = state_25491;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25491__$1,(16),out,inst_25482);
} else {
if((state_val_25492 === (16))){
var inst_25484 = (state_25491[(2)]);
var state_25491__$1 = (function (){var statearr_25509 = state_25491;
(statearr_25509[(12)] = inst_25484);

return statearr_25509;
})();
var statearr_25510_25538 = state_25491__$1;
(statearr_25510_25538[(2)] = null);

(statearr_25510_25538[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (10))){
var inst_25459 = (state_25491[(2)]);
var inst_25460 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_25491__$1 = (function (){var statearr_25511 = state_25491;
(statearr_25511[(13)] = inst_25459);

return statearr_25511;
})();
var statearr_25512_25539 = state_25491__$1;
(statearr_25512_25539[(2)] = inst_25460);


cljs.core.async.impl.ioc_helpers.process_exception(state_25491__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_25492 === (8))){
var inst_25473 = (state_25491[(2)]);
var state_25491__$1 = state_25491;
var statearr_25513_25540 = state_25491__$1;
(statearr_25513_25540[(2)] = inst_25473);

(statearr_25513_25540[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___25525,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__16649__auto__,c__16730__auto___25525,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_25517 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_25517[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_25517[(1)] = (1));

return statearr_25517;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_25491){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_25491);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e25518){if((e25518 instanceof Object)){
var ex__16653__auto__ = e25518;
var statearr_25519_25541 = state_25491;
(statearr_25519_25541[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_25491);

return cljs.core.cst$kw$recur;
} else {
throw e25518;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__25542 = state_25491;
state_25491 = G__25542;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_25491){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_25491);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___25525,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__16732__auto__ = (function (){var statearr_25520 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_25520[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___25525);

return statearr_25520;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___25525,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;
/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args25544 = [];
var len__5570__auto___25600 = arguments.length;
var i__5571__auto___25601 = (0);
while(true){
if((i__5571__auto___25601 < len__5570__auto___25600)){
args25544.push((arguments[i__5571__auto___25601]));

var G__25602 = (i__5571__auto___25601 + (1));
i__5571__auto___25601 = G__25602;
continue;
} else {
}
break;
}

var G__25546 = args25544.length;
switch (G__25546) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25544.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__16730__auto___25604 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___25604,out){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___25604,out){
return (function (state_25576){
var state_val_25577 = (state_25576[(1)]);
if((state_val_25577 === (7))){
var inst_25555 = (state_25576[(7)]);
var inst_25556 = (state_25576[(8)]);
var inst_25555__$1 = (state_25576[(2)]);
var inst_25556__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_25555__$1,(0),null);
var inst_25557 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_25555__$1,(1),null);
var inst_25558 = (inst_25556__$1 == null);
var state_25576__$1 = (function (){var statearr_25578 = state_25576;
(statearr_25578[(7)] = inst_25555__$1);

(statearr_25578[(9)] = inst_25557);

(statearr_25578[(8)] = inst_25556__$1);

return statearr_25578;
})();
if(cljs.core.truth_(inst_25558)){
var statearr_25579_25605 = state_25576__$1;
(statearr_25579_25605[(1)] = (8));

} else {
var statearr_25580_25606 = state_25576__$1;
(statearr_25580_25606[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25577 === (1))){
var inst_25547 = cljs.core.vec(chs);
var inst_25548 = inst_25547;
var state_25576__$1 = (function (){var statearr_25581 = state_25576;
(statearr_25581[(10)] = inst_25548);

return statearr_25581;
})();
var statearr_25582_25607 = state_25576__$1;
(statearr_25582_25607[(2)] = null);

(statearr_25582_25607[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25577 === (4))){
var inst_25548 = (state_25576[(10)]);
var state_25576__$1 = state_25576;
return cljs.core.async.impl.ioc_helpers.ioc_alts_BANG_(state_25576__$1,(7),inst_25548);
} else {
if((state_val_25577 === (6))){
var inst_25572 = (state_25576[(2)]);
var state_25576__$1 = state_25576;
var statearr_25583_25608 = state_25576__$1;
(statearr_25583_25608[(2)] = inst_25572);

(statearr_25583_25608[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25577 === (3))){
var inst_25574 = (state_25576[(2)]);
var state_25576__$1 = state_25576;
return cljs.core.async.impl.ioc_helpers.return_chan(state_25576__$1,inst_25574);
} else {
if((state_val_25577 === (2))){
var inst_25548 = (state_25576[(10)]);
var inst_25550 = cljs.core.count(inst_25548);
var inst_25551 = (inst_25550 > (0));
var state_25576__$1 = state_25576;
if(cljs.core.truth_(inst_25551)){
var statearr_25585_25609 = state_25576__$1;
(statearr_25585_25609[(1)] = (4));

} else {
var statearr_25586_25610 = state_25576__$1;
(statearr_25586_25610[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25577 === (11))){
var inst_25548 = (state_25576[(10)]);
var inst_25565 = (state_25576[(2)]);
var tmp25584 = inst_25548;
var inst_25548__$1 = tmp25584;
var state_25576__$1 = (function (){var statearr_25587 = state_25576;
(statearr_25587[(11)] = inst_25565);

(statearr_25587[(10)] = inst_25548__$1);

return statearr_25587;
})();
var statearr_25588_25611 = state_25576__$1;
(statearr_25588_25611[(2)] = null);

(statearr_25588_25611[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25577 === (9))){
var inst_25556 = (state_25576[(8)]);
var state_25576__$1 = state_25576;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25576__$1,(11),out,inst_25556);
} else {
if((state_val_25577 === (5))){
var inst_25570 = cljs.core.async.close_BANG_(out);
var state_25576__$1 = state_25576;
var statearr_25589_25612 = state_25576__$1;
(statearr_25589_25612[(2)] = inst_25570);

(statearr_25589_25612[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25577 === (10))){
var inst_25568 = (state_25576[(2)]);
var state_25576__$1 = state_25576;
var statearr_25590_25613 = state_25576__$1;
(statearr_25590_25613[(2)] = inst_25568);

(statearr_25590_25613[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25577 === (8))){
var inst_25555 = (state_25576[(7)]);
var inst_25557 = (state_25576[(9)]);
var inst_25548 = (state_25576[(10)]);
var inst_25556 = (state_25576[(8)]);
var inst_25560 = (function (){var cs = inst_25548;
var vec__25553 = inst_25555;
var v = inst_25556;
var c = inst_25557;
return ((function (cs,vec__25553,v,c,inst_25555,inst_25557,inst_25548,inst_25556,state_val_25577,c__16730__auto___25604,out){
return (function (p1__25543_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__25543_SHARP_);
});
;})(cs,vec__25553,v,c,inst_25555,inst_25557,inst_25548,inst_25556,state_val_25577,c__16730__auto___25604,out))
})();
var inst_25561 = cljs.core.filterv(inst_25560,inst_25548);
var inst_25548__$1 = inst_25561;
var state_25576__$1 = (function (){var statearr_25591 = state_25576;
(statearr_25591[(10)] = inst_25548__$1);

return statearr_25591;
})();
var statearr_25592_25614 = state_25576__$1;
(statearr_25592_25614[(2)] = null);

(statearr_25592_25614[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___25604,out))
;
return ((function (switch__16649__auto__,c__16730__auto___25604,out){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_25596 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_25596[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_25596[(1)] = (1));

return statearr_25596;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_25576){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_25576);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e25597){if((e25597 instanceof Object)){
var ex__16653__auto__ = e25597;
var statearr_25598_25615 = state_25576;
(statearr_25598_25615[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_25576);

return cljs.core.cst$kw$recur;
} else {
throw e25597;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__25616 = state_25576;
state_25576 = G__25616;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_25576){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_25576);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___25604,out))
})();
var state__16732__auto__ = (function (){var statearr_25599 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_25599[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___25604);

return statearr_25599;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___25604,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args25617 = [];
var len__5570__auto___25666 = arguments.length;
var i__5571__auto___25667 = (0);
while(true){
if((i__5571__auto___25667 < len__5570__auto___25666)){
args25617.push((arguments[i__5571__auto___25667]));

var G__25668 = (i__5571__auto___25667 + (1));
i__5571__auto___25667 = G__25668;
continue;
} else {
}
break;
}

var G__25619 = args25617.length;
switch (G__25619) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25617.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__16730__auto___25670 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___25670,out){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___25670,out){
return (function (state_25643){
var state_val_25644 = (state_25643[(1)]);
if((state_val_25644 === (7))){
var inst_25625 = (state_25643[(7)]);
var inst_25625__$1 = (state_25643[(2)]);
var inst_25626 = (inst_25625__$1 == null);
var inst_25627 = cljs.core.not(inst_25626);
var state_25643__$1 = (function (){var statearr_25645 = state_25643;
(statearr_25645[(7)] = inst_25625__$1);

return statearr_25645;
})();
if(inst_25627){
var statearr_25646_25671 = state_25643__$1;
(statearr_25646_25671[(1)] = (8));

} else {
var statearr_25647_25672 = state_25643__$1;
(statearr_25647_25672[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25644 === (1))){
var inst_25620 = (0);
var state_25643__$1 = (function (){var statearr_25648 = state_25643;
(statearr_25648[(8)] = inst_25620);

return statearr_25648;
})();
var statearr_25649_25673 = state_25643__$1;
(statearr_25649_25673[(2)] = null);

(statearr_25649_25673[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25644 === (4))){
var state_25643__$1 = state_25643;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_25643__$1,(7),ch);
} else {
if((state_val_25644 === (6))){
var inst_25638 = (state_25643[(2)]);
var state_25643__$1 = state_25643;
var statearr_25650_25674 = state_25643__$1;
(statearr_25650_25674[(2)] = inst_25638);

(statearr_25650_25674[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25644 === (3))){
var inst_25640 = (state_25643[(2)]);
var inst_25641 = cljs.core.async.close_BANG_(out);
var state_25643__$1 = (function (){var statearr_25651 = state_25643;
(statearr_25651[(9)] = inst_25640);

return statearr_25651;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_25643__$1,inst_25641);
} else {
if((state_val_25644 === (2))){
var inst_25620 = (state_25643[(8)]);
var inst_25622 = (inst_25620 < n);
var state_25643__$1 = state_25643;
if(cljs.core.truth_(inst_25622)){
var statearr_25652_25675 = state_25643__$1;
(statearr_25652_25675[(1)] = (4));

} else {
var statearr_25653_25676 = state_25643__$1;
(statearr_25653_25676[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25644 === (11))){
var inst_25620 = (state_25643[(8)]);
var inst_25630 = (state_25643[(2)]);
var inst_25631 = (inst_25620 + (1));
var inst_25620__$1 = inst_25631;
var state_25643__$1 = (function (){var statearr_25654 = state_25643;
(statearr_25654[(8)] = inst_25620__$1);

(statearr_25654[(10)] = inst_25630);

return statearr_25654;
})();
var statearr_25655_25677 = state_25643__$1;
(statearr_25655_25677[(2)] = null);

(statearr_25655_25677[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25644 === (9))){
var state_25643__$1 = state_25643;
var statearr_25656_25678 = state_25643__$1;
(statearr_25656_25678[(2)] = null);

(statearr_25656_25678[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25644 === (5))){
var state_25643__$1 = state_25643;
var statearr_25657_25679 = state_25643__$1;
(statearr_25657_25679[(2)] = null);

(statearr_25657_25679[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25644 === (10))){
var inst_25635 = (state_25643[(2)]);
var state_25643__$1 = state_25643;
var statearr_25658_25680 = state_25643__$1;
(statearr_25658_25680[(2)] = inst_25635);

(statearr_25658_25680[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25644 === (8))){
var inst_25625 = (state_25643[(7)]);
var state_25643__$1 = state_25643;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25643__$1,(11),out,inst_25625);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___25670,out))
;
return ((function (switch__16649__auto__,c__16730__auto___25670,out){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_25662 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_25662[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_25662[(1)] = (1));

return statearr_25662;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_25643){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_25643);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e25663){if((e25663 instanceof Object)){
var ex__16653__auto__ = e25663;
var statearr_25664_25681 = state_25643;
(statearr_25664_25681[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_25643);

return cljs.core.cst$kw$recur;
} else {
throw e25663;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__25682 = state_25643;
state_25643 = G__25682;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_25643){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_25643);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___25670,out))
})();
var state__16732__auto__ = (function (){var statearr_25665 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_25665[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___25670);

return statearr_25665;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___25670,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;
/**
 * Returns a channel that will contain values from ch. Consecutive duplicate
 * values will be dropped.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args25683 = [];
var len__5570__auto___25734 = arguments.length;
var i__5571__auto___25735 = (0);
while(true){
if((i__5571__auto___25735 < len__5570__auto___25734)){
args25683.push((arguments[i__5571__auto___25735]));

var G__25736 = (i__5571__auto___25735 + (1));
i__5571__auto___25735 = G__25736;
continue;
} else {
}
break;
}

var G__25685 = args25683.length;
switch (G__25685) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25683.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__16730__auto___25738 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___25738,out){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___25738,out){
return (function (state_25709){
var state_val_25710 = (state_25709[(1)]);
if((state_val_25710 === (7))){
var inst_25704 = (state_25709[(2)]);
var state_25709__$1 = state_25709;
var statearr_25711_25739 = state_25709__$1;
(statearr_25711_25739[(2)] = inst_25704);

(statearr_25711_25739[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25710 === (1))){
var inst_25686 = null;
var state_25709__$1 = (function (){var statearr_25712 = state_25709;
(statearr_25712[(7)] = inst_25686);

return statearr_25712;
})();
var statearr_25713_25740 = state_25709__$1;
(statearr_25713_25740[(2)] = null);

(statearr_25713_25740[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25710 === (4))){
var inst_25689 = (state_25709[(8)]);
var inst_25689__$1 = (state_25709[(2)]);
var inst_25690 = (inst_25689__$1 == null);
var inst_25691 = cljs.core.not(inst_25690);
var state_25709__$1 = (function (){var statearr_25714 = state_25709;
(statearr_25714[(8)] = inst_25689__$1);

return statearr_25714;
})();
if(inst_25691){
var statearr_25715_25741 = state_25709__$1;
(statearr_25715_25741[(1)] = (5));

} else {
var statearr_25716_25742 = state_25709__$1;
(statearr_25716_25742[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25710 === (6))){
var state_25709__$1 = state_25709;
var statearr_25717_25743 = state_25709__$1;
(statearr_25717_25743[(2)] = null);

(statearr_25717_25743[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25710 === (3))){
var inst_25706 = (state_25709[(2)]);
var inst_25707 = cljs.core.async.close_BANG_(out);
var state_25709__$1 = (function (){var statearr_25718 = state_25709;
(statearr_25718[(9)] = inst_25706);

return statearr_25718;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_25709__$1,inst_25707);
} else {
if((state_val_25710 === (2))){
var state_25709__$1 = state_25709;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_25709__$1,(4),ch);
} else {
if((state_val_25710 === (11))){
var inst_25689 = (state_25709[(8)]);
var inst_25698 = (state_25709[(2)]);
var inst_25686 = inst_25689;
var state_25709__$1 = (function (){var statearr_25719 = state_25709;
(statearr_25719[(7)] = inst_25686);

(statearr_25719[(10)] = inst_25698);

return statearr_25719;
})();
var statearr_25720_25744 = state_25709__$1;
(statearr_25720_25744[(2)] = null);

(statearr_25720_25744[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25710 === (9))){
var inst_25689 = (state_25709[(8)]);
var state_25709__$1 = state_25709;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25709__$1,(11),out,inst_25689);
} else {
if((state_val_25710 === (5))){
var inst_25686 = (state_25709[(7)]);
var inst_25689 = (state_25709[(8)]);
var inst_25693 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_25689,inst_25686);
var state_25709__$1 = state_25709;
if(inst_25693){
var statearr_25722_25745 = state_25709__$1;
(statearr_25722_25745[(1)] = (8));

} else {
var statearr_25723_25746 = state_25709__$1;
(statearr_25723_25746[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25710 === (10))){
var inst_25701 = (state_25709[(2)]);
var state_25709__$1 = state_25709;
var statearr_25724_25747 = state_25709__$1;
(statearr_25724_25747[(2)] = inst_25701);

(statearr_25724_25747[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25710 === (8))){
var inst_25686 = (state_25709[(7)]);
var tmp25721 = inst_25686;
var inst_25686__$1 = tmp25721;
var state_25709__$1 = (function (){var statearr_25725 = state_25709;
(statearr_25725[(7)] = inst_25686__$1);

return statearr_25725;
})();
var statearr_25726_25748 = state_25709__$1;
(statearr_25726_25748[(2)] = null);

(statearr_25726_25748[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___25738,out))
;
return ((function (switch__16649__auto__,c__16730__auto___25738,out){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_25730 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_25730[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_25730[(1)] = (1));

return statearr_25730;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_25709){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_25709);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e25731){if((e25731 instanceof Object)){
var ex__16653__auto__ = e25731;
var statearr_25732_25749 = state_25709;
(statearr_25732_25749[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_25709);

return cljs.core.cst$kw$recur;
} else {
throw e25731;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__25750 = state_25709;
state_25709 = G__25750;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_25709){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_25709);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___25738,out))
})();
var state__16732__auto__ = (function (){var statearr_25733 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_25733[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___25738);

return statearr_25733;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___25738,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel that will contain vectors of n items taken from ch. The
 * final vector in the return channel may be smaller than n if ch closed before
 * the vector could be completely filled.
 * 
 * The output channel is unbuffered by default, unless buf-or-n is given
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args25751 = [];
var len__5570__auto___25821 = arguments.length;
var i__5571__auto___25822 = (0);
while(true){
if((i__5571__auto___25822 < len__5570__auto___25821)){
args25751.push((arguments[i__5571__auto___25822]));

var G__25823 = (i__5571__auto___25822 + (1));
i__5571__auto___25822 = G__25823;
continue;
} else {
}
break;
}

var G__25753 = args25751.length;
switch (G__25753) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25751.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__16730__auto___25825 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___25825,out){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___25825,out){
return (function (state_25791){
var state_val_25792 = (state_25791[(1)]);
if((state_val_25792 === (7))){
var inst_25787 = (state_25791[(2)]);
var state_25791__$1 = state_25791;
var statearr_25793_25826 = state_25791__$1;
(statearr_25793_25826[(2)] = inst_25787);

(statearr_25793_25826[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (1))){
var inst_25754 = (new Array(n));
var inst_25755 = inst_25754;
var inst_25756 = (0);
var state_25791__$1 = (function (){var statearr_25794 = state_25791;
(statearr_25794[(7)] = inst_25756);

(statearr_25794[(8)] = inst_25755);

return statearr_25794;
})();
var statearr_25795_25827 = state_25791__$1;
(statearr_25795_25827[(2)] = null);

(statearr_25795_25827[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (4))){
var inst_25759 = (state_25791[(9)]);
var inst_25759__$1 = (state_25791[(2)]);
var inst_25760 = (inst_25759__$1 == null);
var inst_25761 = cljs.core.not(inst_25760);
var state_25791__$1 = (function (){var statearr_25796 = state_25791;
(statearr_25796[(9)] = inst_25759__$1);

return statearr_25796;
})();
if(inst_25761){
var statearr_25797_25828 = state_25791__$1;
(statearr_25797_25828[(1)] = (5));

} else {
var statearr_25798_25829 = state_25791__$1;
(statearr_25798_25829[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (15))){
var inst_25781 = (state_25791[(2)]);
var state_25791__$1 = state_25791;
var statearr_25799_25830 = state_25791__$1;
(statearr_25799_25830[(2)] = inst_25781);

(statearr_25799_25830[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (13))){
var state_25791__$1 = state_25791;
var statearr_25800_25831 = state_25791__$1;
(statearr_25800_25831[(2)] = null);

(statearr_25800_25831[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (6))){
var inst_25756 = (state_25791[(7)]);
var inst_25777 = (inst_25756 > (0));
var state_25791__$1 = state_25791;
if(cljs.core.truth_(inst_25777)){
var statearr_25801_25832 = state_25791__$1;
(statearr_25801_25832[(1)] = (12));

} else {
var statearr_25802_25833 = state_25791__$1;
(statearr_25802_25833[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (3))){
var inst_25789 = (state_25791[(2)]);
var state_25791__$1 = state_25791;
return cljs.core.async.impl.ioc_helpers.return_chan(state_25791__$1,inst_25789);
} else {
if((state_val_25792 === (12))){
var inst_25755 = (state_25791[(8)]);
var inst_25779 = cljs.core.vec(inst_25755);
var state_25791__$1 = state_25791;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25791__$1,(15),out,inst_25779);
} else {
if((state_val_25792 === (2))){
var state_25791__$1 = state_25791;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_25791__$1,(4),ch);
} else {
if((state_val_25792 === (11))){
var inst_25771 = (state_25791[(2)]);
var inst_25772 = (new Array(n));
var inst_25755 = inst_25772;
var inst_25756 = (0);
var state_25791__$1 = (function (){var statearr_25803 = state_25791;
(statearr_25803[(7)] = inst_25756);

(statearr_25803[(8)] = inst_25755);

(statearr_25803[(10)] = inst_25771);

return statearr_25803;
})();
var statearr_25804_25834 = state_25791__$1;
(statearr_25804_25834[(2)] = null);

(statearr_25804_25834[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (9))){
var inst_25755 = (state_25791[(8)]);
var inst_25769 = cljs.core.vec(inst_25755);
var state_25791__$1 = state_25791;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25791__$1,(11),out,inst_25769);
} else {
if((state_val_25792 === (5))){
var inst_25756 = (state_25791[(7)]);
var inst_25755 = (state_25791[(8)]);
var inst_25759 = (state_25791[(9)]);
var inst_25764 = (state_25791[(11)]);
var inst_25763 = (inst_25755[inst_25756] = inst_25759);
var inst_25764__$1 = (inst_25756 + (1));
var inst_25765 = (inst_25764__$1 < n);
var state_25791__$1 = (function (){var statearr_25805 = state_25791;
(statearr_25805[(11)] = inst_25764__$1);

(statearr_25805[(12)] = inst_25763);

return statearr_25805;
})();
if(cljs.core.truth_(inst_25765)){
var statearr_25806_25835 = state_25791__$1;
(statearr_25806_25835[(1)] = (8));

} else {
var statearr_25807_25836 = state_25791__$1;
(statearr_25807_25836[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (14))){
var inst_25784 = (state_25791[(2)]);
var inst_25785 = cljs.core.async.close_BANG_(out);
var state_25791__$1 = (function (){var statearr_25809 = state_25791;
(statearr_25809[(13)] = inst_25784);

return statearr_25809;
})();
var statearr_25810_25837 = state_25791__$1;
(statearr_25810_25837[(2)] = inst_25785);

(statearr_25810_25837[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (10))){
var inst_25775 = (state_25791[(2)]);
var state_25791__$1 = state_25791;
var statearr_25811_25838 = state_25791__$1;
(statearr_25811_25838[(2)] = inst_25775);

(statearr_25811_25838[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25792 === (8))){
var inst_25755 = (state_25791[(8)]);
var inst_25764 = (state_25791[(11)]);
var tmp25808 = inst_25755;
var inst_25755__$1 = tmp25808;
var inst_25756 = inst_25764;
var state_25791__$1 = (function (){var statearr_25812 = state_25791;
(statearr_25812[(7)] = inst_25756);

(statearr_25812[(8)] = inst_25755__$1);

return statearr_25812;
})();
var statearr_25813_25839 = state_25791__$1;
(statearr_25813_25839[(2)] = null);

(statearr_25813_25839[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___25825,out))
;
return ((function (switch__16649__auto__,c__16730__auto___25825,out){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_25817 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_25817[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_25817[(1)] = (1));

return statearr_25817;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_25791){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_25791);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e25818){if((e25818 instanceof Object)){
var ex__16653__auto__ = e25818;
var statearr_25819_25840 = state_25791;
(statearr_25819_25840[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_25791);

return cljs.core.cst$kw$recur;
} else {
throw e25818;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__25841 = state_25791;
state_25791 = G__25841;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_25791){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_25791);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___25825,out))
})();
var state__16732__auto__ = (function (){var statearr_25820 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_25820[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___25825);

return statearr_25820;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___25825,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;
/**
 * Returns a channel that will contain vectors of items taken from ch. New
 * vectors will be created whenever (f itm) returns a value that differs from
 * the previous item's (f itm).
 * 
 *   The output channel is unbuffered, unless buf-or-n is given
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args25842 = [];
var len__5570__auto___25916 = arguments.length;
var i__5571__auto___25917 = (0);
while(true){
if((i__5571__auto___25917 < len__5570__auto___25916)){
args25842.push((arguments[i__5571__auto___25917]));

var G__25918 = (i__5571__auto___25917 + (1));
i__5571__auto___25917 = G__25918;
continue;
} else {
}
break;
}

var G__25844 = args25842.length;
switch (G__25844) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args25842.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__16730__auto___25920 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__16730__auto___25920,out){
return (function (){
var f__16731__auto__ = (function (){var switch__16649__auto__ = ((function (c__16730__auto___25920,out){
return (function (state_25886){
var state_val_25887 = (state_25886[(1)]);
if((state_val_25887 === (7))){
var inst_25882 = (state_25886[(2)]);
var state_25886__$1 = state_25886;
var statearr_25888_25921 = state_25886__$1;
(statearr_25888_25921[(2)] = inst_25882);

(statearr_25888_25921[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (1))){
var inst_25845 = [];
var inst_25846 = inst_25845;
var inst_25847 = cljs.core.cst$kw$cljs$core$async_SLASH_nothing;
var state_25886__$1 = (function (){var statearr_25889 = state_25886;
(statearr_25889[(7)] = inst_25847);

(statearr_25889[(8)] = inst_25846);

return statearr_25889;
})();
var statearr_25890_25922 = state_25886__$1;
(statearr_25890_25922[(2)] = null);

(statearr_25890_25922[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (4))){
var inst_25850 = (state_25886[(9)]);
var inst_25850__$1 = (state_25886[(2)]);
var inst_25851 = (inst_25850__$1 == null);
var inst_25852 = cljs.core.not(inst_25851);
var state_25886__$1 = (function (){var statearr_25891 = state_25886;
(statearr_25891[(9)] = inst_25850__$1);

return statearr_25891;
})();
if(inst_25852){
var statearr_25892_25923 = state_25886__$1;
(statearr_25892_25923[(1)] = (5));

} else {
var statearr_25893_25924 = state_25886__$1;
(statearr_25893_25924[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (15))){
var inst_25876 = (state_25886[(2)]);
var state_25886__$1 = state_25886;
var statearr_25894_25925 = state_25886__$1;
(statearr_25894_25925[(2)] = inst_25876);

(statearr_25894_25925[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (13))){
var state_25886__$1 = state_25886;
var statearr_25895_25926 = state_25886__$1;
(statearr_25895_25926[(2)] = null);

(statearr_25895_25926[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (6))){
var inst_25846 = (state_25886[(8)]);
var inst_25871 = inst_25846.length;
var inst_25872 = (inst_25871 > (0));
var state_25886__$1 = state_25886;
if(cljs.core.truth_(inst_25872)){
var statearr_25896_25927 = state_25886__$1;
(statearr_25896_25927[(1)] = (12));

} else {
var statearr_25897_25928 = state_25886__$1;
(statearr_25897_25928[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (3))){
var inst_25884 = (state_25886[(2)]);
var state_25886__$1 = state_25886;
return cljs.core.async.impl.ioc_helpers.return_chan(state_25886__$1,inst_25884);
} else {
if((state_val_25887 === (12))){
var inst_25846 = (state_25886[(8)]);
var inst_25874 = cljs.core.vec(inst_25846);
var state_25886__$1 = state_25886;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25886__$1,(15),out,inst_25874);
} else {
if((state_val_25887 === (2))){
var state_25886__$1 = state_25886;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_25886__$1,(4),ch);
} else {
if((state_val_25887 === (11))){
var inst_25850 = (state_25886[(9)]);
var inst_25854 = (state_25886[(10)]);
var inst_25864 = (state_25886[(2)]);
var inst_25865 = [];
var inst_25866 = inst_25865.push(inst_25850);
var inst_25846 = inst_25865;
var inst_25847 = inst_25854;
var state_25886__$1 = (function (){var statearr_25898 = state_25886;
(statearr_25898[(11)] = inst_25866);

(statearr_25898[(7)] = inst_25847);

(statearr_25898[(8)] = inst_25846);

(statearr_25898[(12)] = inst_25864);

return statearr_25898;
})();
var statearr_25899_25929 = state_25886__$1;
(statearr_25899_25929[(2)] = null);

(statearr_25899_25929[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (9))){
var inst_25846 = (state_25886[(8)]);
var inst_25862 = cljs.core.vec(inst_25846);
var state_25886__$1 = state_25886;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_25886__$1,(11),out,inst_25862);
} else {
if((state_val_25887 === (5))){
var inst_25847 = (state_25886[(7)]);
var inst_25850 = (state_25886[(9)]);
var inst_25854 = (state_25886[(10)]);
var inst_25854__$1 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_25850) : f.call(null,inst_25850));
var inst_25855 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_25854__$1,inst_25847);
var inst_25856 = cljs.core.keyword_identical_QMARK_(inst_25847,cljs.core.cst$kw$cljs$core$async_SLASH_nothing);
var inst_25857 = (inst_25855) || (inst_25856);
var state_25886__$1 = (function (){var statearr_25900 = state_25886;
(statearr_25900[(10)] = inst_25854__$1);

return statearr_25900;
})();
if(cljs.core.truth_(inst_25857)){
var statearr_25901_25930 = state_25886__$1;
(statearr_25901_25930[(1)] = (8));

} else {
var statearr_25902_25931 = state_25886__$1;
(statearr_25902_25931[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (14))){
var inst_25879 = (state_25886[(2)]);
var inst_25880 = cljs.core.async.close_BANG_(out);
var state_25886__$1 = (function (){var statearr_25904 = state_25886;
(statearr_25904[(13)] = inst_25879);

return statearr_25904;
})();
var statearr_25905_25932 = state_25886__$1;
(statearr_25905_25932[(2)] = inst_25880);

(statearr_25905_25932[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (10))){
var inst_25869 = (state_25886[(2)]);
var state_25886__$1 = state_25886;
var statearr_25906_25933 = state_25886__$1;
(statearr_25906_25933[(2)] = inst_25869);

(statearr_25906_25933[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_25887 === (8))){
var inst_25846 = (state_25886[(8)]);
var inst_25850 = (state_25886[(9)]);
var inst_25854 = (state_25886[(10)]);
var inst_25859 = inst_25846.push(inst_25850);
var tmp25903 = inst_25846;
var inst_25846__$1 = tmp25903;
var inst_25847 = inst_25854;
var state_25886__$1 = (function (){var statearr_25907 = state_25886;
(statearr_25907[(14)] = inst_25859);

(statearr_25907[(7)] = inst_25847);

(statearr_25907[(8)] = inst_25846__$1);

return statearr_25907;
})();
var statearr_25908_25934 = state_25886__$1;
(statearr_25908_25934[(2)] = null);

(statearr_25908_25934[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__16730__auto___25920,out))
;
return ((function (switch__16649__auto__,c__16730__auto___25920,out){
return (function() {
var cljs$core$async$state_machine__16650__auto__ = null;
var cljs$core$async$state_machine__16650__auto____0 = (function (){
var statearr_25912 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_25912[(0)] = cljs$core$async$state_machine__16650__auto__);

(statearr_25912[(1)] = (1));

return statearr_25912;
});
var cljs$core$async$state_machine__16650__auto____1 = (function (state_25886){
while(true){
var ret_value__16651__auto__ = (function (){try{while(true){
var result__16652__auto__ = switch__16649__auto__(state_25886);
if(cljs.core.keyword_identical_QMARK_(result__16652__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__16652__auto__;
}
break;
}
}catch (e25913){if((e25913 instanceof Object)){
var ex__16653__auto__ = e25913;
var statearr_25914_25935 = state_25886;
(statearr_25914_25935[(5)] = ex__16653__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_25886);

return cljs.core.cst$kw$recur;
} else {
throw e25913;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__16651__auto__,cljs.core.cst$kw$recur)){
var G__25936 = state_25886;
state_25886 = G__25936;
continue;
} else {
return ret_value__16651__auto__;
}
break;
}
});
cljs$core$async$state_machine__16650__auto__ = function(state_25886){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__16650__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__16650__auto____1.call(this,state_25886);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__16650__auto____0;
cljs$core$async$state_machine__16650__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__16650__auto____1;
return cljs$core$async$state_machine__16650__auto__;
})()
;})(switch__16649__auto__,c__16730__auto___25920,out))
})();
var state__16732__auto__ = (function (){var statearr_25915 = (f__16731__auto__.cljs$core$IFn$_invoke$arity$0 ? f__16731__auto__.cljs$core$IFn$_invoke$arity$0() : f__16731__auto__.call(null));
(statearr_25915[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__16730__auto___25920);

return statearr_25915;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__16732__auto__);
});})(c__16730__auto___25920,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;
